Option Strict Off
Option Explicit On
Friend Class frmAnalyze
    Inherits System.Windows.Forms.Form
    'Carries out analysis of databases and other development functions
    'Disabled in the release version 
	
    Dim blnCancelled As Boolean
    Private Sub cmdCancel_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdCancel.Click
        'Cancel and close the window
        strMsgBox = strTexts(intAnalyzeBase + 13 * intNLanguages + intLanguage)
        MyMsgBox.ShowDialog()
        If MyMsgBox.DialogResult = System.Windows.Forms.DialogResult.OK Then 'Confirm cancel
            Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
            blnCancelled = True
            blnCancel = True
            Me.Close()
        End If
    End Sub
	
    Private Sub cmdOK_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdOK.Click
        'Carry out the selected test then close
        strMsgBox = strTexts(intAnalyzeBase + 12 * intNLanguages + intLanguage)
        'Warn that this may take some time
        MyMsgBox.ShowDialog()
        If MyMsgBox.DialogResult = System.Windows.Forms.DialogResult.OK Then 'Confirm go ahead for test
            udtAnalyze.blnEvening = optEvening.Checked 'Analyze evening or morning apparitions of the Moon
            If cboCriterion.SelectedIndex > -1 Then udtAnalyze.intCriterion = cboCriterion.SelectedIndex
            udtAnalyze.intApparition = cboApparition.SelectedIndex
            'Values for intApparition
            '0: Higher - reliable time given for higher appearence, first appearance for New and last appearance for old
            '1: Lower - reliable time given for lower appearence, last appearance for New and first appearance for old
            '2: Both - reliable times for both higher and lower apparations given
            '3: Either - reliable time give for either higher or lower apparation
            '4: Seen - reliably seen with the naked eye
            '5: Not seen - not seen in clear skies by an experienced oberver
            '6: All - all reliable reports
            '7: Binoculars - reliably seen with optical aid (even only with a telescope) by an experienced observer that could not see it with the nake eye in clear conditions 
            '8: Not Binocs - reliably not seen even with optical aid by an experienced observer in clear conditions
            '9: Difficult - Seen with the naked eye for less than 10 minutes. Used for determining the optimum time for observation.
            '10: Include bad - include unreliable observations
            If optINMS.Checked Then
                udtAnalyze.intDataBase = 1
            ElseIf optSAAO.Checked Then
                udtAnalyze.intDataBase = 2
            Else
                udtAnalyze.intDataBase = 0
            End If
            blnCancelled = True
            Me.DialogResult = System.Windows.Forms.DialogResult.OK
            Me.Close()
        End If
    End Sub
    Private Sub cmdYearTable_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdYearTable.Click
        'Make an annual table of New Moon appearances with parameters for the Maimonides, Karaite and DALT-width
        'criteria and ease of visibility
        Dim blnValid As Boolean
        Dim lngDate As Integer
        Dim strTable(10) As String
        Dim lngNewMoonDate As Integer
        Dim intMonth As Short
        Dim dblDarkness As Double
        Dim intMoonUp As Short
        Dim intSunUp As Short
        Dim dblBrightness As Double
        Dim dblV As Double
        Dim dblQ As Double
        Dim dblOldQ As Double
        Dim dblHS As Double
        Dim dblBestTime As Double
        Dim dblKaraiteIllumAppar As Double
        Dim dblKaraiteDistTopo As Double
        Dim udtNewMoonDate As MyDate
        Dim udtHebDate As MyDate
        Dim udtMyCriterion As CriterionOptions
        Dim cHebrew As New clsHebrew
        Dim cGregorian As New clsGregorian
        Dim cMoon As New clsMoon
        Dim strFname As String

        On Error GoTo EH
        Dim fso As Object
        Dim MyFile As Object
        Dim saveFileDialog1 As New SaveFileDialog()
        'Allow the user to select the file for saveing
        saveFileDialog1.Filter = "txt files (*.txt)|*.txt"
        saveFileDialog1.FilterIndex = 2
        saveFileDialog1.RestoreDirectory = True
        fso = CreateObject("Scripting.FileSystemObject")
        If saveFileDialog1.ShowDialog() = DialogResult.OK Then
            strFName = saveFileDialog1.FileName()
            MyFile = fso.OpenTextFile(strFName, 2, True, -1)
            If (MyFile IsNot Nothing) Then 'If the file sucessfully opens write the data
                MyFile.writeLine(strTexts(intAnalyzeBase + 14 * intNLanguages + intLanguage))
                'Title bar
                'Name, Date, OR, DALT+0.34OR, qDALTORt, hSunHigh, hMoonLow, Seen,
                'Find start of year - go to 28th Elul
                lngDate = frmDate.ToLngDate(dblDate + dblTime, blnValid, False)
                If Not blnValid Then Exit Sub
                Call cHebrew.fixed_hebrew(lngDate, udtHebDate, blnValid)
                If Not blnValid Then Exit Sub
                'If on borderline then select the year starting from earliest telescopic visibility after the date
                If udtHebDate.intDateOfMonth = 29 And udtHebDate.intMonth = 6 Or udtHebDate.intDateOfMonth < 4 And udtHebDate.intMonth = 7 Then
                    'check to see if this is after the first visibility
                    lngNewMoonDate = cMoon.NextNewMoon(lngDate - 4, True, True)
                    If lngNewMoonDate < lngDate Then 'Push it to next year
                        If udtHebDate.intMonth = 6 Then
                            udtHebDate.intYear = udtHebDate.intYear + 1
                            udtHebDate.intDateOfMonth = 28
                        End If
                    ElseIf udtHebDate.intMonth = 7 Then  'Bring it back a year
                        udtHebDate.intYear = udtHebDate.intYear - 1
                        udtHebDate.intMonth = 6
                        udtHebDate.intDateOfMonth = 28
                    End If
                Else 'go to the end of the current year
                    udtHebDate.intMonth = 6
                    udtHebDate.intDateOfMonth = 28
                End If
                lngDate = cHebrew.hebrew_fixed(udtHebDate, blnValid)
                For intMonth = 1 To cHebrew.MonthsInHebrewYear(udtHebDate.intYear + 1) + 1
                    'For the whole year including the next Tishri
                    dblQ = -1 'Force a calculation
                    dblOldQ = -1
                    lngDate = cMoon.NextNewMoon(CDbl(lngDate), True, True)
                    'Look for the next visibility of the New Moon even if only with a telescope
                    While dblQ < 0.9 And dblOldQ < 0
                        'While the previous day was not at least 90% likely to be seen
                        dblOldQ = dblQ
                        Select Case intLanguage
                            Case 0 'Write the Gregorian date in English
                                Call cGregorian.fixed_gregorian(lngDate, udtNewMoonDate, blnValid)
                                strTable(1) = frmDate.WriteDate(udtNewMoonDate, blnValid, True, True)
                            Case 1 'Write the Hebrew date in Hebrew
                                Call cHebrew.fixed_hebrew(lngDate, udtNewMoonDate, blnValid)
                                strTable(1) = frmDate.WriteDate(udtNewMoonDate, blnValid, True, False, False)
                        End Select
                        udtMyCriterion.intType = 3 'Rambam
                        Call cMoon.SetCriterion(udtMyCriterion, blnValid, True)
                        Call cMoon.Criterion(lngDate, dblDarkness, intMoonUp, intSunUp, dblBrightness, udtMyCriterion, dblV, dblQ, dblHS, blnValid, dblKaraiteIllumAppar, dblKaraiteDistTopo)
                        strTable(2) = strAngle(dblDarkness, blnValid, -1)
                        strTable(3) = strAngle(dblBrightness, blnValid, -1)
                        strTable(4) = strAngle(dblBrightness + dblDarkness, blnValid, -1)
                        udtMyCriterion.intType = 7 'Karaite
                        Call cMoon.SetCriterion(udtMyCriterion, blnValid, True)
                        Call cMoon.Criterion(lngDate, dblDarkness, intMoonUp, intSunUp, dblBrightness, udtMyCriterion, dblV, dblQ, dblHS, dblBestTime, blnValid, dblKaraiteIllumAppar, dblKaraiteDistTopo)
                        strTable(5) = VB6.Format(Int(dblDarkness + 1 / 120.0#), "##0") & strTexts(intAnalyzeBase + 15 * intNLanguages + intLanguage) & VB6.Format(Int(60 * (dblDarkness + 1 / 120.0# - Int(dblDarkness + 1 / 120.0#))), "00") & strTexts(intAnalyzeBase + 16 * intNLanguages + intLanguage)
                        strTable(6) = VB6.Format(dblKaraiteIllumAppar, "0.00") & "(" & VB6.Format(dblBrightness, "0.00") & ")"
                        strTable(7) = VB6.Format(dblKaraiteDistTopo, "000000")
                        udtMyCriterion.intType = 2 'DALT - width
                        Call cMoon.SetCriterion(udtMyCriterion, blnValid, True)
                        Call cMoon.Criterion(lngDate, dblDarkness, intMoonUp, intSunUp, dblBrightness, udtMyCriterion, dblV, dblQ, dblHS, blnValid, dblKaraiteIllumAppar, dblKaraiteDistTopo)
                        strTable(8) = strAngle(dblDarkness, blnValid, -1)
                        Select Case intLanguage
                            Case 0
                                strTable(9) = VB6.Format(dblBrightness * 60, "##0") & """"
                                strTable(10) = VB6.Format(dblQ, "#0.0")
                            Case 1 'Reverse the order in Hebrew so that it comes out right
                                strTable(9) = """" & VB6.Format(dblBrightness * 60, "##0")
                                If dblQ > -0.05 Then
                                    strTable(10) = VB6.Format(dblQ, "##0.0")
                                Else
                                    strTable(10) = VB6.Format(-dblQ, "##0.0") & "-"
                                End If
                        End Select
                        lngDate = lngDate + 1
                        MyFile.writeLine(strTable(1) & ", " & strTable(2) & ", " & strTable(3) & ", " & strTable(4) & ", " & strTable(5) & ", " & strTable(6) & ", " & strTable(7) & ", " & strTable(8) & ", " & strTable(9) & ", " & strTable(10))
                    End While
                Next
                If Not blnValid Then Exit Sub
                MyFile.close()
            End If
        End If
        Exit Sub
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            blnValid = False
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Sub

    Private Sub DeltaT_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles DeltaT.Click
        'Test the DeltaT function (Earth's rotation relative to fixed time)
        Dim cDeltaT As New clsDeltaT
        Dim intI As Short
        Dim blnValid As Boolean
        Dim strFName As String
        Dim strDeltaT As String

        Dim fso As Object
        Dim saveFileDialog1 As New SaveFileDialog()
        'Allow the user to select the file for saveing
        saveFileDialog1.Filter = "txt files (*.txt)|*.txt"
        saveFileDialog1.FilterIndex = 2
        saveFileDialog1.RestoreDirectory = True
        fso = CreateObject("Scripting.FileSystemObject")
        If saveFileDialog1.ShowDialog() = DialogResult.OK Then
            strFName = saveFileDialog1.FileName()
            FileOpen(2, strFName, OpenMode.Output, OpenAccess.Write)
            PrintLine(2, " Year         DeltaT") 'Title
            For intI = -3000 To 3000 Step 50 'For each 50 years record the DeltaT
                'Format to make a straight table
                strDeltaT = Format(cDeltaT.DeltaT(intI * 365.25 - 365.25 - 14.25, blnValid, True), "#.000")
                PrintLine(2, Mid("     ", 1, 5 - Len(CStr(intI))) & intI, Mid("     ", 1, 9 - Len(strDeltaT)) & strDeltaT)
            Next
            FileClose(2)
        End If
    End Sub

    Private Sub frmAnalyze_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        If Not blnCancelled And Me.Visible Then Call cmdOK_Click(cmdOK, New System.EventArgs())
        'Confirm a cancel command
    End Sub

    Private Sub frmAnalyze_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        'set up the labels on loading
        Me.Text = strTexts(intAnalyzeBase + intLanguage)
        fraMornEve.Text = strTexts(intAnalyzeBase + intNLanguages + intLanguage)
        optEvening.Text = strTexts(intAnalyzeBase + 2 * intNLanguages + intLanguage)
        optMorning.Text = strTexts(intAnalyzeBase + 3 * intNLanguages + intLanguage)
        fraDB.Text = strTexts(intAnalyzeBase + 4 * intNLanguages + intLanguage)
        optINMS.Text = strTexts(intAnalyzeBase + 5 * intNLanguages + intLanguage)
        optSAAO.Text = strTexts(intAnalyzeBase + 6 * intNLanguages + intLanguage)
        optbothDB.Text = strTexts(intAnalyzeBase + 7 * intNLanguages + intLanguage)
        lblCriterion.Text = strTexts(intAnalyzeBase + 8 * intNLanguages + intLanguage)
        lblApparition.Text = strTexts(intAnalyzeBase + 9 * intNLanguages + intLanguage)
        DeltaT.Text = strTexts(intAnalyzeBase + 10 * intNLanguages + intLanguage)
        cmdYearTable.Text = strTexts(intAnalyzeBase + 11 * intNLanguages + intLanguage)
        cmdCancel.Text = strTexts(intStringBase + intNLanguages + intLanguage)
        cmdDefault.Text = strTexts(intStringBase + intLanguage)
        cmdOK.Text = strTexts(intStringBase + 2 * intNLanguages + intLanguage)
        optINMS.Checked = udtAnalyze.intDataBase = 1
        optSAAO.Checked = udtAnalyze.intDataBase = 2
        optbothDB.Checked = udtAnalyze.intDataBase = 0
        optEvening.Checked = udtAnalyze.blnEvening
        optMorning.Checked = Not udtAnalyze.blnEvening
        cboCriterion.Items.Clear()
        cboCriterion.Items.Add(strTexts(intListAnalyzeBase + intLanguage))
        cboCriterion.Items.Add(strTexts(intListAnalyzeBase + intNLanguages + intLanguage))
        cboCriterion.Items.Add(strTexts(intListAnalyzeBase + 2 * intNLanguages + intLanguage))
        cboCriterion.Text = VB6.GetItemString(cboCriterion, udtAnalyze.intCriterion)
        cboApparition.Items.Clear()
        cboApparition.Items.Add(strTexts(intListAnalyzeBase + 3 * intNLanguages + intLanguage))
        cboApparition.Items.Add(strTexts(intListAnalyzeBase + 4 * intNLanguages + intLanguage))
        cboApparition.Items.Add(strTexts(intListAnalyzeBase + 5 * intNLanguages + intLanguage))
        cboApparition.Items.Add(strTexts(intListAnalyzeBase + 6 * intNLanguages + intLanguage))
        cboApparition.Items.Add(strTexts(intListAnalyzeBase + 7 * intNLanguages + intLanguage))
        cboApparition.Items.Add(strTexts(intListAnalyzeBase + 8 * intNLanguages + intLanguage))
        cboApparition.Items.Add(strTexts(intListAnalyzeBase + 9 * intNLanguages + intLanguage))
        cboApparition.Items.Add(strTexts(intListAnalyzeBase + 10 * intNLanguages + intLanguage))
        cboApparition.Items.Add(strTexts(intListAnalyzeBase + 11 * intNLanguages + intLanguage))
        cboApparition.Items.Add(strTexts(intListAnalyzeBase + 12 * intNLanguages + intLanguage))
        cboApparition.Items.Add(strTexts(intListAnalyzeBase + 13 * intNLanguages + intLanguage))
        cboApparition.SelectedIndex = 0
        blnCancel = False
        blnCancelled = False
    End Sub
    Private Sub MyRedraw()
        'Redraw the window as described in Date.vb
        Dim dblScaleSize As Double
        Dim sngScalePoint As System.Drawing.Point
        Dim sngScaleSize As System.Drawing.Size

        If Not Me.Visible Then Exit Sub
        'blnIsresizing = True
        If Me.ClientSize.Width < Me.ClientSize.Height * 1.746 Then
            dblScaleSize = Me.ClientSize.Width / 316
        Else
            dblScaleSize = Me.ClientSize.Height / 181
        End If
        If dblScaleSize < 0.1 Then Exit Sub 'Font too small to display
        Dim aFont As New System.Drawing.Font("Arial", CSng(8 * dblScaleSize))
        Call setsize(8, 8, 105, 66, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        fraMornEve.Location = sngScalePoint
        fraMornEve.Size = sngScaleSize
        fraMornEve.Font = aFont
        If blnRtl Then
            fraMornEve.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            fraMornEve.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 16, 89, 17, dblScaleSize, fraMornEve.ClientSize.Width, sngScalePoint, sngScaleSize)
        optEvening.Location = sngScalePoint
        optEvening.Size = sngScaleSize
        optEvening.Font = aFont
        If blnRtl Then
            optEvening.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            optEvening.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 41, 89, 17, dblScaleSize, fraMornEve.ClientSize.Width, sngScalePoint, sngScaleSize)
        optMorning.Location = sngScalePoint
        optMorning.Size = sngScaleSize
        optMorning.Font = aFont
        If blnRtl Then
            optMorning.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            optMorning.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 82, 105, 91, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        fraDB.Location = sngScalePoint
        fraDB.Size = sngScaleSize
        fraDB.Font = aFont
        If blnRtl Then
            fraDB.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            fraDB.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 16, 89, 17, dblScaleSize, fraDB.ClientSize.Width, sngScalePoint, sngScaleSize)
        optINMS.Location = sngScalePoint
        optINMS.Size = sngScaleSize
        optINMS.Font = aFont
        If blnRtl Then
            optINMS.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            optINMS.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 41, 89, 17, dblScaleSize, fraDB.ClientSize.Width, sngScalePoint, sngScaleSize)
        optSAAO.Location = sngScalePoint
        optSAAO.Size = sngScaleSize
        optSAAO.Font = aFont
        If blnRtl Then
            optSAAO.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            optSAAO.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 66, 89, 17, dblScaleSize, fraDB.ClientSize.Width, sngScalePoint, sngScaleSize)
        optbothDB.Location = sngScalePoint
        optbothDB.Size = sngScaleSize
        optbothDB.Font = aFont
        If blnRtl Then
            optbothDB.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            optbothDB.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(121, 10, 57, 17, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        lblCriterion.Location = sngScalePoint
        lblCriterion.Size = sngScaleSize
        lblCriterion.Font = aFont
        If blnRtl Then
            lblCriterion.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            lblCriterion.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(186, 8, 113, 22, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        cboCriterion.Location = sngScalePoint
        cboCriterion.Size = sngScaleSize
        cboCriterion.Font = aFont
        If blnRtl Then
            cboCriterion.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            cboCriterion.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(121, 40, 57, 17, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        lblApparition.Location = sngScalePoint
        lblApparition.Size = sngScaleSize
        lblApparition.Font = aFont
        If blnRtl Then
            lblApparition.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            lblApparition.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(186, 38, 113, 22, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        cboApparition.Location = sngScalePoint
        cboApparition.Size = sngScaleSize
        cboApparition.Font = aFont
        If blnRtl Then
            cboApparition.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            cboApparition.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(121, 68, 57, 40, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        DeltaT.Location = sngScalePoint
        DeltaT.Size = sngScaleSize
        DeltaT.Font = aFont
        If blnRtl Then
            DeltaT.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            DeltaT.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(186, 68, 57, 40, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        cmdYearTable.Location = sngScalePoint
        cmdYearTable.Size = sngScaleSize
        cmdYearTable.Font = aFont
        If blnRtl Then
            cmdYearTable.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            cmdYearTable.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(121, 153, 57, 20, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        cmdDefault.Location = sngScalePoint
        cmdDefault.Size = sngScaleSize
        cmdDefault.Font = aFont
        If blnRtl Then
            cmdDefault.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            cmdDefault.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(186, 153, 57, 20, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        cmdCancel.Location = sngScalePoint
        cmdCancel.Size = sngScaleSize
        cmdCancel.Font = aFont
        If blnRtl Then
            cmdCancel.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            cmdCancel.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(251, 153, 57, 20, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        cmdOK.Location = sngScalePoint
        cmdOK.Size = sngScaleSize
        cmdOK.Font = aFont
        If blnRtl Then
            cmdOK.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            cmdOK.RightToLeft = Windows.Forms.RightToLeft.No
        End If
    End Sub

    Private Sub frmAnalyze_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        'Redraw the window after resizing
        Call MyRedraw()
    End Sub


    Private Sub cmdDefault_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdDefault.Click
        'Set the default options - INMS database, New Moon, Make table
        If optMorning.Checked Or Not optINMS.Checked Or cboCriterion.SelectedIndex <> 0 Or cboApparition.SelectedIndex <> 0 Then
            strMsgBox = strTexts(intStringBase + 6 * intNLanguages + intLanguage)
            MyMsgBox.ShowDialog()
            If MyMsgBox.DialogResult = System.Windows.Forms.DialogResult.OK Then 'confirm before reverting to default values
                optEvening.Checked = True
                optMorning.Checked = False
                optINMS.Checked = True
                optSAAO.Checked = False
                optbothDB.Checked = False
                cboApparition.SelectedIndex = 0
                cboCriterion.SelectedIndex = 0
            End If
        End If
    End Sub
End Class