Option Strict Off
Option Explicit On
Friend Class clsDMS
	'(C)Roy E. Hoffman 2000
    'See Main.bas for terms and conditions of use
    'Dnverts to and from sexegesimal to decimal
	
    Friend Function FromDMS(ByVal udtDms As DMS, ByRef blnValid As Boolean) As Double
        'Convert base 60 to decimal
        On Error GoTo EH
        blnValid = True
        'Check for validity
        If udtDms.intDegreesHours < 0 Then
            Err.Raise(vbObjectError + 1, "clsDMS.FromDMS", "udtDms.intDegreeshours out of range: " & udtDms.intDegreesHours)
        End If
        If udtDms.intMinutes < 0 Or udtDms.intMinutes > 59 Then
            Err.Raise(vbObjectError + 1, "clsDMS.FromDMS", "udtDms.intminutes out of range: " & udtDms.intMinutes)
        End If
        If udtDms.dblSeconds < 0 Or udtDms.dblSeconds >= 60 Then
            Err.Raise(vbObjectError + 1, "clsDMS.FromDMS", "udtDms.intseconds out of range: " & udtDms.dblSeconds)
        End If
        'Do the conversion
        FromDMS = udtDms.intDegreesHours + udtDms.intMinutes / 60 + udtDms.dblSeconds / 3600
        If Not udtDms.blnSign Then FromDMS = -FromDMS
        Exit Function
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description & vbCrLf & "Data from last saved location corrupted or missing. Loading default location.")
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Source, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Function
    Friend Sub ToDMS(ByVal dblX As Double, ByRef udtDms As DMS, Optional ByVal blnSecs As Boolean = True)
        'Convert decimal to base 60
        Dim lngX2 As Integer
        '21/2/00 correction to rounding to cope with negative numbers
        '09/1/08 added option for rounding to nearest minute
        'intrinsic resolution to 0.1"
        On Error GoTo EH
        If System.Math.Abs(dblX) > LongMax \ 36000 Then
            Err.Raise(vbObjectError + 1, "clsDMS.ToDMS", "dblX out of range: " & dblX)
        End If
        lngX2 = Fix(dblX * 36000 + System.Math.Sign(dblX) * 0.5)
        'In tenths of seconds rounded up by 0.05"
        With udtDms
            .intDegreesHours = Int(System.Math.Abs(lngX2 / 36000))
            If blnSecs Then 'To the nearest 0.1"
                .intMinutes = Int(System.Math.Abs(lngX2 / 600)) Mod 60
                .dblSeconds = (System.Math.Abs(lngX2) Mod 600) / 10.0
            Else 'To the nearest minute
                .intMinutes = Int(System.Math.Abs(lngX2 / 600) + 0.5) Mod 60
                .dblSeconds = 0
            End If
            .blnSign = (lngX2 >= 0)
            If .intDegreesHours < 0 Then
                Err.Raise(vbObjectError + 1, "clsDMS.ToDMS", ".intDegreeshours out of range: " & .intDegreesHours)
            End If
            If .intMinutes < 0 Or .intMinutes > 59 Then
                Err.Raise(vbObjectError + 1, "clsDMS.ToDMS", ".intminutes out of range: " & .intMinutes)
            End If
            If .dblSeconds < 0 Or .dblSeconds >= 60 Or Not blnSecs And .dblSeconds <> 0 Then
                Err.Raise(vbObjectError + 1, "clsDMS.ToDMS", ".intseconds out of range: " & .dblSeconds)
            End If
        End With
        Exit Sub
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description & vbCrLf & "Data from last saved location corrupted or missing. Loading default location.")
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Source, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Sub
End Class