Option Strict Off
Option Explicit On
Friend Class clsJD
    '(C)Roy E. Hoffman 2000-2011
    'Julian day number functions
	'See Main.bas for terms and conditions of use
	
    Friend Function jd_fixed(ByVal dblDate As Double, ByRef blnValid As Boolean) As Double
        'Convert Julian day number (UTC based) to fixed radix

        On Error GoTo EH
        blnValid = True
        jd_fixed = dblDate - 1721424.5
        If System.Math.Abs(jd_fixed) > FixMax Then
            Err.Raise(vbObjectError + 1, "clsJD.jd_fixed", "Magnitude of jd_fixed too large: " & jd_fixed)
        End If
        Exit Function
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            blnValid = False
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Function
    Friend Function fixed_jd(ByRef dblval As Double, ByRef blnValid As Boolean) As Double
        'Convert fixed radix to Julian day number (UTC based)
        On Error GoTo EH
        blnValid = True
        If System.Math.Abs(dblDate) > FixMax Then
            Err.Raise(vbObjectError + 1, "clsJD.fixed_jd", "Magnitude of dblDate too large: " & dblDate)
        End If

        fixed_jd = dblDate + 1721424.5
        Exit Function
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            blnValid = False
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Function
End Class