Option Strict Off
Option Explicit On
Friend Class clsMJD
    '(C)Roy E. Hoffman 2000-2011
    'See Main.bas for terms and conditions of use
    'Routines handling modified Julian day number
	
	Function mjd_fixed(ByRef dblDate As Double, ByRef blnValid As Boolean) As Double
		'Convert modified Julian day number (UTC based) to fixed radix
		
		On Error GoTo EH
		blnValid = True
        mjd_fixed = dblDate + 678576 'Convert
		If System.Math.Abs(mjd_fixed) > FixMax Then
			Err.Raise(vbObjectError + 1, "clsJD.mjd_fixed", "Magnitude of mjd_fixed too large: " & mjd_fixed)
		End If
		Exit Function
EH: 
		If Err.Number = vbObjectError + 1 Then
			MsgBox("Error in " & Err.Source & ", " & Err.Description)
			blnValid = False
		Else
			Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
			Err.Raise(Err.Number)
		End If
	End Function
	Function fixed_mjd(ByRef dblDate As Double, ByRef blnValid As Boolean) As Double
		'Convert fixed radix to modified Julian day number (UTC based)
		On Error GoTo EH
		blnValid = True
		If System.Math.Abs(dblDate) > FixMax Then
			Err.Raise(vbObjectError + 1, "clsJD.fixed_jd", "Magnitude of dblDate too large: " & dblDate)
		End If
		
        fixed_mjd = dblDate - 678576 'Convert
		Exit Function
EH: 
		If Err.Number = vbObjectError + 1 Then
			MsgBox("Error in " & Err.Source & ", " & Err.Description)
			blnValid = False
		Else
			Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
			Err.Raise(Err.Number)
		End If
	End Function
End Class