Option Strict Off
Option Explicit On
Friend Class frmObserver
	Inherits System.Windows.Forms.Form
    Dim blnCancelled As Boolean
    Dim blnIsInitializing As Boolean
    Friend Sub EvaluateObserver()
        'Pass parameters to global variable
        udtObserver.blnOverall = optOverall.Checked
        udtObserver.dblLevel = CDbl(txtLevel.Text)
    End Sub
	
	
    Friend Function WriteObserver(ByRef blnValid As Boolean) As String
        'Convert the parameters to a string for reporting
        On Error GoTo EH
        blnValid = True
        WriteObserver = strTexts(intfrmObserverBase + 6 * intNLanguages + intLanguage) & " "
        If udtObserver.blnOverall Then
            WriteObserver = WriteObserver & strTexts(intfrmObserverBase + intNLanguages + intLanguage)
        Else
            If System.Math.Abs(udtObserver.dblLevel) > 99.99 Then
                Err.Raise(vbObjectError + 1, "frmObserver.WriteObserver", "Invalid udtObserver.dblLevel: " & udtObserver.dblLevel)
            End If
            WriteObserver = WriteObserver & strTexts(intfrmObserverBase + 4 * intNLanguages + intLanguage) & " " & VB6.Format(udtObserver.dblLevel, "#0.00")
        End If
        Exit Function
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            blnValid = False
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Function
    Private Sub frmObserver_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        'Set the texts to the correct language and instert the current parameters
        blnIsInitializing = True
        Me.Text = strTexts(intfrmObserverBase + intLanguage)
        optOverall.Text = strTexts(intfrmObserverBase + intNLanguages + intLanguage)
        optPersonal.Text = strTexts(intfrmObserverBase + 2 * intNLanguages + intLanguage)
        lblLevel.Text = strTexts(intfrmObserverBase + 3 * intNLanguages + intLanguage)
        cmdOK.Text = strTexts(intStringBase + 2 * intNLanguages + intLanguage)
        cmdCancel.Text = strTexts(intStringBase + intNLanguages + intLanguage)
        cmdDefault.Text = strTexts(intStringBase + intLanguage)
        optOverall.Checked = udtObserver.blnOverall
        optPersonal.Checked = Not udtObserver.blnOverall
        txtLevel.Text = CStr(udtObserver.dblLevel)
        Call Update_Renamed()
        blnIsInitializing = False
    End Sub
    Private Sub Update_Renamed()
        'Update the form
        txtLevel.Enabled = Not optOverall.Checked
        blnCancelled = False
    End Sub
	
    Private Sub frmObserver_FormClosed(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        'Close form unless marked as cancelled close
        If Not blnCancelled Then Call cmdOK_Click(cmdOK, New System.EventArgs())
    End Sub
    Private Sub cmdCancel_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdCancel.Click
        'Handles the cancel command
        If optOverall.Checked <> udtObserver.blnOverall Or _
            txtLevel.Text <> CStr(udtObserver.dblLevel) Then
            'If changed confirm the cancel
            strMsgBox = strTexts(intStringBase + 5 * intNLanguages + intLanguage)
            MyMsgBox.ShowDialog()
            If MyMsgBox.DialogResult = System.Windows.Forms.DialogResult.OK Then
                Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
                blnCancelled = True
                Me.Close()
            End If
        Else
            'If unchanged, cancel and close
            Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
            blnCancelled = True
            Me.Close()
        End If
    End Sub
	
    Private Sub cmdOK_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdOK.Click
        'Check the input and close
        Dim blnError As Boolean
        Dim strError As String

        If Not IsNumeric(txtLevel.Text) Then
            If optOverall.Checked Then
                txtLevel.Text = CStr(udtObserver.dblLevel)
            Else
                strError = strTexts(intfrmObserverBase + 5 * intNLanguages + intLanguage)
                blnError = True
            End If
        End If
        strError = ""
        If blnError Then
            MsgBox(strError)
        Else
            If optOverall.Checked <> udtObserver.blnOverall Or _
                txtLevel.Text <> CStr(udtObserver.dblLevel) Then
                Me.DialogResult = System.Windows.Forms.DialogResult.OK
                blnChangedInput = True
            Else
                Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
            End If
            Call EvaluateObserver()
            blnCancelled = True
            Me.Close()
        End If
    End Sub
	
    Private Sub optOverall_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles optOverall.CheckedChanged
        If Not blnIsInitializing Then
            If eventSender.Checked Then
                Call Update_Renamed()
            End If
        End If
    End Sub
	
    Private Sub optPersonal_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles optPersonal.CheckedChanged
        If Not blnIsInitializing Then
            If eventSender.Checked Then
                Call Update_Renamed()
            End If
        End If
    End Sub
    Private Sub MyRedraw()
        'Deal with redrawing
        Dim dblScaleSize As Double
        Dim sngScalePoint As System.Drawing.Point
        Dim sngScaleSize As System.Drawing.Size

        If Not Me.Visible Then Exit Sub
        If Me.ClientSize.Width < Me.ClientSize.Height * 1.721 Then
            dblScaleSize = Me.ClientSize.Width / 210
        Else
            dblScaleSize = Me.ClientSize.Height / 122
        End If
        If dblScaleSize < 0.1 Then Exit Sub 'Font too small to display
        Dim aFont As New System.Drawing.Font("Arial", CSng(8 * dblScaleSize))
        Call setsize(8, 8, 121, 17, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        optOverall.Location = sngScalePoint
        optOverall.Size = sngScaleSize
        optOverall.Font = aFont
        If blnRtl Then
            optOverall.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            optOverall.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 33, 121, 17, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        optPersonal.Location = sngScalePoint
        optPersonal.Size = sngScaleSize
        optPersonal.Font = aFont
        If blnRtl Then
            optPersonal.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            optPersonal.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 67, 121, 17, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        lblLevel.Location = sngScalePoint
        lblLevel.Size = sngScaleSize
        lblLevel.Font = aFont
        If blnRtl Then
            lblLevel.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            lblLevel.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(137, 66, 65, 20, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        txtLevel.Location = sngScalePoint
        txtLevel.Size = sngScaleSize
        txtLevel.Font = aFont
        If blnRtl Then
            txtLevel.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            txtLevel.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(17, 94, 57, 20, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        cmdDefault.Location = sngScalePoint
        cmdDefault.Size = sngScaleSize
        cmdDefault.Font = aFont
        If blnRtl Then
            cmdDefault.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            cmdDefault.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(82, 94, 57, 20, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        cmdCancel.Location = sngScalePoint
        cmdCancel.Size = sngScaleSize
        cmdCancel.Font = aFont
        If blnRtl Then
            cmdCancel.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            cmdCancel.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(145, 94, 57, 20, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        cmdOK.Location = sngScalePoint
        cmdOK.Size = sngScaleSize
        cmdOK.Font = aFont
        If blnRtl Then
            cmdOK.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            cmdOK.RightToLeft = Windows.Forms.RightToLeft.No
        End If
    End Sub

    Private Sub frmObserver_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        Call MyRedraw()
    End Sub

    Private Sub frmObserver_VisibleChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.VisibleChanged
        Call MyRedraw()
    End Sub

    Private Sub cmdDefault_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdDefault.Click
        'Handle the default option
        If optOverall.Checked = False Or _
            txtLevel.Text <> "0" Then
            'If not already default then confirm the change
            strMsgBox = strTexts(intStringBase + 6 * intNLanguages + intLanguage)
            MyMsgBox.ShowDialog()
            If MyMsgBox.DialogResult = System.Windows.Forms.DialogResult.OK Then
                optOverall.Checked = True
                optPersonal.Checked = False
                txtLevel.Text = "0"
            End If
        End If
    End Sub
End Class