Option Strict Off
Option Explicit On
Friend Class frmOptions
	Inherits System.Windows.Forms.Form
	
    Dim blnCancelled As Boolean
    Dim blnIsInitializing As Boolean
    Private Sub cmdCancel_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdCancel.Click
        'Deal with the cancel command
        If blnChanged() Then 'If the form has been changed
            strMsgBox = strTexts(intStringBase + 5 * intNLanguages + intLanguage)
            MyMsgBox.ShowDialog()
            If MyMsgBox.DialogResult = System.Windows.Forms.DialogResult.OK Then 'Confirm cancel
                Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
                blnCancelled = True
                Me.Close()
            End If
        Else 'If the form has not been changed, exit without confirming
            Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
            blnCancelled = True
            Me.Close()
        End If
    End Sub
	
    Private Sub EvalObs()
        'Evaluate the number of potential observers
        Dim intNObs As Short
        If IsNumeric(txtNWitnesses.Text) And IsNumeric(txtPopulation.Text) Then
            'Check the validity of the parameters and give a warning if invalid
            If CDbl(txtNWitnesses.Text) < 1 Or CDbl(txtNWitnesses.Text) > Int(CDbl(txtNWitnesses.Text)) _
                Or CDbl(txtNWitnesses.Text) > 1000000000.0# Then
                lblwit.Text = strTexts(intfrmOptionsBase + 22 * intNLanguages + intLanguage)
            ElseIf CDbl(txtPopulation.Text) < 1 / 0.000046 Or (CDbl(txtPopulation.Text) < 1 / 0.000023 And Not chkWomen.CheckState) Or CDbl(txtPopulation.Text) > 100000000000.0# Then
                lblwit.Text = strTexts(intfrmOptionsBase + 23 * intNLanguages + intLanguage)
            Else
                'Calculate the number of potential witnesses
                If chkWomen.CheckState Then
                    'Allowing women as witnesses doubles the potential number
                    intNObs = CDbl(txtPopulation.Text) * 0.000046
                Else
                    intNObs = CDbl(txtPopulation.Text) * 0.000023
                End If
                If CDbl(txtNWitnesses.Text) > intNObs Then 'Check for validity
                    lblwit.Text = strTexts(intfrmOptionsBase + 22 * intNLanguages + intLanguage)
                End If
                lblwit.Text = strTexts(intfrmOptionsBase + 21 * intNLanguages + intLanguage) & " " & intNObs
            End If
        Else
            lblwit.Text = strTexts(intfrmOptionsBase + 24 * intNLanguages + intLanguage)
        End If
    End Sub
    Private Sub cmdDefault_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdDefault.Click
        'Handle the default command
        'If not already default, confirm the change
        If Not opt0.Checked Or Not OptG1.Checked Or Not optP1.Checked Or Not optS2.Checked Or chkWomen.CheckState Or _
            txtNWitnesses.Text <> "2" Or txtPopulation.Text <> "700000" Then 'If not already default
            strMsgBox = strTexts(intStringBase + 6 * intNLanguages + intLanguage)
            MyMsgBox.ShowDialog()
            If MyMsgBox.DialogResult = System.Windows.Forms.DialogResult.OK Then 'confirm before reverting to default values
                'lngPrecision = 0
                opt0.Checked = True
                opt1.Checked = False
                opt2.Checked = False
                'lngMoonCalcMode = 0
                optG0.Checked = False
                OptG1.Checked = True
                'lngPlotMode = 0
                optP0.Checked = False
                optP1.Checked = True
                optP2.Checked = False
                'intNIntegrals = 64
                optS0.Checked = False
                optS1.Checked = False
                optS2.Checked = True
                optS3.Checked = False
                chkWomen.CheckState = False
                txtNWitnesses.Text = CStr(2)
                txtPopulation.Text = CStr(700000)
            End If
        End If
    End Sub
	
    Private Function blnChanged() As Boolean
        'Check to see if there has been a change
        blnChanged = (udtObserver.blnWomen <> chkWomen.CheckState Or _
            udtObserver.lngNWitnesses <> CInt(txtNWitnesses.Text) Or _
            udtObserver.lngPopulation <> CDbl(txtPopulation.Text) Or _
            lngPrecision = 0 And Not opt0.Checked Or _
            lngPrecision = 1 And Not opt1.Checked Or _
            lngPrecision = 2 And Not opt2.Checked Or _
            lngMoonCalcMode = 0 And Not optG0.Checked Or _
            lngMoonCalcMode = 3 And Not OptG1.Checked Or _
            lngPlotMode = 0 And Not optP0.Checked Or _
            lngPlotMode = 1 And Not optP1.Checked Or _
            lngPlotMode = 2 And Not optP2.Checked Or _
            intNIntegrals = 16 And Not optS0.Checked Or _
            intNIntegrals = 32 And Not optS1.Checked Or _
            intNIntegrals = 64 And Not optS2.Checked Or _
            intNIntegrals = 128 And Not optS3.Checked)
    End Function
    Private Sub cmdOK_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdOK.Click
        'Check the parameters and exit
        Dim intI As Short
        Dim blnError As Boolean
        Dim strError As String

        strError = ""
        If Not IsNumeric(txtNWitnesses.Text) Then
            blnError = True
            strError = strTexts(intfrmOptionsBase + 25 * intNLanguages + intLanguage)
        End If
        If Not IsNumeric(txtPopulation.Text) Then
            blnError = True
            strError = strTexts(intfrmOptionsBase + 26 * intNLanguages + intLanguage)
        End If
        If Not blnError Then
            If CDbl(txtNWitnesses.Text) > Int(CDbl(txtNWitnesses.Text)) Or CDbl(txtNWitnesses.Text) < 1 Or CDbl(txtNWitnesses.Text) > 100000000000.0# Then
                blnError = True
                strError = strTexts(intfrmOptionsBase + 27 * intNLanguages + intLanguage)
            ElseIf CDbl(txtPopulation.Text) > Int(CDbl(txtPopulation.Text)) Or CDbl(txtPopulation.Text) < 1 Or CDbl(txtPopulation.Text) > 100000000000.0# Then
                blnError = True
                strError = strTexts(intfrmOptionsBase + 28 * intNLanguages + intLanguage)
            ElseIf CDbl(txtNWitnesses.Text) >= CDbl(txtPopulation.Text) * 0.000046 Or (CDbl(txtNWitnesses.Text) >= CDbl(txtPopulation.Text) * 0.000023 And Not chkWomen.CheckState) Then
                blnError = True
                strError = strTexts(intfrmOptionsBase + 29 * intNLanguages + intLanguage)
            ElseIf CDbl(txtPopulation.Text) > 1000000 Then
                MsgBox(strTexts(intfrmOptionsBase + 30 * intNLanguages + intLanguage))
            End If
        End If
        If blnError Then
            MsgBox(strError)
        Else
            If blnChanged() Then
                blnChangedInput = True
                Me.DialogResult = Windows.Forms.DialogResult.OK
                For intI = 0 To 6
                    udtVisibilitySave(intI).blnUpdated = False
                Next
                udtObserver.blnWomen = chkWomen.CheckState
                udtObserver.lngNWitnesses = CInt(txtNWitnesses.Text)
                udtObserver.lngPopulation = CDbl(txtPopulation.Text)
                If opt0.Checked Then
                    lngPrecision = 0
                ElseIf opt1.Checked Then
                    lngPrecision = 1
                Else
                    lngPrecision = 2
                End If
                If optG0.Checked Then
                    lngMoonCalcMode = 0
                ElseIf OptG1.Checked Then
                    lngMoonCalcMode = 3
                End If
                If optP0.Checked Then
                    lngPlotMode = 0
                ElseIf optP1.Checked Then
                    lngPlotMode = 1
                Else
                    lngPlotMode = 2
                End If
                If optS0.Checked Then
                    intNIntegrals = 16
                ElseIf optS1.Checked Then
                    intNIntegrals = 32
                ElseIf optS2.Checked Then
                    intNIntegrals = 64
                Else
                    intNIntegrals = 128
                End If
            Else
                blnChangedInput = False
                Me.DialogResult = Windows.Forms.DialogResult.Cancel
            End If
            blnCancelled = True
            Me.Close()
        End If
    End Sub

    Private Sub frmOptions_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        'If not marked as cancelled then close the form
        If Not blnCancelled Then Call cmdOK_Click(cmdOK, New System.EventArgs())
    End Sub
	
    Private Sub frmOptions_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        'Load the texts in the correct language and the current parameters
        blnIsInitializing = True
        Me.Text = strTexts(intfrmOptionsBase + intLanguage)
        fraPrecision.Text = strTexts(intfrmOptionsBase + intNLanguages + intLanguage)
        opt0.Text = strTexts(intfrmOptionsBase + 2 * intNLanguages + intLanguage)
        opt1.Text = strTexts(intfrmOptionsBase + 3 * intNLanguages + intLanguage)
        opt2.Text = strTexts(intfrmOptionsBase + 4 * intNLanguages + intLanguage)
        fraPlotMode.Text = strTexts(intfrmOptionsBase + 5 * intNLanguages + intLanguage)
        optP0.Text = strTexts(intfrmOptionsBase + 6 * intNLanguages + intLanguage)
        optP2.Text = strTexts(intfrmOptionsBase + 7 * intNLanguages + intLanguage)
        optP1.Text = strTexts(intfrmOptionsBase + 8 * intNLanguages + intLanguage)
        fraGraph.Text = strTexts(intfrmOptionsBase + 9 * intNLanguages + intLanguage)
        optG0.Text = strTexts(intfrmOptionsBase + 10 * intNLanguages + intLanguage)
        OptG1.Text = strTexts(intfrmOptionsBase + 11 * intNLanguages + intLanguage)
        fraSpeed.Text = strTexts(intfrmOptionsBase + 12 * intNLanguages + intLanguage)
        optS0.Text = strTexts(intfrmOptionsBase + 13 * intNLanguages + intLanguage)
        optS1.Text = strTexts(intfrmOptionsBase + 14 * intNLanguages + intLanguage)
        optS2.Text = strTexts(intfrmOptionsBase + 15 * intNLanguages + intLanguage)
        optS3.Text = strTexts(intfrmOptionsBase + 16 * intNLanguages + intLanguage)
        fraTestimony.Text = strTexts(intfrmOptionsBase + 17 * intNLanguages + intLanguage)
        chkWomen.Text = strTexts(intfrmOptionsBase + 18 * intNLanguages + intLanguage)
        lblNWitnesses.Text = strTexts(intfrmOptionsBase + 19 * intNLanguages + intLanguage)
        lblPopulation.Text = strTexts(intfrmOptionsBase + 20 * intNLanguages + intLanguage)
        lblwit.Text = strTexts(intfrmOptionsBase + 21 * intNLanguages + intLanguage)
        cmdCancel.Text = strTexts(intStringBase + intNLanguages + intLanguage)
        cmdDefault.Text = strTexts(intStringBase + intLanguage)
        cmdOK.Text = strTexts(intStringBase + 2 * intNLanguages + intLanguage)
        Select Case lngPrecision
            Case 0
                opt0.Checked = True
                opt1.Checked = False
                opt2.Checked = False
            Case 1
                opt0.Checked = False
                opt1.Checked = True
                opt2.Checked = False
            Case Else
                opt0.Checked = False
                opt1.Checked = False
                opt2.Checked = True
        End Select
        Select Case lngMoonCalcMode
            Case 0
                optG0.Checked = True
                OptG1.Checked = False
            Case 3
                optG0.Checked = False
                OptG1.Checked = True
        End Select
        If lngPlotMode = 0 Then
            optP0.Checked = True
            optP1.Checked = False
            optP2.Checked = False
        ElseIf lngPlotMode = 1 Then
            optP0.Checked = False
            optP1.Checked = True
            optP2.Checked = False
        Else
            optP0.Checked = False
            optP1.Checked = False
            optP2.Checked = True
        End If
        Select Case intNIntegrals
            Case 16
                optS0.Checked = True
                optS1.Checked = False
                optS2.Checked = False
                optS3.Checked = False
            Case 32
                optS0.Checked = False
                optS1.Checked = True
                optS2.Checked = False
                optS3.Checked = False
            Case 128
                optS0.Checked = False
                optS1.Checked = False
                optS2.Checked = False
                optS3.Checked = True
            Case Else
                optS0.Checked = False
                optS1.Checked = False
                optS2.Checked = True
                optS3.Checked = False
        End Select
        If udtObserver.blnWomen Then
            chkWomen.CheckState = System.Windows.Forms.CheckState.Checked
        Else
            chkWomen.CheckState = System.Windows.Forms.CheckState.Unchecked
        End If
        txtNWitnesses.Text = CStr(udtObserver.lngNWitnesses)
        txtPopulation.Text = CStr(udtObserver.lngPopulation)
        blnCancelled = False
        Call EvalObs()
        blnIsInitializing = False
    End Sub
	
    Private Sub chkWomen_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles chkWomen.CheckStateChanged
        If Not blnIsInitializing Then
            Call EvalObs()
        End If
    End Sub
	
    Private Sub txtNWitnesses_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles txtNWitnesses.TextChanged
        If Not blnIsInitializing Then
            Call EvalObs()
        End If
    End Sub
	
    Private Sub txtPopulation_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles txtPopulation.TextChanged
        If Not blnIsInitializing Then
            Call EvalObs()
        End If
    End Sub
    Private Sub MyRedraw()
        'Redraw the window
        Dim dblScaleSize As Double
        Dim sngScalePoint As System.Drawing.Point
        Dim sngScaleSize As System.Drawing.Size

        If Not Me.Visible Then Exit Sub
        If Me.ClientSize.Width < Me.ClientSize.Height * 1.853 Then
            dblScaleSize = Me.ClientSize.Width / 428
        Else
            dblScaleSize = Me.ClientSize.Height / 231
        End If
        If dblScaleSize < 0.1 Then Exit Sub 'Font too small to display
        Dim aFont As New System.Drawing.Font("Arial", CSng(8 * dblScaleSize))
        Call setsize(8, 8, 137, 91, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        fraPrecision.Location = sngScalePoint
        fraPrecision.Size = sngScaleSize
        fraPrecision.Font = aFont
        If blnRtl Then
            fraPrecision.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            fraPrecision.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 16, 121, 17, dblScaleSize, fraPrecision.ClientSize.Width, sngScalePoint, sngScaleSize)
        opt0.Location = sngScalePoint
        opt0.Size = sngScaleSize
        opt0.Font = aFont
        If blnRtl Then
            opt0.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            opt0.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 41, 121, 17, dblScaleSize, fraPrecision.ClientSize.Width, sngScalePoint, sngScaleSize)
        opt1.Location = sngScalePoint
        opt1.Size = sngScaleSize
        opt1.Font = aFont
        If blnRtl Then
            opt1.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            opt1.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 66, 121, 17, dblScaleSize, fraPrecision.ClientSize.Width, sngScalePoint, sngScaleSize)
        opt2.Location = sngScalePoint
        opt2.Size = sngScaleSize
        opt2.Font = aFont
        If blnRtl Then
            opt2.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            opt2.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(153, 82, 97, 91, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        fraPlotMode.Location = sngScalePoint
        fraPlotMode.Size = sngScaleSize
        fraPlotMode.Font = aFont
        If blnRtl Then
            fraPlotMode.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            fraPlotMode.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 16, 81, 17, dblScaleSize, fraPlotMode.ClientSize.Width, sngScalePoint, sngScaleSize)
        optP0.Location = sngScalePoint
        optP0.Size = sngScaleSize
        optP0.Font = aFont
        If blnRtl Then
            optP0.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            optP0.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 41, 81, 17, dblScaleSize, fraPlotMode.ClientSize.Width, sngScalePoint, sngScaleSize)
        optP2.Location = sngScalePoint
        optP2.Size = sngScaleSize
        optP2.Font = aFont
        If blnRtl Then
            optP2.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            optP2.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 66, 81, 17, dblScaleSize, fraPlotMode.ClientSize.Width, sngScalePoint, sngScaleSize)
        optP1.Location = sngScalePoint
        optP1.Size = sngScaleSize
        optP1.Font = aFont
        If blnRtl Then
            optP1.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            optP1.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(153, 8, 97, 66, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        fraGraph.Location = sngScalePoint
        fraGraph.Size = sngScaleSize
        fraGraph.Font = aFont
        If blnRtl Then
            fraGraph.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            fraGraph.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 16, 81, 17, dblScaleSize, fraGraph.ClientSize.Width, sngScalePoint, sngScaleSize)
        optG0.Location = sngScalePoint
        optG0.Size = sngScaleSize
        optG0.Font = aFont
        If blnRtl Then
            optG0.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            optG0.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 41, 81, 17, dblScaleSize, fraGraph.ClientSize.Width, sngScalePoint, sngScaleSize)
        OptG1.Location = sngScalePoint
        OptG1.Size = sngScaleSize
        OptG1.Font = aFont
        If blnRtl Then
            OptG1.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            OptG1.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 107, 137, 116, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        fraSpeed.Location = sngScalePoint
        fraSpeed.Size = sngScaleSize
        fraSpeed.Font = aFont
        If blnRtl Then
            fraSpeed.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            fraSpeed.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 16, 121, 17, dblScaleSize, fraSpeed.ClientSize.Width, sngScalePoint, sngScaleSize)
        optS0.Location = sngScalePoint
        optS0.Size = sngScaleSize
        optS0.Font = aFont
        If blnRtl Then
            optS0.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            optS0.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 41, 121, 17, dblScaleSize, fraSpeed.ClientSize.Width, sngScalePoint, sngScaleSize)
        optS1.Location = sngScalePoint
        optS1.Size = sngScaleSize
        optS1.Font = aFont
        If blnRtl Then
            optS1.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            optS1.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 66, 121, 17, dblScaleSize, fraSpeed.ClientSize.Width, sngScalePoint, sngScaleSize)
        optS2.Location = sngScalePoint
        optS2.Size = sngScaleSize
        optS2.Font = aFont
        If blnRtl Then
            optS2.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            optS2.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 91, 121, 17, dblScaleSize, fraSpeed.ClientSize.Width, sngScalePoint, sngScaleSize)
        optS3.Location = sngScalePoint
        optS3.Size = sngScaleSize
        optS3.Font = aFont
        If blnRtl Then
            optS3.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            optS3.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(258, 8, 162, 122, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        fraTestimony.Location = sngScalePoint
        fraTestimony.Size = sngScaleSize
        fraTestimony.Font = aFont
        If blnRtl Then
            fraTestimony.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            fraTestimony.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 26, 97, 17, dblScaleSize, fraTestimony.ClientSize.Width, sngScalePoint, sngScaleSize)
        chkWomen.Location = sngScalePoint
        chkWomen.Size = sngScaleSize
        chkWomen.Font = aFont
        If blnRtl Then
            chkWomen.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            chkWomen.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 42, 97, 17, dblScaleSize, fraTestimony.ClientSize.Width, sngScalePoint, sngScaleSize)
        lblNWitnesses.Location = sngScalePoint
        lblNWitnesses.Size = sngScaleSize
        lblNWitnesses.Font = aFont
        If blnRtl Then
            lblNWitnesses.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            lblNWitnesses.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(113, 41, 41, 20, dblScaleSize, fraTestimony.ClientSize.Width, sngScalePoint, sngScaleSize)
        txtNWitnesses.Location = sngScalePoint
        txtNWitnesses.Size = sngScaleSize
        txtNWitnesses.Font = aFont
        If blnRtl Then
            txtNWitnesses.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            txtNWitnesses.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 70, 57, 17, dblScaleSize, fraTestimony.ClientSize.Width, sngScalePoint, sngScaleSize)
        lblPopulation.Location = sngScalePoint
        lblPopulation.Size = sngScaleSize
        lblPopulation.Font = aFont
        If blnRtl Then
            lblPopulation.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            lblPopulation.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(64, 69, 89, 20, dblScaleSize, fraTestimony.ClientSize.Width, sngScalePoint, sngScaleSize)
        txtPopulation.Location = sngScalePoint
        txtPopulation.Size = sngScaleSize
        txtPopulation.Font = aFont
        If blnRtl Then
            txtPopulation.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            txtPopulation.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 97, 145, 17, dblScaleSize, fraTestimony.ClientSize.Width, sngScalePoint, sngScaleSize)
        lblwit.Location = sngScalePoint
        lblwit.Size = sngScaleSize
        lblwit.Font = aFont
        If blnRtl Then
            lblwit.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            lblwit.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(233, 203, 57, 20, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        cmdDefault.Location = sngScalePoint
        cmdDefault.Size = sngScaleSize
        cmdDefault.Font = aFont
        If blnRtl Then
            cmdDefault.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            cmdDefault.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(298, 203, 57, 20, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        cmdCancel.Location = sngScalePoint
        cmdCancel.Size = sngScaleSize
        cmdCancel.Font = aFont
        If blnRtl Then
            cmdCancel.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            cmdCancel.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(363, 203, 57, 20, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        cmdOK.Location = sngScalePoint
        cmdOK.Size = sngScaleSize
        cmdOK.Font = aFont
        If blnRtl Then
            cmdOK.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            cmdOK.RightToLeft = Windows.Forms.RightToLeft.No
        End If
    End Sub

    Private Sub frmOptions_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        Call MyRedraw()
    End Sub

    Private Sub frmOptions_VisibleChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.VisibleChanged
        Call MyRedraw()
    End Sub
End Class