Option Strict Off
Option Explicit On
Imports VB = Microsoft.VisualBasic
Friend Class frmTime
	Inherits System.Windows.Forms.Form
	'(C)Roy E. Hoffman 2000
    'See Main.bas for terms and conditions of use
    'Deals with time (of day) related routines
	
	Dim blnCancelled As Boolean
	
    Friend Sub TimeFromString(ByVal strTime As String, ByVal strTZ As String, ByRef intDayShift As Short, ByRef blnValid As Boolean)
        'Convert a UTC string to time and place in the global variable udtTime
        Dim intColon(1) As Short

        blnValid = True
        intDayShift = 0
        udtTime.enmTimeType = Main.TimeType.utc
        udtTime.bln24Hr = True
        udtTime.blnSecondTime = False
        intColon(0) = 1
        While intColon(0) < Len(strTime) And StrComp(Mid(strTime, intColon(0), 1), ":") <> 0
            intColon(0) = intColon(0) + 1
        End While
        If StrComp(Mid(strTime, intColon(0), 1), ":") Then
            blnValid = False
        Else
            udtTime.udtDms.intDegreesHours = CDbl(Mid(strTime, 1, intColon(0) - 1)) - CDbl(strTZ)
            If udtTime.udtDms.intDegreesHours > 23 Then
                udtTime.udtDms.intDegreesHours = udtTime.udtDms.intDegreesHours - 24
                intDayShift = 1
            ElseIf udtTime.udtDms.intDegreesHours < 0 Then
                udtTime.udtDms.intDegreesHours = udtTime.udtDms.intDegreesHours + 24
                intDayShift = -1
            End If
            intColon(1) = intColon(0) + 1
            While intColon(1) < Len(strTime) And StrComp(Mid(strTime, intColon(1), 1), ":") <> 0
                intColon(1) = intColon(1) + 1
            End While
            If Not StrComp(Mid(strTime, intColon(1), 1), ":") = 0 Then
                udtTime.udtDms.intMinutes = CShort(Mid(strTime, intColon(0) + 1, Len(strTime) - intColon(0)))
                udtTime.udtDms.dblSeconds = 0
            Else
                udtTime.udtDms.intMinutes = CShort(Mid(strTime, intColon(0) + 1, intColon(1) - intColon(0) - 1))
                udtTime.udtDms.dblSeconds = CDbl(Mid(strTime, intColon(1) + 1, Len(strTime) - intColon(1)))
            End If
        End If

    End Sub
    Friend Sub EvaluateTime(ByRef blnValid As Boolean, ByRef blnChangeOverTime As Boolean)
        'Convert time to number of days after UTC midnight at the start of or during the current day
        Dim cLocalTime As New clsLocalTime
        Dim cMeanSolar As New clsMeanSolar
        Dim cUTC As New clsUTC
        Dim cGMST As New clsGMST
        Dim cLST As New clsLST
        Dim cTrueSolar As New clsTrueSolar
        Dim cSeasonal As New clsSeasonal

        On Error GoTo EH
        blnValid = True
        'Select the appropriate conversion routine
        Select Case udtTime.enmTimeType
            Case Main.TimeType.utc
                dblTime = cUTC.FromUTC(udtTime, blnValid, udtDate.enmDateType)
            Case Main.TimeType.localt
                dblTime = cLocalTime.FromLocal(udtTime, blnValid, udtDate.enmDateType, blnChangeOverTime)
            Case Main.TimeType.meansolar
                dblTime = cMeanSolar.FromMeanSolar(udtTime, blnValid, udtDate.enmDateType)
            Case Main.TimeType.gmst
                dblTime = cGMST.FromGMST(udtTime, blnValid, udtDate.enmDateType)
            Case Main.TimeType.lst
                dblTime = cLST.FromLST(udtTime, blnValid, udtDate.enmDateType)
            Case Main.TimeType.truesolar
                dblTime = cTrueSolar.FromTrueSolar(udtTime, blnValid, udtDate.enmDateType)
            Case Main.TimeType.seasonal
                dblTime = cSeasonal.FromSeasonal(udtTime, blnValid)
            Case Else 'Invalid type
                Err.Raise(vbObjectError + 1, "frmTime.EvaluateTime", "Error in DateToFixed, Invalid time type: " & udtTime.enmTimeType)
        End Select
        Exit Sub
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            blnValid = False
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Sub
	
    Private Sub Update_Renamed()
        'Update the form according to udtTime
        opt24Hr.Checked = udtTime.bln24Hr
        optAmPm.Checked = Not udtTime.bln24Hr
        optAM.Checked = Not udtTime.blnPM
        optPM.Checked = udtTime.blnPM
        opt1.Checked = Not udtTime.blnSecondTime
        opt2.Checked = udtTime.blnSecondTime
        txtHours.Text = CStr(udtTime.udtDms.intDegreesHours)
        txtMinutes.Text = CStr(udtTime.udtDms.intMinutes)
        txtSeconds.Text = CStr(udtTime.udtDms.dblSeconds)
        If cboTimeType.SelectedIndex = Main.TimeType.seasonal Then
            optAM.Text = strTexts(intfrmTimeBase + 14 * intNLanguages + intLanguage)
            optPM.Text = strTexts(intfrmTimeBase + 15 * intNLanguages + intLanguage)
        Else
            optAM.Text = strTexts(intfrmTimeBase + 12 * intNLanguages + intLanguage)
            optPM.Text = strTexts(intfrmTimeBase + 13 * intNLanguages + intLanguage)
        End If
    End Sub
	
	'UPGRADE_WARNING: Event cboTimeType.SelectedIndexChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub cboTimeType_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cboTimeType.SelectedIndexChanged
		'Change in time type
		'AM/PM only apply to UTC, Local, mean and true solar times
		opt24Hr.Enabled = (cboTimeType.SelectedIndex = Main.TimeType.utc Or cboTimeType.SelectedIndex = Main.TimeType.localt Or cboTimeType.SelectedIndex = Main.TimeType.meansolar Or cboTimeType.SelectedIndex = Main.TimeType.truesolar)
		optAmPm.Enabled = opt24Hr.Enabled
		'optAM and optPM are used to select day and night for seasonal time
		optAM.Enabled = (opt24Hr.Enabled Or cboTimeType.SelectedIndex = Main.TimeType.seasonal)
		optPM.Enabled = optAM.Enabled
        If cboTimeType.SelectedIndex = Main.TimeType.seasonal Then
            optAM.Text = strTexts(intfrmTimeBase + 14 * intNLanguages + intLanguage)
            optPM.Text = strTexts(intfrmTimeBase + 15 * intNLanguages + intLanguage)
        Else
            optAM.Text = strTexts(intfrmTimeBase + 12 * intNLanguages + intLanguage)
            optPM.Text = strTexts(intfrmTimeBase + 13 * intNLanguages + intLanguage)
        End If
    End Sub
	
    Private Sub cmdCancel_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdCancel.Click
        'Deal with the cancel command
        If udtTime.bln24Hr <> opt24Hr.Checked And cboTimeType.SelectedIndex < Main.TimeType.gmst Or udtTime.blnPM <> optPM.Checked And Not opt24Hr.Checked And cboTimeType.SelectedIndex <> Main.TimeType.gmst And cboTimeType.SelectedIndex <> Main.TimeType.lst Or udtTime.blnSecondTime <> opt2.Checked Or udtTime.enmTimeType <> cboTimeType.SelectedIndex Or udtTime.udtDms.dblSeconds <> CDbl(txtSeconds.Text) Or udtTime.udtDms.intDegreesHours <> CDbl(txtHours.Text) Or udtTime.udtDms.intMinutes <> CDbl(txtMinutes.Text) Then
            strMsgBox = strTexts(intStringBase + 5 * intNLanguages + intLanguage)
            MyMsgBox.ShowDialog()
            If MyMsgBox.DialogResult = System.Windows.Forms.DialogResult.OK Then 'Confirm cancel
                Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
                blnCancelled = True
                blnChangedInput = False
                Me.Close()
            End If
        Else 'If the form has not been changed, exit without confirming
            Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
            blnCancelled = True
            blnChangedInput = False
            Me.Close()
        End If
    End Sub
	
    Private Sub cmdOK_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdOK.Click
        'Check and close the form
        Dim blnError As Boolean 'Indicates that the time cannot be valid
        Dim strError As String
        Dim intI As Short

        blnError = False
        strError = strTexts(intfrmTimeBase + 16 * intNLanguages + intLanguage)
        'Hours
        If cboTimeType.SelectedIndex = -1 Then
            strError = strError & vbCrLf & strTexts(intfrmTimeBase + 17 * intNLanguages + intLanguage)
            blnError = True
        ElseIf Not IsNumeric(txtHours.Text) Then
            strError = strError & vbCrLf & strTexts(intfrmTimeBase + 18 * intNLanguages + intLanguage)
            blnError = True
        ElseIf CDbl(txtHours.Text) >= 24 Or CDbl(txtHours.Text) < 0 Then
            strError = strError & vbCrLf & strTexts(intfrmTimeBase + 19 * intNLanguages + intLanguage)
            blnError = True
        ElseIf CDbl(txtHours.Text) <> Int(CDbl(txtHours.Text)) Then
            strError = strError & vbCrLf & strTexts(intfrmTimeBase + 20 * intNLanguages + intLanguage)
            blnError = True
        ElseIf optAmPm.Checked And cboTimeType.SelectedIndex < Main.TimeType.gmst And (CDbl(txtHours.Text) = 0 Or CDbl(txtHours.Text) >= 13) Or cboTimeType.SelectedIndex = Main.TimeType.seasonal And CDbl(txtHours.Text) >= 12 Then
            If cboTimeType.SelectedIndex = Main.TimeType.seasonal Then
                strError = strError & vbCrLf & strTexts(intfrmTimeBase + 21 * intNLanguages + intLanguage)
            Else
                strError = strError & vbCrLf & strTexts(intfrmTimeBase + 22 * intNLanguages + intLanguage)
            End If
            blnError = True
        End If
        'Minutes
        If Not IsNumeric(txtMinutes.Text) Then
            strError = strError & vbCrLf & strTexts(intfrmTimeBase + 23 * intNLanguages + intLanguage)
            blnError = True
        ElseIf CDbl(txtMinutes.Text) < 0 Or CDbl(txtMinutes.Text) >= 60 Then
            strError = strError & vbCrLf & strTexts(intfrmTimeBase + 24 * intNLanguages + intLanguage)
            blnError = True
        ElseIf CDbl(txtMinutes.Text) <> Int(CDbl(txtMinutes.Text)) Then
            strError = strError & vbCrLf & strTexts(intfrmTimeBase + 25 * intNLanguages + intLanguage)
            blnError = True
        End If
        'Seconds
        If Not IsNumeric(txtSeconds.Text) Then
            strError = strError & vbCrLf & strTexts(intfrmTimeBase + 26 * intNLanguages + intLanguage)
            blnError = True
        ElseIf CDbl(txtSeconds.Text) < 0 Or CDbl(txtSeconds.Text) >= 60 Then
            strError = strError & vbCrLf & strTexts(intfrmTimeBase + 27 * intNLanguages + intLanguage)
            blnError = True
        End If
        If blnError Then
            MsgBox(strError)
        Else
            blnChangedInput = udtTime.bln24Hr <> opt24Hr.Checked And cboTimeType.SelectedIndex < Main.TimeType.gmst Or udtTime.blnPM <> optPM.Checked And Not opt24Hr.Checked And cboTimeType.SelectedIndex <> Main.TimeType.gmst And cboTimeType.SelectedIndex <> Main.TimeType.lst Or udtTime.blnSecondTime <> opt2.Checked Or udtTime.enmTimeType <> cboTimeType.SelectedIndex Or udtTime.udtDms.dblSeconds <> CDbl(txtSeconds.Text) Or udtTime.udtDms.intDegreesHours <> CDbl(txtHours.Text) Or udtTime.udtDms.intMinutes <> CDbl(txtMinutes.Text)
            If blnChangedInput Then
                Me.DialogResult = Windows.Forms.DialogResult.OK
                For intI = 0 To 6
                    udtVisibilitySave(intI).blnUpdated = False
                Next
                udtTime.bln24Hr = opt24Hr.Checked
                udtTime.blnPM = optPM.Checked
                udtTime.blnSecondTime = opt2.Checked
                udtTime.enmTimeType = cboTimeType.SelectedIndex
                If udtTime.enmTimeType = Main.TimeType.seasonal Then
                    udtTime.bln24Hr = False
                ElseIf udtTime.enmTimeType = Main.TimeType.gmst Or udtTime.enmTimeType = Main.TimeType.lst Then
                    udtTime.bln24Hr = True
                End If
                udtTime.udtDms.blnSign = True
                udtTime.udtDms.dblSeconds = CDbl(txtSeconds.Text)
                udtTime.udtDms.intDegreesHours = CShort(txtHours.Text)
                udtTime.udtDms.intMinutes = CShort(txtMinutes.Text)
            Else
                Me.DialogResult = Windows.Forms.DialogResult.Cancel
            End If
            blnCancelled = True
            Me.Close()
        End If
    End Sub
    Friend Function WriteTime(ByRef udtTimeIn As Mytime, ByRef intPrec As Short, ByRef blnValid As Boolean, ByRef blnTimeType As Boolean, ByRef blnChangeOverTime As Boolean) As String
        Dim udtRounded As DMS
        Dim strSeconds As String

        'Turn time into string
        On Error GoTo EH
        blnValid = True
        If blnChangeOverTime Then
            WriteTime = strTexts(intfrmTimeBase + 28 * intNLanguages + intLanguage)
            Exit Function
        End If
        If udtTimeIn.enmTimeType < Main.TimeType.utc Or udtTimeIn.enmTimeType > Main.TimeType.seasonal Then
            Err.Raise(vbObjectError + 1, "frmTime.WriteTime", "Invalid udtTimeIn.enmTimeType: " & udtTimeIn.enmTimeType)
        End If
        If udtTimeIn.udtDms.intDegreesHours < 0 Or udtTimeIn.udtDms.intDegreesHours > 24 Then
            Err.Raise(vbObjectError + 1, "frmTime.WriteTime", "Invalid udtTimeIn.udtDms.intDegreesHours: " & udtTimeIn.udtDms.intDegreesHours)
        End If
        If udtTimeIn.udtDms.intMinutes < 0 Or udtTimeIn.udtDms.intMinutes > 59 Then
            Err.Raise(vbObjectError + 1, "frmTime.WriteTime", "Invalid udtTimeIn.udtDms.intMinutes: " & udtTimeIn.udtDms.intMinutes)
        End If
        If udtTimeIn.udtDms.dblSeconds < 0 Or udtTimeIn.udtDms.dblSeconds >= 60 Then
            Err.Raise(vbObjectError + 1, "frmTime.WriteTime", "Invalid udtTimeIn.udtDms.dblSeconds: " & udtTimeIn.udtDms.dblSeconds)
        End If
        udtRounded.blnSign = udtTimeIn.udtDms.blnSign
        udtRounded.intDegreesHours = udtTimeIn.udtDms.intDegreesHours
        udtRounded.intMinutes = udtTimeIn.udtDms.intMinutes
        udtRounded.dblSeconds = udtTimeIn.udtDms.dblSeconds
        ' NEED TO FIX roundups across days and am to pm
        If intPrec = -1 Then 'Round up seconds
            udtRounded.dblSeconds = 0
            If udtTimeIn.udtDms.dblSeconds >= 30 Then
                If udtRounded.intMinutes < 59 Then
                    udtRounded.intMinutes = udtRounded.intMinutes + 1
                Else
                    udtRounded.intMinutes = 0
                    If udtRounded.intDegreesHours < 23 Then
                        udtRounded.intDegreesHours = udtRounded.intDegreesHours + 1
                    Else
                        udtRounded.intDegreesHours = 0
                    End If
                End If
            End If
        Else
            Select Case intPrec
                Case 0
                    strSeconds = VB6.Format(udtTimeIn.udtDms.dblSeconds, "00")
                Case 1
                    strSeconds = VB6.Format(udtTimeIn.udtDms.dblSeconds, "00.0")
                Case Else '2
                    strSeconds = VB6.Format(udtTimeIn.udtDms.dblSeconds, "00.00")
            End Select
            If VB.Left(strSeconds, 2) = "60" Then
                udtRounded.dblSeconds = 0
                If udtRounded.intMinutes < 59 Then
                    udtRounded.intMinutes = udtRounded.intMinutes + 1
                Else
                    udtRounded.intMinutes = 0
                    If udtRounded.intDegreesHours < 23 Then
                        udtRounded.intDegreesHours = udtRounded.intDegreesHours + 1
                    Else
                        udtRounded.intDegreesHours = 0
                    End If
                End If
            End If
        End If
        If udtTime.bln24Hr Then
            WriteTime = VB6.Format(udtRounded.intDegreesHours, "00")
        Else
            WriteTime = CStr(udtRounded.intDegreesHours)
        End If
        WriteTime = WriteTime & ":" & VB6.Format(udtRounded.intMinutes, "00")
        If intPrec >= 0 Then
            WriteTime = WriteTime & ":"
            Select Case intPrec
                Case 0
                    WriteTime = WriteTime & VB6.Format(udtRounded.dblSeconds, "00")
                Case 1
                    WriteTime = WriteTime & VB6.Format(udtRounded.dblSeconds, "00.0")
                Case Else '2
                    WriteTime = WriteTime & VB6.Format(udtRounded.dblSeconds, "00.00")
            End Select
        End If
        If Not udtTimeIn.bln24Hr Then
            If udtTimeIn.enmTimeType = Main.TimeType.seasonal Then
                If udtTimeIn.blnPM Then
                    WriteTime = WriteTime & " " & strTexts(intfrmTimeBase + 15 * intNLanguages + intLanguage)
                Else
                    WriteTime = WriteTime & " " & strTexts(intfrmTimeBase + 14 * intNLanguages + intLanguage)
                End If
            Else
                If udtTimeIn.blnPM Then
                    WriteTime = WriteTime & " " & strTexts(intfrmTimeBase + 13 * intNLanguages + intLanguage)
                Else
                    WriteTime = WriteTime & " " & strTexts(intfrmTimeBase + 12 * intNLanguages + intLanguage)
                End If
            End If
        End If
        If udtTimeIn.blnSecondTime Then
            WriteTime = WriteTime & " " & strTexts(intfrmTimeBase + 7 * intNLanguages + intLanguage)
        End If
        If blnTimeType Then
            Select Case udtTimeIn.enmTimeType
                Case Main.TimeType.utc
                    WriteTime = WriteTime & " " & strTexts(intListBase + 25 * intNLanguages + intLanguage)
                Case Main.TimeType.localt
                    WriteTime = WriteTime & " " & strTexts(intListBase + 26 * intNLanguages + intLanguage)
                Case Main.TimeType.meansolar
                    WriteTime = WriteTime & " " & strTexts(intListBase + 27 * intNLanguages + intLanguage)
                Case Main.TimeType.truesolar
                    WriteTime = WriteTime & " " & strTexts(intListBase + 28 * intNLanguages + intLanguage)
                Case Main.TimeType.gmst
                    WriteTime = WriteTime & " " & strTexts(intListBase + 29 * intNLanguages + intLanguage)
                Case Main.TimeType.lst
                    WriteTime = WriteTime & " " & strTexts(intListBase + 30 * intNLanguages + intLanguage)
                Case Main.TimeType.seasonal
                    WriteTime = WriteTime & " " & strTexts(intListBase + 31 * intNLanguages + intLanguage)
            End Select
        End If
        Exit Function
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            blnValid = False
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Function
	
    Private Sub frmTime_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        'Set the texts according to the language and the time according to the parameters
        Me.Text = strTexts(intfrmTimeBase + intLanguage)
        lblTimeType.Text = strTexts(intfrmTimeBase + intNLanguages + intLanguage)
        lblHours.Text = strTexts(intfrmTimeBase + 2 * intNLanguages + intLanguage)
        lblMinutes.Text = strTexts(intfrmTimeBase + 3 * intNLanguages + intLanguage)
        lblSeconds.Text = strTexts(intfrmTimeBase + 4 * intNLanguages + intLanguage)
        fraNTime.Text = strTexts(intfrmTimeBase + 5 * intNLanguages + intLanguage)
        opt1.Text = strTexts(intfrmTimeBase + 6 * intNLanguages + intLanguage)
        opt2.Text = strTexts(intfrmTimeBase + 7 * intNLanguages + intLanguage)
        fra24Hr.Text = strTexts(intfrmTimeBase + 8 * intNLanguages + intLanguage)
        optAmPm.Text = strTexts(intfrmTimeBase + 9 * intNLanguages + intLanguage)
        opt24Hr.Text = strTexts(intfrmTimeBase + 10 * intNLanguages + intLanguage)
        fraAMPM.Text = strTexts(intfrmTimeBase + 11 * intNLanguages + intLanguage)
        optAM.Text = strTexts(intfrmTimeBase + 12 * intNLanguages + intLanguage)
        optPM.Text = strTexts(intfrmTimeBase + 13 * intNLanguages + intLanguage)
        cmdCancel.Text = strTexts(intStringBase + intNLanguages + intLanguage)
        cmdDefault.Text = strTexts(intStringBase + intLanguage)
        cmdOK.Text = strTexts(intStringBase + 2 * intNLanguages + intLanguage)
        cboTimeType.Items.Clear()
        cboTimeType.Items.Add(strTexts(intListBase + 25 * intNLanguages + intLanguage))
        cboTimeType.Items.Add(strTexts(intListBase + 26 * intNLanguages + intLanguage))
        cboTimeType.Items.Add(strTexts(intListBase + 27 * intNLanguages + intLanguage))
        cboTimeType.Items.Add(strTexts(intListBase + 28 * intNLanguages + intLanguage))
        cboTimeType.Items.Add(strTexts(intListBase + 29 * intNLanguages + intLanguage))
        cboTimeType.Items.Add(strTexts(intListBase + 30 * intNLanguages + intLanguage))
        cboTimeType.Items.Add(strTexts(intListBase + 31 * intNLanguages + intLanguage))
        cboTimeType.SelectedIndex = udtTime.enmTimeType
        'Copy variable to form settings
        Call Update_Renamed()
        blnCancelled = False
    End Sub
	
    Private Sub frmTime_FormClosed(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        'If not marked as cancelled, close the form
        If Not blnCancelled Then Call cmdOK_Click(cmdOK, New System.EventArgs())
    End Sub
	Friend Sub ToAMPM(ByRef udtTimeIn As Mytime, ByRef blnValid As Boolean)
		'Converts a 24 hour time into an AM/PM (Night/Day for seasonal) time
		On Error GoTo EH
		blnValid = True
		'Needs to be changed - may be a kluje
		udtTimeIn.udtDms.intDegreesHours = udtTimeIn.udtDms.intDegreesHours Mod 24
		udtTimeIn.blnPM = udtTimeIn.udtDms.intDegreesHours >= 12
		If udtTimeIn.enmTimeType = Main.TimeType.seasonal Then
			udtTimeIn.bln24Hr = False
		ElseIf udtTimeIn.enmTimeType = Main.TimeType.gmst Or udtTimeIn.enmTimeType = Main.TimeType.lst Then 
			udtTimeIn.bln24Hr = True
		Else
			udtTimeIn.bln24Hr = udtTime.bln24Hr
		End If
		If udtTimeIn.bln24Hr And udtTimeIn.enmTimeType = Main.TimeType.seasonal Then
			Err.Raise(vbObjectError + 1, "frmTime.ToAMPM", "Time must not be in 24 hour mode for seasonal type")
		ElseIf Not udtTimeIn.bln24Hr And (udtTimeIn.enmTimeType = Main.TimeType.gmst Or udtTimeIn.enmTimeType = Main.TimeType.lst) Then 
			Err.Raise(vbObjectError + 1, "frmTime.ToAMPM", "Time must be in 24 hour mode for GMST and LST type")
		End If
		If Not udtTimeIn.bln24Hr Then
			If udtTimeIn.udtDms.intDegreesHours = 0 And udtTimeIn.enmTimeType <> Main.TimeType.seasonal Then
				udtTimeIn.udtDms.intDegreesHours = 12
			ElseIf udtTimeIn.udtDms.intDegreesHours > 12 Or udtTimeIn.udtDms.intDegreesHours = 12 And udtTimeIn.enmTimeType = Main.TimeType.seasonal Then 
				udtTimeIn.udtDms.intDegreesHours = udtTimeIn.udtDms.intDegreesHours - 12
			End If
		End If
		If Not udtTimeIn.bln24Hr And (udtTimeIn.udtDms.intDegreesHours < 0 Or udtTimeIn.udtDms.intDegreesHours > 12 Or udtTimeIn.enmTimeType <> Main.TimeType.seasonal And udtTimeIn.udtDms.intDegreesHours = 0 Or udtTimeIn.udtDms.intDegreesHours = 12 And udtTimeIn.enmTimeType = Main.TimeType.seasonal) Then
			Err.Raise(vbObjectError + 1, "frmTime.ToAMPM", "Invalid udtTimeIn.udtDms.intDegreesHours: " & udtTimeIn.udtDms.intDegreesHours)
		End If
		Exit Sub
EH: 
		If Err.Number = vbObjectError + 1 Then
			MsgBox("Error in " & Err.Source & ", " & Err.Description)
			blnValid = False
		Else
			Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
			Err.Raise(Err.Number)
		End If
	End Sub
    Friend Function FromAMPM(ByVal udtTimeIn As Mytime, ByRef blnValid As Boolean) As Double
        'Get a value from a mytime type in hours
        Dim cDMS As New clsDMS

        On Error GoTo EH
        blnValid = True
        If udtTimeIn.bln24Hr And udtTimeIn.enmTimeType = Main.TimeType.seasonal Then
            Err.Raise(vbObjectError + 1, "frmTime.FromAMPM", "Time must not be in 24 hour mode for seasonal type")
        ElseIf Not udtTimeIn.bln24Hr And (udtTimeIn.enmTimeType = Main.TimeType.gmst Or udtTimeIn.enmTimeType = Main.TimeType.lst) Then
            Err.Raise(vbObjectError + 1, "frmTime.FromAMPM", "Time must be in 24 hour mode for GMST and LST type")
        End If
        If udtTimeIn.udtDms.intDegreesHours < 0 Or udtTimeIn.udtDms.intDegreesHours > 24 Or udtTimeIn.udtDms.intDegreesHours = 0 And udtTimeIn.bln24Hr = False And udtTimeIn.enmTimeType < Main.TimeType.seasonal Or udtTimeIn.udtDms.intDegreesHours > 12 And Not udtTimeIn.bln24Hr Or udtTimeIn.udtDms.intDegreesHours > 12 And udtTimeIn.enmTimeType = Main.TimeType.seasonal Then
            Err.Raise(vbObjectError + 1, "frmTime.FromAMPM", "Invalid udtTimeIn.udtDms.intDegreesHours: " & udtTimeIn.udtDms.intDegreesHours)
        End If
        If udtTimeIn.udtDms.intMinutes < 0 Or udtTimeIn.udtDms.intMinutes > 59 Then
            Err.Raise(vbObjectError + 1, "frmTime.FromAMPM", "Invalid udtTimeIn.udtDms.intMinutes: " & udtTimeIn.udtDms.intMinutes)
        End If
        If udtTimeIn.udtDms.dblSeconds < 0 Or udtTimeIn.udtDms.dblSeconds >= 60 Then
            Err.Raise(vbObjectError + 1, "frmTime.FromAMPM", "Invalid udtTimeIn.udtDms.dblSeconds: " & udtTimeIn.udtDms.dblSeconds)
        End If
        FromAMPM = cDMS.FromDMS(udtTimeIn.udtDms, blnValid)
        If Not blnValid Then Exit Function
        If Not udtTimeIn.bln24Hr Then
            If udtTimeIn.udtDms.intDegreesHours = 12 And Not udtTimeIn.blnPM Then
                FromAMPM = FromAMPM - 12
            ElseIf udtTimeIn.blnPM And udtTimeIn.udtDms.intDegreesHours < 12 Then
                FromAMPM = FromAMPM + 12
            End If
        End If
        If FromAMPM < 0 Or FromAMPM > 24 Or FromAMPM = 24 And udtTimeIn.udtDms.intMinutes > 0 Then
            Err.Raise(vbObjectError + 1, "frmTime.FromAMPM", "Invalid fromampm: " & FromAMPM)
        End If
        If udtTimeIn.blnSecondTime Then
            FromAMPM = FromAMPM + 24
        End If
        Exit Function
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            blnValid = False
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Function
    Friend Function SubTime(ByVal udtTime1 As Mytime, ByVal udtTime2 As Mytime) As Double
        'Subtract two times and give answer in days
        Dim dblTime1 As Double
        Dim dblTime2 As Double
        Dim blnValid As Boolean

        'evaluate times
        dblTime1 = FromAMPM(udtTime1, blnValid)
        dblTime2 = FromAMPM(udtTime2, blnValid)
        'subtract and convert to days
        SubTime = (dblTime1 - dblTime2) / 24
    End Function
    Private Sub MyRedraw()
        'Redraw the form
        Dim dblScaleSize As Double
        Dim sngScalePoint As System.Drawing.Point
        Dim sngScaleSize As System.Drawing.Size

        If Not Me.Visible Then Exit Sub
        'blnIsresizing = True
        If Me.ClientSize.Width < Me.ClientSize.Height * 1.172 Then
            dblScaleSize = Me.ClientSize.Width / 259
        Else
            dblScaleSize = Me.ClientSize.Height / 221
        End If
        If dblScaleSize < 0.1 Then Exit Sub 'Font too small to display
        Dim aFont As New System.Drawing.Font("Arial", CSng(8 * dblScaleSize))
        Call setsize(8, 10, 57, 17, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        lblTimeType.Location = sngScalePoint
        lblTimeType.Size = sngScaleSize
        lblTimeType.Font = aFont
        If blnRtl Then
            lblTimeType.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            lblTimeType.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(73, 8, 97, 22, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        cboTimeType.Location = sngScalePoint
        cboTimeType.Size = sngScaleSize
        cboTimeType.Font = aFont
        If blnRtl Then
            cboTimeType.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            cboTimeType.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 39, 57, 17, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        lblHours.Location = sngScalePoint
        lblHours.Size = sngScaleSize
        lblHours.Font = aFont
        If blnRtl Then
            lblHours.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            lblHours.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(73, 38, 81, 20, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        txtHours.Location = sngScalePoint
        txtHours.Size = sngScaleSize
        txtHours.Font = aFont
        If blnRtl Then
            txtHours.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            txtHours.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 67, 57, 17, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        lblMinutes.Location = sngScalePoint
        lblMinutes.Size = sngScaleSize
        lblMinutes.Font = aFont
        If blnRtl Then
            lblMinutes.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            lblMinutes.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(73, 66, 81, 20, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        txtMinutes.Location = sngScalePoint
        txtMinutes.Size = sngScaleSize
        txtMinutes.Font = aFont
        If blnRtl Then
            txtMinutes.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            txtMinutes.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 95, 57, 17, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        lblSeconds.Location = sngScalePoint
        lblSeconds.Size = sngScaleSize
        lblSeconds.Font = aFont
        If blnRtl Then
            lblSeconds.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            lblSeconds.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(73, 94, 81, 20, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        txtSeconds.Location = sngScalePoint
        txtSeconds.Size = sngScaleSize
        txtSeconds.Font = aFont
        If blnRtl Then
            txtSeconds.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            txtSeconds.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 122, 146, 66, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        fraNTime.Location = sngScalePoint
        fraNTime.Size = sngScaleSize
        fraNTime.Font = aFont
        If blnRtl Then
            fraNTime.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            fraNTime.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 16, 73, 17, dblScaleSize, fraNTime.ClientSize.Width, sngScalePoint, sngScaleSize)
        opt1.Location = sngScalePoint
        opt1.Size = sngScaleSize
        opt1.Font = aFont
        If blnRtl Then
            opt1.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            opt1.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 41, 73, 17, dblScaleSize, fraNTime.ClientSize.Width, sngScalePoint, sngScaleSize)
        opt2.Location = sngScalePoint
        opt2.Size = sngScaleSize
        opt2.Font = aFont
        If blnRtl Then
            opt2.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            opt2.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(162, 38, 73, 66, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        fra24Hr.Location = sngScalePoint
        fra24Hr.Size = sngScaleSize
        fra24Hr.Font = aFont
        If blnRtl Then
            fra24Hr.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            fra24Hr.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 16, 57, 17, dblScaleSize, fra24Hr.ClientSize.Width, sngScalePoint, sngScaleSize)
        optAmPm.Location = sngScalePoint
        optAmPm.Size = sngScaleSize
        optAmPm.Font = aFont
        If blnRtl Then
            optAmPm.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            optAmPm.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 41, 57, 17, dblScaleSize, fra24Hr.ClientSize.Width, sngScalePoint, sngScaleSize)
        opt24Hr.Location = sngScalePoint
        opt24Hr.Size = sngScaleSize
        opt24Hr.Font = aFont
        If blnRtl Then
            opt24Hr.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            opt24Hr.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(162, 112, 73, 66, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        fraAMPM.Location = sngScalePoint
        fraAMPM.Size = sngScaleSize
        fraAMPM.Font = aFont
        If blnRtl Then
            fraAMPM.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            fraAMPM.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 16, 49, 17, dblScaleSize, fraAMPM.ClientSize.Width, sngScalePoint, sngScaleSize)
        optAM.Location = sngScalePoint
        optAM.Size = sngScaleSize
        optAM.Font = aFont
        If blnRtl Then
            optAM.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            optAM.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(8, 41, 49, 17, dblScaleSize, fraAMPM.ClientSize.Width, sngScalePoint, sngScaleSize)
        optPM.Location = sngScalePoint
        optPM.Size = sngScaleSize
        optPM.Font = aFont
        If blnRtl Then
            optPM.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            optPM.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(48, 196, 57, 20, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        cmdDefault.Location = sngScalePoint
        cmdDefault.Size = sngScaleSize
        cmdDefault.Font = aFont
        If blnRtl Then
            cmdDefault.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            cmdDefault.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(113, 196, 57, 20, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        cmdCancel.Location = sngScalePoint
        cmdCancel.Size = sngScaleSize
        cmdCancel.Font = aFont
        If blnRtl Then
            cmdCancel.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            cmdCancel.RightToLeft = Windows.Forms.RightToLeft.No
        End If
        Call setsize(178, 196, 57, 20, dblScaleSize, Me.ClientSize.Width, sngScalePoint, sngScaleSize)
        cmdOK.Location = sngScalePoint
        cmdOK.Size = sngScaleSize
        cmdOK.Font = aFont
        If blnRtl Then
            cmdOK.RightToLeft = Windows.Forms.RightToLeft.Yes
        Else
            cmdOK.RightToLeft = Windows.Forms.RightToLeft.No
        End If
    End Sub

    Private Sub frmTime_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        Call MyRedraw()
    End Sub

    Private Sub frmTime_VisibleChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.VisibleChanged
        Call MyRedraw()
    End Sub

    Private Sub cmdDefault_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdDefault.Click
        'Deal with the default command - set the time to that when the program was started
        If DefaultTime.bln24Hr <> opt24Hr.Checked And cboTimeType.SelectedIndex < Main.TimeType.gmst Or _
            DefaultTime.blnPM <> optPM.Checked And Not opt24Hr.Checked And cboTimeType.SelectedIndex <> Main.TimeType.gmst _
            And cboTimeType.SelectedIndex <> Main.TimeType.lst Or DefaultTime.blnSecondTime <> opt2.Checked Or _
            DefaultTime.enmTimeType <> cboTimeType.SelectedIndex Or DefaultTime.udtDms.dblSeconds <> CDbl(txtSeconds.Text) Or _
            DefaultTime.udtDms.intDegreesHours <> CDbl(txtHours.Text) Or DefaultTime.udtDms.intMinutes <> CDbl(txtMinutes.Text) Then
            strMsgBox = strTexts(intStringBase + 6 * intNLanguages + intLanguage)
            MyMsgBox.ShowDialog()
            If MyMsgBox.DialogResult = System.Windows.Forms.DialogResult.OK Then 'confirm before reverting to default values
                opt24Hr.Checked = DefaultTime.bln24Hr
                optAmPm.Checked = Not DefaultTime.bln24Hr
                optAM.Checked = Not DefaultTime.blnPM
                optPM.Checked = DefaultTime.blnPM
                opt1.Checked = Not DefaultTime.blnSecondTime
                opt2.Checked = DefaultTime.blnSecondTime
                txtHours.Text = CStr(DefaultTime.udtDms.intDegreesHours)
                txtMinutes.Text = CStr(DefaultTime.udtDms.intMinutes)
                txtSeconds.Text = CStr(DefaultTime.udtDms.dblSeconds)
                cboTimeType.SelectedIndex = DefaultTime.enmTimeType
                If cboTimeType.SelectedIndex = Main.TimeType.seasonal Then
                    optAM.Text = strTexts(intfrmTimeBase + 14 * intNLanguages + intLanguage)
                    optPM.Text = strTexts(intfrmTimeBase + 15 * intNLanguages + intLanguage)
                Else
                    optAM.Text = strTexts(intfrmTimeBase + 12 * intNLanguages + intLanguage)
                    optPM.Text = strTexts(intfrmTimeBase + 13 * intNLanguages + intLanguage)
                End If
            End If
        End If

    End Sub
End Class