Option Strict Off
Option Explicit On
Friend Class clsHBody
    'Calculates the positions, functions and parameters of heavenly bodies
    Const AU As Integer = 149597870 'Astronomical unit in km
    Const PARSEC As Double = 30856775670286.6 'Parsec in km
    Const PI As Double = 3.14159265358979
    Const TPI As Double = 6.28318530717959
    Const NATTOMAG As Double = 0.9210340371976 'Conversion factor from ln to magnitude
    Friend Function DistSize(ByVal strHBody As String, ByRef blnValid As Boolean) As String
        'Return distance and apparent radius
        Dim udtHBody As HBody
        Dim udtDms As DMS
        Dim cDMS As New clsDMS

        On Error GoTo EH
        blnValid = True
        DistSize = ""
        'Calculate the position
        Call TrueHBody(frmMain.TranslateHBody(strHBody, False), dblDate + dblTime, udtHBody, blnValid)
        If Not blnValid Then Exit Function
        If udtHBody.DistanceTopo > 10000000000.0# Then 'No significant difference between geo and topocentric
            If intLanguage = 0 Then
                DistSize = frmMain.TranslateHBody(strHBody, True, True, True) & strTexts(intclsHBodyBase + intNLanguages + intLanguage)
                '"'s distance and size"
            Else
                DistSize = strTexts(intclsHBodyBase + intNLanguages + intLanguage) & frmMain.TranslateHBody(strHBody, True, True, True)
            End If

            DistSize = DistSize & vbCrLf & strTexts(intclsHBodyBase + 2 * intNLanguages + intLanguage) & " " & VB6.Format(udtHBody.DistanceGeo / PARSEC, strFormat(lngPrecision + 1)) & " " & strTexts(intclsHBodyBase + 3 * intNLanguages + intLanguage)
            'Distance in parsecs
            DistSize = DistSize & vbCrLf & strTexts(intclsHBodyBase + 6 * intNLanguages + intLanguage) & " " & strAngle(udtHBody.ElongationGeo, blnValid, CShort(lngPrecision))
            'Geocentric elongation
            DistSize = DistSize & vbCrLf & strTexts(intclsHBodyBase + 8 * intNLanguages + intLanguage) & " " & strAngle(udtHBody.ElongationTopo, blnValid, CShort(lngPrecision))
            'DistSize = DistSize & "Topocentric solar elongation " & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & VB6.Format(udtDms.dblSeconds, strFormat(lngPrecision))
        Else
            If intLanguage = 0 Then
                DistSize = DistSize & frmMain.TranslateHBody(strHBody, True, True, True) & strTexts(intclsHBodyBase + intNLanguages + intLanguage)
            Else
                DistSize = strTexts(intclsHBodyBase + intNLanguages + intLanguage) & " "
                DistSize = DistSize & frmMain.TranslateHBody(strHBody, True, True, True)
            End If
            DistSize = DistSize & vbCrLf & strTexts(intclsHBodyBase + 2 * intNLanguages + intLanguage) & " " & VB6.Format(udtHBody.DistanceGeo, strFormat(lngPrecision)) & " " & strTexts(intclsHBodyBase + 5 * intNLanguages + intLanguage) & vbCrLf
            'DistSize = strHBody & "'s distance and size" & vbCrLf & "Geocentric distance " & VB6.Format(udtHBody.DistanceGeo, strFormat(lngPrecision / 2)) & " km" & vbCrLf
            DistSize = DistSize & strTexts(intclsHBodyBase + 6 * intNLanguages + intLanguage) & " " & strAngle(udtHBody.ElongationGeo, blnValid, CShort(lngPrecision)) & vbCrLf
            'DistSize = DistSize & "Solar geocentric elongation " & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & VB6.Format(udtDms.dblSeconds, strFormat(lngPrecision)) & """" & vbCrLf
            DistSize = DistSize & strTexts(intclsHBodyBase + 7 * intNLanguages + intLanguage) & " " & VB6.Format(udtHBody.DistanceTopo, strFormat(CDbl(lngPrecision) / 2.0)) & " " & strTexts(intclsHBodyBase + 5 * intNLanguages + intLanguage) & vbCrLf
            'DistSize = DistSize & "Topocentric distance " & VB6.Format(udtHBody.DistanceTopo, strFormat(lngPrecision / 2)) & " km" & vbCrLf
            DistSize = DistSize & strTexts(intclsHBodyBase + 8 * intNLanguages + intLanguage) & " " & strAngle(udtHBody.ElongationTopo, blnValid, CShort(lngPrecision))
            'DistSize = DistSize & "Solar topocentric elongation " & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & VB6.Format(udtDms.dblSeconds, strFormat(lngPrecision))
            DistSize = DistSize & vbCrLf & strTexts(intclsHBodyBase + 9 * intNLanguages + intLanguage) & " " & VB6.Format(udtHBody.Phase * 100, strFormat(lngPrecision + 2)) & "% " & strTexts(intclsHBodyBase + 10 * intNLanguages + intLanguage) & " " & strAngle(acosD((udtHBody.Phase - 0.5) * 2), blnValid, lngPrecision)
            'DistSize = DistSize & vbCrLf & "Illumination " & VB6.Format(udtHBody.Phase * 100, strFormat(lngPrecision + 2)) & "% Phase angle " & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & VB6.Format(udtDms.dblSeconds, strFormat(lngPrecision)) & """" & vbCrLf
        End If
        If udtHBody.Radius < 0.01 Then
            udtDms.blnSign = True
            udtDms.intDegreesHours = 0
            udtDms.intMinutes = 0
            udtDms.dblSeconds = udtHBody.Radius * 3600
        Else
            Call cDMS.ToDMS(udtHBody.Radius, udtDms)
        End If
        If udtDms.intMinutes > 0 Then 'Sun and Moon
            Select intLanguage
                Case 0
                    DistSize = DistSize & vbCrLf & strTexts(intclsHBodyBase + 11 * intNLanguages + intLanguage) & " " & udtDms.intMinutes & "'" & VB6.Format(udtDms.dblSeconds, strFormat(lngPrecision)) & """"
                Case 1
                    DistSize = DistSize & vbCrLf & strTexts(intclsHBodyBase + 11 * intNLanguages + intLanguage) & " " & """" & VB6.Format(udtDms.dblSeconds, strFormat(lngPrecision)) & "'" & udtDms.intMinutes
            End Select
            'DistSize = DistSize & "Topocentric radius " & udtDms.intMinutes & "'" & VB6.Format(udtDms.dblSeconds, strFormat(lngPrecision)) & """"
        Else
            Select Case intLanguage
                Case 0
                    DistSize = DistSize & vbCrLf & strTexts(intclsHBodyBase + 61 * intNLanguages + intLanguage) & " " & VB6.Format(udtDms.dblSeconds, strFormat(lngPrecision - Int(Log10(udtDms.dblSeconds)) + 2)) & """"
                Case 1
                    DistSize = DistSize & vbCrLf & strTexts(intclsHBodyBase + 61 * intNLanguages + intLanguage) & " " & """" & VB6.Format(udtDms.dblSeconds, strFormat(lngPrecision - Int(Log10(udtDms.dblSeconds)) + 2))
            End Select
        End If
        Exit Function
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            blnValid = False
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Function
    Friend Sub TrueHBody(ByVal strHBody As String, ByVal dblFix As Double, ByRef udtHBody As HBody, ByRef blnValid As Boolean)
        'Find the true (as opposed to mean) position and parameters for a heavenly body at a particular time
        Dim dblMoonFix As Double 'Time for Moon corrected for differences in lunar acceleration
        Dim dblL As Double 'Planetary longitude as seen from the Sun
        Dim dblB As Double 'Planetary declination as seen from the Sun/Precession parameter B
        Dim dblR As Double 'Planetary distance from Sun
        Dim dblLS As Double 'Earth's longitude as seen from the Sun
        Dim dblBS As Double 'Earth's declination as seen from the Sun
        Dim dblRS As Double 'Earth's distance from the Sun
        'Cartesian coordinates of a planet or star measured from Earth
        Dim dblX As Double
        Dim dblY As Double
        Dim dblZ As Double
        Dim dblDelta As Double 'Light time
        Dim dblDiameter As Double 'Diameter of planet in km
        Dim intI As Short 'Counter
        Dim cSun As New clsSun
        Dim udtSun As HBody 'Parameters for the Sun
        Dim dblDMS As Double 'Distance from the Sun to the Moon
        Dim dblBeta As Double 'Phase angle on the Moon
        Dim dblRRMH As Double 'Angular radius of Moon
        Dim dblDPMH As Double 'Angle to terminator
        Dim dblT As Double 'Time in Julian centuries since J2000
        Dim dblOmega As Double 'Longitude of the Moon's ascending node used for nutation calculation
        Dim dblEps As Double 'Inclination or Earth's axis
        Dim cPlanet As New clsPlanet
        Dim cMoon As New clsMoon
        Dim dblLp As Double 'Mean longitude of the Moon
        Dim dblD As Double 'Mean elongation of the Moon
        Dim dblM As Double 'Mean anomaly (angular distance from perhelion) of the Sun
        Dim dblMp As Double 'Mean anomaly (angular distance from perigee) of the Moon
        Dim dblF As Double 'Moon's argument of latitude (mean distance of Moon from its ascending node)
        Dim dblA1 As Double 'Action of Venus on the Moon
        Dim dblA2 As Double 'Action of Jupiter on the Moon
        Dim dblA3 As Double 'Extra perturbation of the Moon
        Dim dblE As Double 'Eccentricity of the Moon
        Dim dblEE(2) As Double 'dblEE(n) = dblE^n
        Dim dblPar As Double 'Lunar parameter during calculation of its orbit
        Dim dblZeta As Double 'Precession parameter zeta
        Dim dblTheta As Double 'Precession parameter theta
        'Cartesian coordinates for the proper motions of a star
        Dim dblX2 As Double
        Dim dblY2 As Double
        Dim dblZ2 As Double
        Dim dblZ3 As Double 'Precession parameter z
        'Precession parameters
        Dim dblA As Double
        Dim dblC As Double

        On Error GoTo EH
        blnValid = True
        Select Case strHBody 'Determine the diameter in km
            Case "Sun"
                dblDiameter = 1392000
            Case "Mercury"
                dblDiameter = 4880
            Case "Venus"
                dblDiameter = 12103.6
            Case "Moon"
                dblDiameter = 3476
            Case "Mars"
                dblDiameter = 6790
            Case "Jupiter"
                dblDiameter = 116600
            Case "Saturn"
                dblDiameter = 100000
            Case Else
                intI = 0
                While intI < intNStars - 1 And strHBody <> udtStar(intI).strName(0)
                    intI = intI + 1
                End While
                If strHBody <> udtStar(intI).strName(0) Then
                    Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Invalid heavenly body name: " & strHBody)
                End If
        End Select
        If System.Math.Abs(dblFix) > FixMax + 2 Then 'allow leaway for calls near the limit
            Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Magnitude of dblFix too large: " & dblFix)
        End If
        Select Case strHBody 'Different algorithms for Sun, Moon, planets and stars
            Case "Sun"
                If blnEarth And Not blnChangedInput And dblFix = udtSunSave.Fix_Renamed And dblFix <> 0 Then
                    Call CopyHBody(udtSunSave, udtHBody)
                Else
                    dblT = ToJ2000(dblFix, blnValid) 'Julian date in centuries from J2000
                    If Not blnValid Then Exit Sub
                    dblOmega = 125.04452 - 1934.136261 * dblT + 0.0020708 * dblT * dblT + dblT * dblT * dblT / 450000 'Used for nutation correction
                    dblEps = Eps(dblT, blnValid) + 0.00256 * cosD(dblOmega)
                    If Not blnValid Then Exit Sub
                    'Find position of the Earth as seen from the Sun
                    Call cPlanet.HelioPlanet("Earth", dblFix, udtHBody.EclLong, udtHBody.EclDecl, udtHBody.DistanceGeo, blnValid)
                    If Not blnValid Then Exit Sub
                    'The Sun as seen from the Earth is opposite the Earth seen from the Sun with correction for nutation
                    udtHBody.EclLong = FracCirc(180 + udtHBody.EclLong - 0.00569 - 0.00478 * sinD(dblOmega))
                    udtHBody.EclDecl = -udtHBody.EclDecl
                    Call ConvCoords(udtHBody, dblFix, blnValid) 'Calculate the other parameters
                    If Not blnValid Then Exit Sub
                    udtHBody.Phase = 1 'Always full
                    udtHBody.Radius = atn2D(dblDiameter / 2 / udtHBody.DistanceTopo, 1) 'Apparent radius of Sun
                    udtHBody.RadiusGeo = atn2D(dblDiameter / 2 / udtHBody.DistanceGeo, 1) 'Apparent radius of Sun
                    udtHBody.WidthTopo = 2 * udtHBody.Radius 'Always full
                    'Elongation always 0
                    udtHBody.EclElong = 0
                    udtHBody.ElongationGeo = 0
                    udtHBody.ElongationTopo = 0
                    udtHBody.Fix_Renamed = dblFix
                    Call CopyHBody(udtHBody, udtSunSave)
                End If
            Case "Moon"
                If blnMoonRead And Not blnChangedInput And dblFix = udtMoonSave.Fix_Renamed And dblFix <> 0 Then
                    Call CopyHBody(udtMoonSave, udtHBody)
                Else
                    If Not blnMoonRead Then 'First time, read table
                        Call ReadHBody("Moon", udtMercury, lngMoonLR, lngMoonB, udtStar)
                        blnMoonRead = True
                    End If
                    dblT = ((dblFix + 14.25 + 365.25) / 365.25 - 2000) / 100 + 0.445 'Centuries since 1955.5
                    If dblT >= 0 Then
                        dblMoonFix = dblFix
                    Else 'adjust the time used for calculating the Moon's position to correct for the
                        'change in current measured lunar acceleration relative the lunar acceleration
                        'assumed when the lunar orbital model was invented
                        dblMoonFix = dblFix - 0.91072 * (LunAcc - LunAccMoon) * Square(dblT) / 86400
                    End If
                    dblT = ToJ2000(dblMoonFix, blnValid) 'Julian centuries since J2000
                    If Not blnValid Then Exit Sub
                    dblLp = cMoon.MeanMoon(dblMoonFix, blnValid) 'Moon's mean longitude
                    If Not blnValid Then Exit Sub
                    'Moon's mean elongation - the calculation is split because of limitations in the original Visual Basic 6 language
                    dblD = dblT * (1 / 545868 - dblT / 113065000)
                    dblD = FracCirc(297.8501921 + dblT * (445267.1114034 - dblT * (0.0018819 - dblD)))
                    'Sun's mean anomaly
                    dblM = FracCirc(357.5291092 + dblT * (35999.0502909 - dblT * (0.0001536 - dblT / 24490000)))
                    'Moon's mean anomaly
                    dblMp = dblT * (1 / 69699 - dblT / 14712000)
                    dblMp = FracCirc(134.9633964 + dblT * (477198.8675055 + dblT * (0.0087414 + dblMp)))
                    'Moon's argument of latitude
                    dblF = dblT * (1 / 3526000 - dblT / 863310000)
                    dblF = FracCirc(93.272095 + dblT * (483202.0175233 - dblT * (0.0036539 + dblF)))
                    'Planetary perturbations
                    dblA1 = FracCirc(119.75 + dblT * 131.849) 'Venus
                    dblA2 = FracCirc(53.09 + dblT * 479264.29) 'Jupiter
                    dblA3 = FracCirc(313.45 + dblT * 481266.484)
                    dblE = 1 - dblT * (0.002516 + dblT * 0.0000074) 'Eccentricity
                    dblEE(0) = 1 'Power of eccentricity
                    For intI = 1 To 2
                        dblEE(intI) = dblEE(intI - 1) * dblE
                    Next
                    'Sum of lunar coefficients
                    udtHBody.EclLong = 0
                    udtHBody.DistanceGeo = 0
                    udtHBody.EclDecl = 0
                    For intI = 0 To 59
                        'longitude
                        dblPar = dblD * lngMoonLR(0, intI) + dblM * lngMoonLR(1, intI) + dblMp * lngMoonLR(2, intI) + dblF * lngMoonLR(3, intI)
                        dblPar = (dblPar - 360 * Int(dblPar / 360)) / RADCON
                        udtHBody.EclLong = udtHBody.EclLong + lngMoonLR(4, intI) * dblEE(System.Math.Abs(lngMoonLR(1, intI))) * System.Math.Sin(dblPar)
                        'distance
                        udtHBody.DistanceGeo = udtHBody.DistanceGeo + lngMoonLR(5, intI) * dblEE(System.Math.Abs(lngMoonLR(1, intI))) * System.Math.Cos(dblPar)
                        'latitude
                        dblPar = dblD * lngMoonB(0, intI) + dblM * lngMoonB(1, intI) + dblMp * lngMoonB(2, intI) + dblF * lngMoonB(3, intI)
                        dblPar = (dblPar - 360 * Int(dblPar / 360)) / RADCON
                        udtHBody.EclDecl = udtHBody.EclDecl + lngMoonB(4, intI) * dblEE(System.Math.Abs(lngMoonB(1, intI))) * System.Math.Sin(dblPar)
                    Next
                    'Correction for perturbation of planets and the flattening of the Earth
                    udtHBody.EclLong = dblLp + (udtHBody.EclLong + 3958 * sinD(dblA1) + 1962 * sinD(dblLp - dblF) + 318 * sinD(dblA2)) / 1000000
                    dblOmega = 125.04452 - 1934.136261 * dblT + 0.0020708 * dblT * dblT + dblT * dblT * dblT / 450000 'Used for nutation correction
                    'Convert to apparent longitude correcting for abberation and nutation
                    udtHBody.EclLong = FracCirc(udtHBody.EclLong - 0.00569 * System.Math.Cos(dblD) - 0.00478 * sinD(dblOmega))
                    udtHBody.EclDecl = (udtHBody.EclDecl - 2235 * sinD(dblLp) + 382 * sinD(dblA3) + 175 * sinD(dblA1 - dblF) + 175 * sinD(dblA1 + dblF) + 127 * sinD(dblLp - dblMp) - 115 * sinD(dblLp + dblMp)) / 1000000
                    udtHBody.DistanceGeo = 385000.56 + udtHBody.DistanceGeo / 1000
                    Call ConvCoords(udtHBody, dblFix, blnValid) 'Calculate the other parameters
                    If Not blnValid Then Exit Sub
                    Call TrueHBody("Sun", dblFix, udtSun, blnValid) 'Calculate the position of the Sun for elongation
                    If Not blnValid Then Exit Sub
                    'Elongation calculations
                    udtHBody.EclElong = FracCirc2(udtHBody.EclLong - udtSun.EclLong)
                    udtHBody.EclElongTopo = FracCirc2(udtHBody.EclLongTopo - udtSun.EclLongTopo)
                    udtHBody.ElongationGeo = sinD(udtHBody.DeclGeo) * sinD(udtSun.DeclGeo) + cosD(udtHBody.DeclGeo) * cosD(udtSun.DeclGeo) * cosD(udtHBody.RAGeo - udtSun.RAGeo)
                    If udtHBody.ElongationGeo > 0.999995 Then 'If very close an alternative algorithm is more accurate
                        udtHBody.ElongationGeo = System.Math.Sqrt(Square(udtSun.RAGeo - udtHBody.RAGeo) * cosD((udtHBody.DeclGeo + udtSun.DeclGeo) / 2) + Square(udtHBody.DeclGeo - udtSun.DeclGeo))
                    ElseIf udtHBody.ElongationGeo <= -1 Then 'If very close to opposition, prevent rounding errors
                        udtHBody.ElongationGeo = 180
                    Else
                        udtHBody.ElongationGeo = acosD(udtHBody.ElongationGeo)
                    End If
                    udtHBody.ElongationTopo = sinD(udtHBody.DeclTopo) * sinD(udtSun.DeclTopo) + cosD(udtHBody.DeclTopo) * cosD(udtSun.DeclTopo) * cosD(udtHBody.RATopo - udtSun.RATopo)
                    If udtHBody.ElongationTopo > 0.999995 Then
                        udtHBody.ElongationTopo = System.Math.Sqrt(Square(udtSun.RATopo - udtHBody.RATopo) * cosD((udtHBody.DeclTopo + udtSun.DeclTopo) / 2) + Square(udtHBody.DeclTopo - udtSun.DeclTopo))
                    ElseIf udtHBody.ElongationTopo <= -1 Then
                        udtHBody.ElongationTopo = 180
                    Else
                        udtHBody.ElongationTopo = acosD(udtHBody.ElongationTopo)
                    End If
                    udtHBody.Radius = asinD(dblDiameter / 2 / udtHBody.DistanceTopo)
                    udtHBody.RadiusGeo = asinD(dblDiameter / 2 / udtHBody.DistanceGeo)
                    'Calculation of topocentric phase accurate to within 0.0022%
                    dblDMS = System.Math.Sqrt(Square(udtHBody.DistanceTopo) + Square(udtSun.DistanceTopo) - 2 * udtHBody.DistanceTopo * udtSun.DistanceTopo * cosD(udtHBody.ElongationTopo))
                    If Square(udtHBody.DistanceTopo) + Square(dblDMS) < Square(udtSun.DistanceTopo) Then
                        dblBeta = 90 - asinD(sinD(udtHBody.ElongationTopo) * udtSun.DistanceTopo / dblDMS)
                    Else
                        dblBeta = asinD(sinD(udtHBody.ElongationTopo) * udtSun.DistanceTopo / dblDMS) - 90
                    End If
                    dblRRMH = asinD(1505.152 / udtHBody.DistanceTopo)
                    dblDPMH = System.Math.Sqrt(Square(1505.152) + Square(udtHBody.DistanceTopo) - 2 * 1505.152 * udtHBody.DistanceTopo * cosD(dblBeta))
                    udtHBody.Phase = (1 - asinD(1505.152 * sinD(dblBeta) / dblDPMH) / dblRRMH) / 2
                    dblRRMH = asinD(1738 / udtHBody.DistanceTopo)
                    dblDPMH = System.Math.Sqrt(Square(1738) + Square(udtHBody.DistanceTopo) - 2 * 1738 * udtHBody.DistanceTopo * cosD(dblBeta))
                    udtHBody.WidthTopo = (dblRRMH - asinD(1738 * sinD(dblBeta) / dblDPMH))
                    udtHBody.Fix_Renamed = dblFix
                    Call CopyHBody(udtHBody, udtMoonSave)
                End If
            Case "Mercury", "Mars", "Venus", "Jupiter", "Saturn"
                dblDelta = 0 'Correction for light time in days
                For intI = 0 To 2 'Three iterations for light time correction
                    'Position of the planet relative to the Sun
                    Call cPlanet.HelioPlanet(strHBody, dblFix - dblDelta, dblL, dblB, dblR, blnValid)
                    If Not blnValid Then Exit Sub
                    'Position of the Earth relative to the Sun
                    Call cPlanet.HelioPlanet("Earth", dblFix, dblLS, dblBS, dblRS, blnValid)
                    If Not blnValid Then Exit Sub
                    'Position of the Sun
                    Call TrueHBody("Sun", dblFix - dblDelta, udtSun, blnValid)
                    If Not blnValid Then Exit Sub
                    'Relative position of the planet from Earth
                    dblX = dblR * cosD(dblB) * cosD(dblL) - dblRS * cosD(dblBS) * cosD(dblLS)
                    dblY = dblR * cosD(dblB) * sinD(dblL) - dblRS * cosD(dblBS) * sinD(dblLS)
                    dblZ = dblR * sinD(dblB) - dblRS * sinD(dblBS)
                    'Light time from planet
                    dblDelta = System.Math.Sqrt(Square(dblX) + Square(dblY) + Square(dblZ)) * 0.0000000000386068915885
                Next
                'Ecliptic coordinates from cartesian coordinates
                udtHBody.EclLong = atn2D(dblY, dblX)
                udtHBody.EclDecl = atn2D(dblZ, System.Math.Sqrt(Square(dblX) + Square(dblY)))
                If udtHBody.EclDecl >= 180 Then udtHBody.EclDecl = udtHBody.EclDecl - 360
                udtHBody.DistanceGeo = dblDelta / 0.0000000000386068915885 'Distance from light time
                Call ConvCoords(udtHBody, dblFix, blnValid) 'Calculate the other parameters
                If Not blnValid Then Exit Sub
                'Calculate elongation
                udtHBody.EclElong = FracCirc2(udtHBody.EclLong - udtSun.EclLong)
                udtHBody.EclElongTopo = FracCirc2(udtHBody.EclLongTopo - udtSun.EclLongTopo)
                udtHBody.ElongationGeo = sinD(udtHBody.DeclGeo) * sinD(udtSun.DeclGeo) + cosD(udtHBody.DeclGeo) * cosD(udtSun.DeclGeo) * cosD(udtHBody.RAGeo - udtSun.RAGeo)
                If udtHBody.ElongationGeo > 0.999995 Then
                    udtHBody.ElongationGeo = System.Math.Sqrt(Square(udtSun.RAGeo - udtHBody.RAGeo) * cosD((udtHBody.DeclGeo + udtSun.DeclGeo) / 2) + Square(udtHBody.DeclGeo - udtSun.DeclGeo))
                ElseIf udtHBody.ElongationGeo <= -1 Then
                    udtHBody.ElongationGeo = 180
                Else
                    udtHBody.ElongationGeo = acosD(udtHBody.ElongationGeo)
                End If
                udtHBody.ElongationTopo = sinD(udtHBody.DeclTopo) * sinD(udtSun.DeclTopo) + cosD(udtHBody.DeclTopo) * cosD(udtSun.DeclTopo) * cosD(udtHBody.RATopo - udtSun.RATopo)
                If udtHBody.ElongationTopo > 0.999995 Then
                    udtHBody.ElongationTopo = System.Math.Sqrt(Square(udtSun.RATopo - udtHBody.RATopo) * cosD((udtHBody.DeclTopo + udtSun.DeclTopo) / 2) + Square(udtHBody.DeclTopo - udtSun.DeclTopo))
                ElseIf udtHBody.ElongationTopo <= -1 Then
                    udtHBody.ElongationTopo = 180
                Else
                    udtHBody.ElongationTopo = acosD(udtHBody.ElongationTopo)
                End If
                udtHBody.Radius = asinD(dblDiameter / 2 / udtHBody.DistanceTopo)
                udtHBody.RadiusGeo = asinD(dblDiameter / 2 / udtHBody.DistanceGeo)
                'Calculation of topocentric phase accurate to within 0.0022%
                dblDMS = System.Math.Sqrt(Square(udtHBody.DistanceTopo) + Square(udtSun.DistanceTopo) - 2 * udtSun.DistanceTopo * udtHBody.DistanceTopo * cosD(udtHBody.ElongationTopo))
                If Square(udtHBody.DistanceTopo) + Square(dblDMS) < Square(udtSun.DistanceTopo) Then
                    dblBeta = 90 - asinD(sinD(udtHBody.ElongationTopo) * udtSun.DistanceTopo / dblDMS)
                Else
                    dblBeta = asinD(sinD(udtHBody.ElongationTopo) * udtSun.DistanceTopo / dblDMS) - 90
                End If
                dblRRMH = asinD(dblDiameter * 0.433 / udtHBody.DistanceTopo)
                dblDPMH = System.Math.Sqrt(Square(dblDiameter * 0.433) + Square(udtHBody.DistanceTopo) - 2 * dblDiameter * 0.433 * udtHBody.DistanceTopo * cosD(dblBeta))
                udtHBody.Phase = (1 - asinD(dblDiameter * 0.4332 * sinD(dblBeta) / dblDPMH) / dblRRMH) / 2
                udtHBody.WidthTopo = udtHBody.Phase * udtHBody.Radius
            Case Else 'Star
                If Not blnStarRead Then 'First time, read table
                    Call ReadHBody("Star", udtMercury, lngMoonLR, lngMoonB, udtStar)
                    blnStarRead = True
                End If
                intI = 0
                While intI < intNStars - 1 And strHBody <> udtStar(intI).strName(0)
                    intI = intI + 1
                End While
                If strHBody <> udtStar(intI).strName(0) Then
                    MsgBox(strTexts(intclsHBodyBase + 12 * intNLanguages + intLanguage))
                    'MsgBox("Star not found")
                    End
                End If
                dblT = ToJ2000(dblFix, blnValid) 'Julian centuries since J2000.0
                If Not blnValid Then Exit Sub
                'Correct for proper motion
                With udtStar(intI)
                    dblX = .dblDist * cosD(.dblDec) * cosD(.dblRA)
                    dblY = .dblDist * cosD(.dblDec) * sinD(.dblRA)
                    dblZ = .dblDist * sinD(.dblDec)
                    '977792 is the conversion factor from parsecs/y to km/s
                    '206265 is the number of arcseconds in a radian
                    dblX2 = dblX + ((dblX / .dblDist) * .dblDDist / 977792 - dblZ * .dblDDec * cosD(.dblRA) / 206265 - dblY * .dblDRA / 206265) * dblT * 100
                    dblY2 = dblY + ((dblY / .dblDist) * .dblDDist / 977792 - dblZ * .dblDDec * sinD(.dblRA) / 206265 + dblX * .dblDRA / 206265) * dblT * 100
                    dblZ2 = dblZ + ((dblZ / .dblDist) * .dblDDist / 977792 + .dblDist * .dblDDec * cosD(.dblDec) / 206265) * dblT * 100
                End With
                'Correct for precession
                dblZeta = (dblT * (2306.2181 + dblT * (0.30188 + dblT * 0.017998))) / 3600
                dblZ3 = (dblT * (2306.2181 + dblT * (1.09468 + dblT * 0.018203))) / 3600
                dblTheta = (dblT * (2004.3109 - dblT * (0.42665 + dblT * 0.041833))) / 3600
                With udtHBody
                    .RAGeo = atn2D(dblY2, dblX2)
                    .DeclGeo = atn2D(dblZ2, System.Math.Sqrt(Square(dblX2) + Square(dblY2)))
                    .DistanceGeo = System.Math.Sqrt(Square(dblX2) + Square(dblY2) + Square(dblZ2)) * 30856800000000.0#
                    dblA = cosD(.DeclGeo) * sinD(.RAGeo + dblZeta)
                    dblB = cosD(dblTheta) * cosD(.DeclGeo) * cosD(.RAGeo + dblZeta) - sinD(dblTheta) * sinD(.DeclGeo)
                    dblC = sinD(dblTheta) * cosD(.DeclGeo) * cosD(.RAGeo + dblZeta) + cosD(dblTheta) * sinD(.DeclGeo)
                    .DeclGeo = asinD(dblC)
                    .RAGeo = FracCirc(atn2D(dblA, dblB) + dblZ3)
                    'Convert to ecliptic coordinates
                    dblEps = Eps(ToJ2000(dblFix, blnValid), blnValid)
                    If Not blnValid Then Exit Sub
                    .EclLong = atn2D(sinD(.RAGeo) * cosD(dblEps) + tanD(.DeclGeo) * sinD(dblEps), cosD(.RAGeo))
                    .EclDecl = asinD(sinD(.DeclGeo) * cosD(dblEps) - cosD(.DeclGeo) * sinD(dblEps) * sinD(.RAGeo))
                End With
                Call ConvCoords(udtHBody, dblFix, blnValid) 'Calculate the other parameters
                If Not blnValid Then Exit Sub
                Call TrueHBody("Sun", dblFix, udtSun, blnValid) 'Calculate the Sun's position
                If Not blnValid Then Exit Sub
                'Calculate enlongation
                udtHBody.EclElong = FracCirc2(udtHBody.EclLong - udtSun.EclLong)
                udtHBody.EclElongTopo = FracCirc2(udtHBody.EclLongTopo - udtSun.EclLongTopo)
                udtHBody.ElongationGeo = sinD(udtHBody.DeclGeo) * sinD(udtSun.DeclGeo) + cosD(udtHBody.DeclGeo) * cosD(udtSun.DeclGeo) * cosD(udtHBody.RAGeo - udtSun.RAGeo)
                If udtHBody.ElongationGeo > 0.999995 Then
                    udtHBody.ElongationGeo = System.Math.Sqrt(Square(udtSun.RAGeo - udtHBody.RAGeo) * cosD((udtHBody.DeclGeo + udtSun.DeclGeo) / 2) + Square(udtHBody.DeclGeo - udtSun.DeclGeo))
                ElseIf udtHBody.ElongationGeo <= -1 Then
                    udtHBody.ElongationGeo = 180
                Else
                    udtHBody.ElongationGeo = acosD(udtHBody.ElongationGeo)
                End If
                udtHBody.ElongationTopo = sinD(udtHBody.DeclTopo) * sinD(udtSun.DeclTopo) + cosD(udtHBody.DeclTopo) * cosD(udtSun.DeclTopo) * cosD(udtHBody.RATopo - udtSun.RATopo)
                If udtHBody.ElongationTopo > 0.999995 Then
                    udtHBody.ElongationTopo = System.Math.Sqrt(Square(udtSun.RATopo - udtHBody.RATopo) * cosD((udtHBody.DeclTopo + udtSun.DeclTopo) / 2) + Square(udtHBody.DeclTopo - udtSun.DeclTopo))
                ElseIf udtHBody.ElongationTopo <= -1 Then
                    udtHBody.ElongationTopo = 180
                Else
                    udtHBody.ElongationTopo = acosD(udtHBody.ElongationTopo)
                End If
                udtHBody.Radius = asinD(udtStar(intI).dblDiam / 2 / udtHBody.DistanceTopo)
                udtHBody.RadiusGeo = asinD(udtStar(intI).dblDiam / 2 / udtHBody.DistanceGeo)
                udtHBody.Phase = 1 'Always full
                udtHBody.WidthTopo = 2 * udtHBody.Radius
        End Select
        If udtHBody.AltGeo > 90 Or udtHBody.AltGeo < -90 Then
            Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Invalid udtHBody.AltGeo: " & udtHBody.AltGeo)
        End If
        If udtHBody.AltRefr > 90 Or udtHBody.AltRefr < -90 Then
            Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Invalid udtHBody.AltRefr: " & udtHBody.AltRefr)
        End If
        If udtHBody.AltTopo > 90 Or udtHBody.AltTopo < -90 Then
            Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Invalid udtHBody.AltTopo: " & udtHBody.AltTopo)
        End If
        If udtHBody.AzGeo >= 360 Or udtHBody.AzGeo < 0 Then
            Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Invalid udtHBody.AzGeo: " & udtHBody.AzGeo)
        End If
        If udtHBody.AzTopo >= 360 Or udtHBody.AzTopo < 0 Then
            Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Invalid udtHBody.AzTopo: " & udtHBody.AzTopo)
        End If
        If udtHBody.DeclGeo > 90 Or udtHBody.DeclGeo < -90 Then
            Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Invalid udtHBody.DeclGeo: " & udtHBody.DeclGeo)
        End If
        If udtHBody.DeclTopo > 90 Or udtHBody.DeclTopo < -90 Then
            Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Invalid udtHBody.DeclTopo: " & udtHBody.DeclTopo)
        End If
        If udtHBody.DistanceGeo < 0 Then
            Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Invalid udtHBody.DistanceGeo: " & udtHBody.DistanceGeo)
        End If
        If udtHBody.DistanceTopo < 0 Then
            Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Invalid udtHBody.DistanceGeo: " & udtHBody.DistanceTopo)
        End If
        If udtHBody.EclDecl > 90 Or udtHBody.EclDecl < -90 Then
            Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Invalid udtHBody.EclDecl: " & udtHBody.EclDecl)
        End If
        If udtHBody.EclDeclTopo > 90 Or udtHBody.EclDeclTopo < -90 Then
            Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Invalid udtHBody.EclDeclTopo: " & udtHBody.EclDeclTopo)
        End If
        If udtHBody.EclElong > 180 Or udtHBody.EclElong <= -180 Then
            Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Invalid udtHBody.EclElong: " & udtHBody.EclElong)
        End If
        If udtHBody.EclElongTopo > 180 Or udtHBody.EclElongTopo <= -180 Then
            Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Invalid udtHBody.EclElongTopo: " & udtHBody.EclElongTopo)
        End If
        If udtHBody.EclLong >= 360 Or udtHBody.EclLong < 0 Then
            Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Invalid udtHBody.EclLong: " & udtHBody.EclLong)
        End If
        If udtHBody.EclLongTopo >= 360 Or udtHBody.EclLongTopo < 0 Then
            Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Invalid udtHBody.EclLongTopo: " & udtHBody.EclLongTopo)
        End If
        If udtHBody.ElongationGeo >= 360 Or udtHBody.ElongationGeo < 0 Then
            Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Invalid udtHBody.ElongationGeo: " & udtHBody.ElongationGeo)
        End If
        If udtHBody.ElongationTopo >= 360 Or udtHBody.ElongationTopo < 0 Then
            Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Invalid udtHBody.ElongationTopo: " & udtHBody.ElongationTopo)
        End If
        If System.Math.Abs(udtHBody.Fix_Renamed) > FixMax + 2 Then
            Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Invalid udtHBody.Fix: " & udtHBody.Fix_Renamed)
        End If
        If udtHBody.HourAngGeo > 180 Or udtHBody.HourAngGeo <= -180 Then
            Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Invalid udtHBody.HourAngGeo: " & udtHBody.HourAngGeo)
        End If
        If udtHBody.HourAngTopo > 180 Or udtHBody.HourAngTopo <= -180 Then
            Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Invalid udtHBody.HourAngTopo: " & udtHBody.HourAngTopo)
        End If
        If udtHBody.Phase > 180 Or udtHBody.Phase < 0 Then
            Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Invalid udtHBody.Phase: " & udtHBody.Phase)
        End If
        If udtHBody.Radius < 0 Then
            Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Invalid udtHBody.Radius: " & udtHBody.Radius)
        End If
        If udtHBody.RAGeo >= 360 Or udtHBody.RAGeo < 0 Then
            Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Invalid udtHBody.RAGeo: " & udtHBody.RAGeo)
        End If
        If udtHBody.RATopo >= 360 Or udtHBody.RATopo < 0 Then
            Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Invalid udtHBody.RATopo: " & udtHBody.RATopo)
        End If
        If udtHBody.WidthTopo > 1 Or udtHBody.WidthTopo < 0 Then
            Err.Raise(vbObjectError + 1, "cHBody.TrueHBody", "Invalid udtHBody.WidthTopo: " & udtHBody.WidthTopo)
        End If
        Exit Sub
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            blnValid = False
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Sub
    Friend Sub ReadHBody(ByVal strName As String, ByRef udtPars As VSOP, ByRef lngMoonLR(,) As Integer, ByRef lngMoonB(,) As Integer, ByRef udtStar() As StarData)
        'Read parameters defining the position/orbit of a heavenly body
        Dim intFactor As Short 'Perturbation factor number
        Dim intComponent As Short 'Perturbation component number
        Dim blnFoundData As Boolean 'True if the data is found and of the correct format
        Dim intI As Short 'Counter for perturbation factor for the Moon and star number
        Dim intJ As Short 'Counter for perturbation component for the Moon and star language
        Dim strLines() As String 'Data read
        Dim intLines As Integer 'Number of lines of data
        Dim intLineNumber As Integer 'Current line number
        Dim chrType As Char 'Perturbation type L, B, R
        Dim intCurrentFactor As Integer 'Current perturbation number
        Dim strData As String 'Resource name
        Dim cReadResource As New clsReadResource

        On Error GoTo EH
        blnFoundData = True 'Keep true as long as the data is valid
        Select Case strName 'Different parameters for Sun, Moon, planets and stars
            Case "Moon"
                ReDim strLines(0)
                Call cReadResource.ReadResource(My.Resources.MoonLong, strLines, intLines, "_", "'", True, ",")
                'MoonLong contains data about the Moon's distance andecliptic longitude
                For intI = 0 To 59
                    For intJ = 0 To 5
                        If Not Main.GetValue(strLines(intI * 6 + intJ), "Long", -100000000, 100000000) Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid or missing data for Moon longitude and distance component" & intJ & ", " & intI & vbCrLf & "Sorry cannot continue.")
                            blnFoundData = False
                        Else
                            lngMoonLR(intJ, intI) = strLines(intI * 6 + intJ)
                        End If
                    Next
                Next
                Call cReadResource.ReadResource(My.Resources.Moonlat, strLines, intLines, "_", "'", True, ",")
                'MoonLat contains data about the Moon's ecliptic latitude
                For intI = 0 To 59
                    For intJ = 0 To 4
                        If Not Main.GetValue(strLines(intI * 5 + intJ), "Long", -100000000, 100000000) Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid or missing data for Moon latitude and distance component" & intJ & ", " & intI & vbCrLf & "Sorry cannot continue.")
                            blnFoundData = False
                            End
                        Else
                            lngMoonB(intJ, intI) = strLines(intI * 5 + intJ)
                        End If
                    Next
                Next
                Erase strLines 'Free up memory
            Case "Mercury", "Venus", "Mars", "Earth", "Jupiter", "Saturn" 'Planets
                ReDim strLines(0)
                Select Case strName 'Choose the resource
                    Case "Mercury"
                        strData = My.Resources.Mercury
                    Case "Venus"
                        strData = My.Resources.Venus
                    Case "Earth"
                        strData = My.Resources.Earth
                    Case "Mars"
                        strData = My.Resources.Mars
                    Case "Jupiter"
                        strData = My.Resources.Jupiter
                    Case "Saturn"
                        strData = My.Resources.Saturn
                    Case Else
                        strData = ""
                        Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "The value of strName has been corrupted: " & strName)
                End Select
                Call cReadResource.ReadResource(strData, strLines, intLines, "_", "'", True, ",")
                intLineNumber = 0
                ReDim udtPars.L(0)
                ReDim udtPars.B(0)
                ReDim udtPars.R(0)
                If intLineNumber >= intLines Then
                    Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Error in planet file for " & strName & ": File truncated at entry: " & intLineNumber - 1)
                End If
                If Not Main.GetValue(strLines(intLineNumber), "String") Or Len(strLines(intLineNumber)) <> 2 Or Not IsNumeric(Right(strLines(intLineNumber), 1)) Then
                    Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid power coefficient for L in the data for " & strName & vbCrLf & "Sorry cannot continue.")
                End If
                chrType = strLines(intLineNumber)(0)
                While chrType = "L" 'Longitude
                    intFactor = CShort(Right(strLines(intLineNumber), 1))
                    intCurrentFactor = intFactor
                    ReDim Preserve udtPars.L(intFactor)
                    intComponent = 1
                    While intCurrentFactor = intFactor And chrType = "L"
                        intLineNumber = intLineNumber + 1
                        If intLineNumber >= intLines Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Error in planet file for " & strName & ": File truncated at entry: " & intLineNumber - 1)
                        End If
                        'Check that the component number is correct
                        If Not Main.GetValue(strLines(intLineNumber), "Long", 1, 32000) Or intComponent <> CDbl(strLines(intLineNumber)) Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid ordinal coefficient for L factor " & intFactor & " component " & intComponent & " in the data for " & strName & vbCrLf & "Sorry cannot continue.")
                        End If
                        'Read the components and factors
                        ReDim Preserve udtPars.L(intFactor).A(intComponent)
                        ReDim Preserve udtPars.L(intFactor).B(intComponent)
                        ReDim Preserve udtPars.L(intFactor).C(intComponent)
                        intLineNumber = intLineNumber + 1
                        If intLineNumber >= intLines Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Error in planet file for " & strName & ": File truncated at entry: " & intLineNumber - 1)
                        End If
                        If Not Main.GetValue(strLines(intLineNumber), "Long", 0, 3000000000000.0#) Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid amplitude coefficient for L factor " & intFactor & " component " & intComponent & " in the data for " & strName & vbCrLf & "Sorry cannot continue.")
                        End If
                        udtPars.L(intFactor).A(intComponent) = strLines(intLineNumber)
                        intLineNumber = intLineNumber + 1
                        If intLineNumber >= intLines Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Error in planet file for " & strName & ": File truncated at entry: " & intLineNumber - 1)
                        End If
                        If Not Main.GetValue(strLines(intLineNumber), "Double", 0, 6.284) Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid phase coefficient for L factor " & intFactor & " component " & intComponent & " in the data for " & strName & vbCrLf & "Sorry cannot continue.")
                        End If
                        udtPars.L(intFactor).B(intComponent) = strLines(intLineNumber)
                        intLineNumber = intLineNumber + 1
                        If intLineNumber >= intLines Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Error in planet file for " & strName & ": File truncated at entry: " & intLineNumber - 1)
                        End If
                        If Not Main.GetValue(strLines(intLineNumber), "Double", 0, 300000) Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid frequency coefficient for L factor " & intFactor & " component " & intComponent & " in the data for " & strName & vbCrLf & "Sorry cannot continue.")
                        End If
                        udtPars.L(intFactor).C(intComponent) = strLines(intLineNumber)
                        intComponent = intComponent + 1
                        intLineNumber = intLineNumber + 1
                        If intLineNumber >= intLines Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Error in planet file for " & strName & ": File truncated at entry: " & intLineNumber - 1)
                        End If
                        If Not Main.GetValue(strLines(intLineNumber), "String") Or Len(strLines(intLineNumber)) <> 2 Or Not IsNumeric(Right(strLines(intLineNumber), 1)) Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid power coefficient for L in the data for " & strName & vbCrLf & "Sorry cannot continue.")
                        End If
                        chrType = strLines(intLineNumber)(0)
                        intFactor = CShort(Right(strLines(intLineNumber), 1))
                    End While
                    udtPars.L(intCurrentFactor).N = intComponent - 1
                    If chrType = "L" Then intCurrentFactor = intFactor
                End While
                udtPars.NL = intCurrentFactor
                While chrType = "B" 'Ecliptic latitude
                    'continue here
                    intCurrentFactor = intFactor
                    ReDim Preserve udtPars.B(intFactor)
                    intComponent = 1
                    While intCurrentFactor = intFactor And chrType = "B"
                        intLineNumber = intLineNumber + 1
                        If intLineNumber >= intLines Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Error in planet file for " & strName & ": File truncated at entry: " & intLineNumber - 1)
                        End If
                        If Not Main.GetValue(strLines(intLineNumber), "Long", 1, 32000) Or intComponent <> CDbl(strLines(intLineNumber)) Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid ordinal coefficient for B factor " & intFactor & " component " & intComponent & " in the data for " & strName & vbCrLf & "Sorry cannot continue.")
                        End If
                        ReDim Preserve udtPars.B(intFactor).A(intComponent)
                        ReDim Preserve udtPars.B(intFactor).B(intComponent)
                        ReDim Preserve udtPars.B(intFactor).C(intComponent)
                        intLineNumber = intLineNumber + 1
                        If intLineNumber >= intLines Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Error in planet file for " & strName & ": File truncated at entry: " & intLineNumber - 1)
                        End If
                        If Not Main.GetValue(strLines(intLineNumber), "Long", 0, 3000000000000.0#) Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid amplitude coefficient for B factor " & intFactor & " component " & intComponent & " in the data for " & strName & vbCrLf & "Sorry cannot continue.")
                        End If
                        udtPars.B(intFactor).A(intComponent) = strLines(intLineNumber)
                        intLineNumber = intLineNumber + 1
                        If intLineNumber >= intLines Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Error in planet file for " & strName & ": File truncated at entry: " & intLineNumber - 1)
                        End If
                        If Not Main.GetValue(strLines(intLineNumber), "Double", 0, 6.284) Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid phase coefficient for B factor " & intFactor & " component " & intComponent & " in the data for " & strName & vbCrLf & "Sorry cannot continue.")
                        End If
                        udtPars.B(intFactor).B(intComponent) = strLines(intLineNumber)
                        intLineNumber = intLineNumber + 1
                        If intLineNumber >= intLines Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Error in planet file for " & strName & ": File truncated at entry: " & intLineNumber - 1)
                        End If
                        If Not Main.GetValue(strLines(intLineNumber), "Double", 0, 300000) Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid frequency coefficient for B factor " & intFactor & " component " & intComponent & " in the data for " & strName & vbCrLf & "Sorry cannot continue.")
                        End If
                        udtPars.B(intFactor).C(intComponent) = strLines(intLineNumber)
                        intComponent = intComponent + 1
                        intLineNumber = intLineNumber + 1
                        If intLineNumber >= intLines Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Error in planet file for " & strName & ": File truncated at entry: " & intLineNumber - 1)
                        End If
                        If Not Main.GetValue(strLines(intLineNumber), "String") Or Len(strLines(intLineNumber)) <> 2 Or Not IsNumeric(Right(strLines(intLineNumber), 1)) Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid power coefficient for B in the data for " & strName & vbCrLf & "Sorry cannot continue.")
                        End If
                        chrType = strLines(intLineNumber)(0)
                        intFactor = CShort(Right(strLines(intLineNumber), 1))
                    End While
                    udtPars.B(intCurrentFactor).N = intComponent - 1
                    If chrType = "B" Then intCurrentFactor = intFactor
                End While
                udtPars.NB = intCurrentFactor
                While chrType = "R" 'Distance data
                    intCurrentFactor = intFactor
                    ReDim Preserve udtPars.R(intFactor)
                    intComponent = 1
                    While intCurrentFactor = intFactor And chrType = "R"
                        intLineNumber = intLineNumber + 1
                        If intLineNumber >= intLines Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Error in planet file for " & strName & ": File truncated at entry: " & intLineNumber - 1)
                        End If
                        If Not Main.GetValue(strLines(intLineNumber), "Long", 1, 32000) Or intComponent <> CDbl(strLines(intLineNumber)) Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid ordinal coefficient for R factor " & intFactor & " component " & intComponent & " in the data for " & strName & vbCrLf & "Sorry cannot continue.")
                        End If
                        ReDim Preserve udtPars.R(intFactor).A(intComponent)
                        ReDim Preserve udtPars.R(intFactor).B(intComponent)
                        ReDim Preserve udtPars.R(intFactor).C(intComponent)
                        intLineNumber = intLineNumber + 1
                        If intLineNumber >= intLines Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Error in planet file for " & strName & ": File truncated at entry: " & intLineNumber - 1)
                        End If
                        If Not Main.GetValue(strLines(intLineNumber), "Long", 0, 3000000000000.0#) Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid amplitude coefficient for R factor " & intFactor & " component " & intComponent & " in the data for " & strName & vbCrLf & "Sorry cannot continue.")
                        End If
                        udtPars.R(intFactor).A(intComponent) = strLines(intLineNumber)
                        intLineNumber = intLineNumber + 1
                        If intLineNumber >= intLines Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Error in planet file for " & strName & ": File truncated at entry: " & intLineNumber - 1)
                        End If
                        If Not Main.GetValue(strLines(intLineNumber), "Double", 0, 6.284) Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid phase coefficient for R factor " & intFactor & " component " & intComponent & " in the data for " & strName & vbCrLf & "Sorry cannot continue.")
                        End If
                        udtPars.R(intFactor).B(intComponent) = strLines(intLineNumber)
                        intLineNumber = intLineNumber + 1
                        If intLineNumber >= intLines Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Error in planet file for " & strName & ": File truncated at entry: " & intLineNumber - 1)
                        End If
                        If Not Main.GetValue(strLines(intLineNumber), "Double", 0, 300000) Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid frequency coefficient for R factor " & intFactor & " component " & intComponent & " in the data for " & strName & vbCrLf & "Sorry cannot continue.")
                        End If
                        udtPars.R(intFactor).C(intComponent) = strLines(intLineNumber)
                        intComponent = intComponent + 1
                        intLineNumber = intLineNumber + 1
                        If intLineNumber >= intLines Then 'End of file
                            chrType = ""
                            intFactor = 0
                        ElseIf Not Main.GetValue(strLines(intLineNumber), "String") Or Len(strLines(intLineNumber)) <> 2 Or Not IsNumeric(Right(strLines(intLineNumber), 1)) Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid power coefficient for R in the data for " & strName & vbCrLf & "Sorry cannot continue.")
                        Else
                            chrType = strLines(intLineNumber)(0)
                            intFactor = CShort(Right(strLines(intLineNumber), 1))
                        End If
                    End While
                    udtPars.R(intCurrentFactor).N = intComponent - 1
                    If chrType = "R" Then intCurrentFactor = intFactor
                End While
                udtPars.NR = intCurrentFactor
                Erase strLines 'Free up memory
            Case "Star"
                ReDim strLines(0)
                'Check the number of star entries by reading without dividing the lines
                Call cReadResource.ReadResource(My.Resources.Stars, strLines, intLines, "_", "'", False, ",")
                intNStars = intLines + 1
                Call cReadResource.ReadResource(My.Resources.Stars, strLines, intLines, "_", "'", True, ",")
                ReDim udtStar(intNStars)
                intLineNumber = -1
                For intI = 0 To intNStars - 1
                    With udtStar(intI)
                        ReDim .strName(intNLanguages - 1)
                        For intJ = 0 To intNLanguages - 1
                            intLineNumber = intLineNumber + 1
                            If intLineNumber >= intLines Then
                                Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Error in Stars file: File truncated at entry: " & intLineNumber - 1)
                            End If
                            If Not Main.GetValue(strLines(intLineNumber), "String") Then
                                Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid star name number " & intI & vbCrLf & "Sorry cannot continue.")
                            End If
                            .strName(intJ) = strLines(intLineNumber)
                        Next
                        intLineNumber = intLineNumber + 1
                        If intLineNumber >= intLines Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Error in Stars file: File truncated at entry: " & intLineNumber - 1)
                        End If
                        If Not Main.GetValue(strLines(intLineNumber), "Double", 0, 360, True, False) Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid star right ascension for " & udtStar(intNStars).strName(0) & vbCrLf & "Sorry cannot continue.")
                        End If
                        .dblRA = strLines(intLineNumber)
                        intLineNumber = intLineNumber + 1
                        If intLineNumber >= intLines Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Error in Stars file: File truncated at entry: " & intLineNumber - 1)
                        End If
                        If Not Main.GetValue(strLines(intLineNumber), "Double", -90, 90, True, True) Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid star declination for " & udtStar(intNStars).strName(0) & vbCrLf & "Sorry cannot continue.")
                        End If
                        .dblDec = strLines(intLineNumber)
                        intLineNumber = intLineNumber + 1
                        If intLineNumber >= intLines Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Error in Stars file: File truncated at entry: " & intLineNumber - 1)
                        End If
                        If Not Main.GetValue(strLines(intLineNumber), "Double", 0, 10000000000.0#, False, False) Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid star distance for " & udtStar(intNStars).strName(0) & vbCrLf & "Sorry cannot continue.")
                        End If
                        .dblDist = strLines(intLineNumber)
                        intLineNumber = intLineNumber + 1
                        If intLineNumber >= intLines Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Error in Stars file: File truncated at entry: " & intLineNumber - 1)
                        End If
                        If Not Main.GetValue(strLines(intLineNumber), "Double", -15, 15, False, False) Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid star change in right ascension for " & udtStar(intNStars).strName(0) & vbCrLf & "Sorry cannot continue.")
                        End If
                        .dblDRA = strLines(intLineNumber)
                        intLineNumber = intLineNumber + 1
                        If intLineNumber >= intLines Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Error in Stars file: File truncated at entry: " & intLineNumber - 1)
                        End If
                        If Not Main.GetValue(strLines(intLineNumber), "Double", -15, 15, False, False) Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid star change in declination for " & udtStar(intNStars).strName(0) & vbCrLf & "Sorry cannot continue.")
                        End If
                        .dblDDec = strLines(intLineNumber)
                        intLineNumber = intLineNumber + 1
                        If intLineNumber >= intLines Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Error in Stars file: File truncated at entry: " & intLineNumber - 1)
                        End If
                        If Not Main.GetValue(strLines(intLineNumber), "Double", -300000, 300000, False, False) Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid star change in distance for " & udtStar(intNStars).strName(0) & vbCrLf & "Sorry cannot continue.")
                        End If
                        .dblDDist = strLines(intLineNumber)
                        intLineNumber = intLineNumber + 1
                        If intLineNumber >= intLines Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Error in Stars file: File truncated at entry: " & intLineNumber - 1)
                        End If
                        If Not Main.GetValue(strLines(intLineNumber), "Double", -1.5, 30, False, False) Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid star magnitude for " & udtStar(intNStars).strName(0) & vbCrLf & "Sorry cannot continue.")
                        End If
                        .dblMag = strLines(intLineNumber)
                        intLineNumber = intLineNumber + 1
                        If intLineNumber >= intLines Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Error in Stars file: File truncated at entry: " & intLineNumber - 1)
                        End If
                        If Not Main.GetValue(strLines(intLineNumber), "Double", 0, 10000000000.0#, False, False) Then
                            Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid star diameter for " & udtStar(intNStars).strName(0) & vbCrLf & "Sorry cannot continue.")
                        End If
                        .dblDiam = strLines(intLineNumber)
                    End With
                Next
                Erase strLines 'Free up memory
            Case Else
                Err.Raise(vbObjectError + 1, "cHBody.ReadHBody", "Invalid object name" & vbCrLf & "Sorry cannot continue.")
        End Select
        Exit Sub
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            FileClose(1)
            End
        ElseIf Err.Number = 53 Then
            MsgBox("Error in cHBody.ReadHBody " & Err.Description & vbCrLf & "File containing data missing. Sorry cannot continue")
            FileClose(1)
            End
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Sub
    Friend Function ToJ2000(ByVal dblFix As Double, ByRef blnValid As Boolean) As Double
        'Julian ephemeris centuries since J2000
        Dim cJDE As New clsJDE
        Dim udtDateOut As MyDate
        Dim udtTimeOut As Mytime

        On Error GoTo EH
        blnValid = True
        If System.Math.Abs(dblFix) > FixMax + 2 Then 'allow leaway for calls near the limit
            Err.Raise(vbObjectError + 1, "cHBody.ToJ2000", "Magnitude of dblFix too large: " & dblFix)
        End If
        ToJ2000 = (cJDE.fixed_jde(dblFix, blnValid) - 2451545) / 36525 'Convert to ephemeris time then to Julian centuries
        If System.Math.Abs(ToJ2000 + 20) * 36525 > FixMax + 40 Then 'allow leaway for calls near the limit
            Err.Raise(vbObjectError + 1, "cHBody.ToJ2000", "Magnitude of ToJ2000 too large: " & ToJ2000)
        End If
        Exit Function
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            blnValid = False
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Function
    Friend Function Eps(ByVal dblT As Double, ByRef blnValid As Boolean) As Double
        'Calculate the inclination of Earth's axis
        Dim dblU As Double 'Myriads of Julian years from J2000

        On Error GoTo EH
        blnValid = True
        If System.Math.Abs(dblT + 20) * 36525 > FixMax + 40 Then 'allow leaway for calls near the limit
            Err.Raise(vbObjectError + 1, "cHBody.ToJ2000", "Magnitude of dblT too large: " & dblT)
        End If
        If System.Math.Abs(dblT) <= 100 Then 'Up to 10000 years from J2000
            dblU = dblT / 100
            Eps = (7.12 + dblU * (27.87 + dblU * (5.79 + dblU * 2.45)))
            Eps = (51.38 + dblU * (249.67 + dblU * (39.05 - dblU * Eps)))
            Eps = (1.55 - dblU * (1999.25 - dblU * Eps))
            Eps = 23.4392911111111 - dblU / 3600 * (4680.93 + dblU * Eps)
        Else
            Eps = 23.4392911111111 - dblT / 3600 * (46.815 + dblT * (0.00059 - dblT * 0.001813))
        End If
        If Eps < 0 Or Eps > 90 Then
            Err.Raise(vbObjectError + 1, "cHBody.ToJ2000", "Eps out of range: " & Eps)
        End If
        Exit Function
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            blnValid = False
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Function
    Friend Sub ConvCoords(ByRef udtBody As HBody, ByRef dblFix As Double, ByRef blnValid As Boolean)
        'From J2000 date, ecliptic coordinates and distance, calculate the other coordinates
        Dim dblM As Double
        Dim dblC As Double
        Dim dblNu As Double
        Dim dblOmega As Double
        Dim dblEps As Double
        Dim dblT As Double
        Dim dblLatGeo As Double
        Dim dblRho As Double
        Dim dblSinPar As Double
        Dim dblRefR As Double
        Dim cLST As New clsLST
        Dim dblTheta As Double
        Dim cHBody As New clsHBody
        Dim udtWeatherNow As WeatherNow

        On Error GoTo EH
        blnValid = True
        If System.Math.Abs(dblFix) > FixMax + 2 Then 'allow leaway for calls near the limit
            Err.Raise(vbObjectError + 1, "cHBody.ConvCoords", "Magnitude of dblFix too large: " & dblFix)
        End If
        dblT = cHBody.ToJ2000(dblFix, blnValid)
        If Not blnValid Then Exit Sub
        'Evaluate nutation parameters
        dblM = FracCirc(357.52911 + dblT * (35999.05029 - 0.0001537 * dblT))
        dblC = (1.914602 - dblT * (0.004817 + 0.000014 * dblT)) * sinD(dblM) + (0.019993 - 0.000101 * dblT) * sinD(2 * dblM) + 0.000289 * sinD(3 * dblM)
        dblNu = dblM + dblC
        dblOmega = 125.04452 - 1934.136261 * dblT + 0.0020708 * dblT * dblT + dblT * dblT * dblT / 450000 'Used for nutation correction
        dblEps = Eps(dblT, blnValid) + 0.002556 * cosD(dblOmega) + 0.000158 * cosD(2 * (280.4665 + 36000.7698 * dblT)) + 0.000028 * cosD(2 * (218.3165 + 481267.8813 * dblT)) - 0.000025 * cosD(2 * dblOmega)
        If Not blnValid Then Exit Sub
        'Convert to RA and declination
        udtBody.RAGeo = atn2D(cosD(dblEps) * sinD(udtBody.EclLong) - tanD(udtBody.EclDecl) * sinD(dblEps), cosD(udtBody.EclLong))
        udtBody.DeclGeo = asinD(sinD(udtBody.EclDecl) * cosD(dblEps) + cosD(udtBody.EclDecl) * sinD(dblEps) * sinD(udtBody.EclLong))
        'Use LST to find hour angle
        udtBody.HourAngGeo = FracCirc(cLST.FixToLST(dblFix, False, blnValid) - udtBody.RAGeo + 180) - 180
        If Not blnValid Then Exit Sub
        'Convert to altitude azimuth
        udtBody.AzGeo = FracCirc(atn2D(sinD(udtBody.HourAngGeo), cosD(udtBody.HourAngGeo) * sinD(udtLocation.dblLatitude) - tanD(udtBody.DeclGeo) * cosD(udtLocation.dblLatitude)) + 180)
        udtBody.AltGeo = asinD(sinD(udtLocation.dblLatitude) * sinD(udtBody.DeclGeo) + cosD(udtLocation.dblLatitude) * cosD(udtBody.DeclGeo) * cosD(udtBody.HourAngGeo))
        'Correct for parallax
        dblLatGeo = atn2D(Square(0.99664719) * tanD(udtLocation.dblLatitude), 1)
        dblRho = (6378.14 + udtLocation.dblHeight / 1000) / 6378.14
        dblSinPar = sinD(365459.06 / udtBody.DistanceGeo)
        udtBody.HourAngTopo = atn2D(dblRho * cosD(dblLatGeo) * dblSinPar * sinD(udtBody.HourAngGeo), cosD(udtBody.DeclGeo) - dblRho * cosD(dblLatGeo) * dblSinPar * cosD(udtBody.HourAngGeo))
        If udtBody.HourAngTopo > 180 Then udtBody.HourAngTopo = udtBody.HourAngTopo - 360
        udtBody.DeclTopo = atn2D((sinD(udtBody.DeclGeo) - dblRho * sinD(dblLatGeo) * dblSinPar) * cosD(udtBody.HourAngTopo), cosD(udtBody.DeclGeo) - dblRho * cosD(dblLatGeo) * dblSinPar * cosD(udtBody.HourAngGeo))
        If udtBody.DeclTopo > 180 Then udtBody.DeclTopo = udtBody.DeclTopo - 360
        udtBody.RATopo = FracCirc(udtBody.RAGeo - udtBody.HourAngTopo)
        udtBody.HourAngTopo = udtBody.HourAngGeo + udtBody.HourAngTopo
        If System.Math.Abs(udtLocation.dblLatitude) < 0.5 Then
            udtBody.AzTopo = udtBody.AzGeo
        Else
            udtBody.AzTopo = FracCirc(atn2D(sinD(udtBody.HourAngTopo), cosD(udtBody.HourAngTopo) * sinD(udtLocation.dblLatitude) - tanD(udtBody.DeclTopo) * cosD(udtLocation.dblLatitude)) + 180)
        End If
        udtBody.AltTopo = asinD(sinD(udtLocation.dblLatitude) * sinD(udtBody.DeclTopo) + cosD(udtLocation.dblLatitude) * cosD(udtBody.DeclTopo) * cosD(udtBody.HourAngTopo))
        'Ecliptic coordinates
        udtBody.EclLongTopo = atn2D(cosD(dblEps) * sinD(udtBody.RATopo) + tanD(udtBody.DeclTopo) * sinD(dblEps), cosD(udtBody.RATopo))
        udtBody.EclDeclTopo = asinD(sinD(udtBody.DeclTopo) * cosD(dblEps) - cosD(udtBody.DeclTopo) * sinD(dblEps) * sinD(udtBody.RATopo))
        dblTheta = sinD(dblLatGeo) * sinD(udtBody.DeclTopo) + cosD(dblLatGeo) * cosD(udtBody.DeclTopo) * cosD(udtBody.HourAngGeo)
        If dblTheta > 0.999995 Then
            dblTheta = System.Math.Sqrt(Square(udtBody.HourAngGeo) * cosD((dblLatGeo + udtBody.DeclTopo) / 2) + Square(dblLatGeo - udtBody.DeclTopo))
        ElseIf dblTheta <= -1 Then
            dblTheta = 180
        Else
            dblTheta = acosD(dblTheta)
        End If
        udtBody.DistanceTopo = System.Math.Sqrt(Square(udtBody.DistanceGeo) + Square(dblRho * 6378.14) - 2 * udtBody.DistanceGeo * dblRho * 6378.14 * cosD(dblTheta))
        'Correct for refraction
        Call frmWeather.GetWeatherNow(dblFix, udtWeatherNow, blnValid) 'The weather affects the refraction
        If Not blnValid Then Exit Sub
        dblRefR = Refract(udtBody.AltTopo, True, udtWeatherNow, udtBody.RefrValid, blnValid)
        If Not blnValid Then Exit Sub
        If dblRefR = 90 Then
            udtBody.AltRefr = -90 'Too far below the horizon to calculate
        Else
            udtBody.AltRefr = udtBody.AltTopo + Refract(udtBody.AltTopo, True, udtWeatherNow, udtBody.RefrValid, blnValid)
            If Not blnValid Then Exit Sub
        End If
        If udtBody.RAGeo < 0 Or udtBody.RAGeo >= 360 Then
            Err.Raise(vbObjectError + 1, "cHBody.ConvCoords", "Invalid udtHBody.RAGeo: " & udtBody.RAGeo)
        End If
        If udtBody.DeclGeo < -90 Or udtBody.DeclGeo > 90 Then
            Err.Raise(vbObjectError + 1, "cHBody.ConvCoords", "Invalid udtHBody.DeclGeo: " & udtBody.DeclGeo)
        End If
        If udtBody.HourAngGeo <= -180 Or udtBody.HourAngGeo > 180 Then
            Err.Raise(vbObjectError + 1, "cHBody.ConvCoords", "Invalid udtHBody.HourAngGeo: " & udtBody.HourAngGeo)
        End If
        If udtBody.AzGeo < 0 Or udtBody.AzGeo >= 360 Then
            Err.Raise(vbObjectError + 1, "cHBody.ConvCoords", "Invalid udtHBody.AzGeo: " & udtBody.AzGeo)
        End If
        If udtBody.AltGeo < -90 Or udtBody.AltGeo > 90 Then
            Err.Raise(vbObjectError + 1, "cHBody.ConvCoords", "Invalid udtHBody.AltGeo: " & udtBody.AltGeo)
        End If
        If udtBody.HourAngTopo <= -180 Or udtBody.HourAngTopo > 180 Then
            Err.Raise(vbObjectError + 1, "cHBody.ConvCoords", "Invalid udtHBody.HourAngTopo: " & udtBody.HourAngTopo)
        End If
        If udtBody.DeclTopo < -90 Or udtBody.DeclTopo > 90 Then
            Err.Raise(vbObjectError + 1, "cHBody.ConvCoords", "Invalid udtHBody.DeclTopo: " & udtBody.DeclTopo)
        End If
        If udtBody.RATopo < 0 Or udtBody.RATopo >= 360 Then
            Err.Raise(vbObjectError + 1, "cHBody.ConvCoords", "Invalid udtHBody.RATopo: " & udtBody.RATopo)
        End If
        If udtBody.AzTopo < 0 Or udtBody.AzTopo >= 360 Then
            Err.Raise(vbObjectError + 1, "cHBody.ConvCoords", "Invalid udtHBody.AzTopo: " & udtBody.AzTopo)
        End If
        If udtBody.AltTopo < -90 Or udtBody.AltTopo > 90 Then
            Err.Raise(vbObjectError + 1, "cHBody.ConvCoords", "Invalid udtHBody.AltTopo: " & udtBody.AltTopo)
        End If
        If udtBody.EclLongTopo < 0 Or udtBody.EclLongTopo >= 360 Then
            Err.Raise(vbObjectError + 1, "cHBody.ConvCoords", "Invalid udtHBody.EclLongTopo: " & udtBody.EclLongTopo)
        End If
        If udtBody.EclDeclTopo < -90 Or udtBody.EclDeclTopo > 90 Then
            Err.Raise(vbObjectError + 1, "cHBody.ConvCoords", "Invalid udtHBody.EclDeclTopo: " & udtBody.EclDeclTopo)
        End If
        If udtBody.DistanceTopo <= 0 Then
            Err.Raise(vbObjectError + 1, "cHBody.ConvCoords", "Invalid udtHBody.DistanceTopo: " & udtBody.DistanceTopo)
        End If
        If udtBody.AltRefr < -90 Or udtBody.AltRefr > 90 Then
            Err.Raise(vbObjectError + 1, "cHBody.ConvCoords", "Invalid udtHBody.AltRefr: " & udtBody.AltRefr)
        End If
        Exit Sub
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            blnValid = False
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Sub
    Friend Function Refract(ByVal dblAltitude As Double, ByVal blnToApparent As Boolean, ByVal udtWeatherNow As WeatherNow, ByRef blnRefrValid As Boolean, ByRef blnValid As Boolean) As Double
        'Calculate the adjustment for refraction
        Dim dblRefract As Double
        Dim dblDiff As Double
        Dim intI As Short
        Dim strLine As String
        Dim varTemp As Object
        Dim intLines As Integer
        Dim strLines() As String
        Dim intLineNumber As Integer
        Dim cReadReesource As New clsReadResource
        Dim cSky As New clsSky

        On Error GoTo EH
        blnValid = True
        If dblAltitude < -90 Or dblAltitude > 90 Then
            Err.Raise(vbObjectError + 1, "cHBody.Refract", "Error in dlbAltitude: " & dblAltitude)
        End If
        If dblAltitude < 5 And Not blnRefractRead Then 'First time close to the horizon, read table
            ReDim strLines(0)
            Call cReadReesource.ReadResource(My.Resources.Refract, strLines, intLines, "_", "'", True, ",")
            intLineNumber = -1
            For intI = 0 To 15
                intLineNumber = intLineNumber + 1
                If intLineNumber >= intLines Then
                    Err.Raise(vbObjectError + 1, "cHBody.Refract", "Error in Refract file: File truncated at entry: " & intLineNumber - 1)
                End If
                If Not Main.GetValue(strLines(intLineNumber), "Double", -5, 5) Then
                    Err.Raise(vbObjectError + 2, "cHBody.Refract", "Error in refract reading near horizon refraction values")
                End If
                dblRefA(intI) = strLines(intLineNumber)
                intLineNumber = intLineNumber + 1
                If intLineNumber >= intLines Then
                    Err.Raise(vbObjectError + 1, "cHBody.Refract", "Error in Refract file: File truncated at entry: " & intLineNumber - 1)
                End If
                If Not Main.GetValue(strLines(intLineNumber), "Double", 0, 5) Then
                    Err.Raise(vbObjectError + 2, "cHBody.Refract", "Error in refract reading near horizon refraction values")
                End If
                dblRefR(intI) = strLines(intLineNumber)
            Next
            Erase strLines 'Free up memory
            Call cSky.spline(dblRefA, dblRefR, dblRefR2, 16)
            blnRefractRead = True
        End If
        blnRefrValid = True
        If blnToApparent Then 'Direct calculation
            If dblAltitude >= 4 Then
                'Formula from Astronomical Algorithms
                Refract = 1.02 / tanD(dblAltitude + 10.3 / (dblAltitude + 5.11)) / 60 * 273.15 / 283.15
            ElseIf dblAltitude < -1.626 - 1.1 * System.Math.Sqrt(System.Math.Abs(udtLocation.dblHeight) / 1000) Or dblAltitude < -6 Then
                blnRefrValid = False 'Too far below the horizon
                Refract = 0
            ElseIf dblAltitude <= -3.5 Then 'Approximate formular for extreme refraction
                Refract = (4.08 * dblAltitude + 0.8166 * Square(dblAltitude))
            Else
                Refract = 0
            End If
            If blnRefrValid And dblAltitude < 4.829444444 And dblAltitude > -4.1366 Then
                dblRefract = cSky.splint(dblRefA, dblRefR, dblRefR2, 16, dblAltitude) 'Interpolate table
                If dblAltitude < -3.5 Then
                    'Combine with the formula below
                    Refract = dblRefract * (dblAltitude + 4.1366) / 0.6366 + Refract * (-3.5 - dblAltitude) / 0.6366
                ElseIf dblAltitude < 4 Then
                    Refract = dblRefract 'Pure interpolation
                Else
                    'Combine with the formula above
                    Refract = dblRefract * (4.829444444 - dblAltitude) / 0.829444444 + Refract * (dblAltitude - 4) / 0.829444444
                End If
            End If
            'Multiply by factor derived from the weather
            If blnRefrValid Then Refract = Refract * udtWeatherNow.dblPressure / 1013.25 * 273.15 / (273.15 + udtWeatherNow.dblTemperature)
        Else 'Iterative reverse calculation
            dblRefract = 0
            dblDiff = 1
            blnRefrValid = True
            While dblDiff > 0.00001 And blnRefrValid
                Refract = Refract(dblAltitude - dblRefract, True, udtWeatherNow, blnRefrValid, blnValid)
                If Not blnValid Then Exit Function
                dblDiff = System.Math.Abs(Refract - dblRefract)
                dblRefract = Refract
            End While
            If Not blnRefrValid Then Refract = 0
        End If
        Exit Function
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            blnValid = False
        ElseIf Err.Number = vbObjectError + 2 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description & vbCrLf & "Sorry cannot continue")
            End
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Function
    Function EveningSight(ByVal strHBody As String, ByVal lngFix As Integer, ByRef blnValid As Boolean) As Boolean
        'Find out if the geocentric body is at less than 180 ecliptic elongation from the Sun at true midday
        'For the Moon, Evening sight means New Moon instead of old Moon
        Dim cSun As New clsSun
        Dim dblMidDay As Double
        Dim udtHBody As HBody
        Dim udtSun As HBody

        'On Error GoTo EH
        blnValid = True
        Call Meridian("Sun", lngFix, 0, dblMidDay, blnValid) 'Find true midday (meridian time)
        If Not blnValid Then Exit Function
        Call TrueHBody(strHBody, dblMidDay, udtHBody, blnValid) 'Position of body
        If Not blnValid Then Exit Function
        Call TrueHBody("Sun", dblMidDay, udtSun, blnValid) 'Position of Sun
        If Not blnValid Then Exit Function
        EveningSight = FracCirc(udtHBody.EclLong - udtSun.EclLong) < 180
        Exit Function
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            blnValid = False
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Function
    Friend Function ValidstrHBody(ByVal strHBody As String) As Boolean
        'Check the validity of the name of a heavenly body
        Dim intI As Short

        ValidstrHBody = True
        If Not blnStarRead Then 'First time, read table
            Call ReadHBody("Star", udtMercury, lngMoonLR, lngMoonB, udtStar)
            blnStarRead = True
        End If
        If strHBody <> "Sun" And strHBody <> "Moon" And strHBody <> "Mercury" And strHBody <> "Venus" And strHBody <> "Mars" And strHBody <> "Jupiter" And strHBody <> "Saturn" Then
            intI = 0
            While intI < intNStars - 1 And strHBody <> udtStar(intI).strName(0)
                intI = intI + 1
            End While
            If intI = intNStars And strHBody <> udtStar(intNStars - 1).strName(0) Then
                ValidstrHBody = False
            End If
        End If
    End Function
    Friend Sub RiseSet(ByVal strHBody As String, ByVal lngFix As Integer, ByVal blnSet As Boolean, ByRef dblRiseSetTime As Double, ByVal blnApparent As Boolean, ByRef blnNeverRises As Boolean, ByRef blnNeverSets As Boolean, ByRef blnValid As Boolean, Optional ByVal dblAltitude As Double = 0, Optional ByVal blnSeaLevelHorizon As Boolean = False, Optional ByVal dbldayphase As Double = 0)
        'Calculate Moon Rise or set
        'dblDayPhase defines the angle to the meridian considered the
        'middle of the day for defining the time limit for the result
        'that is half a rotation from that time
        Dim dblMidDay As Double 'Initial estimate of riseset based on dblDayPhase
        Dim dblStartday As Double 'Half a 'day' before initial estimate
        Dim dblEndday As Double 'Half a 'day' after initial estimate
        Dim intI As Double
        Dim intDayShift As Short 'Shift a day if it does not match
        Dim dblORS As Double 'Previous iteration
        Dim dblOORS As Double '2nd previous iteration
        Dim udtHBody As HBody
        Dim dblRiseSetTime2 As Double

        On Error GoTo EH
        blnValid = True
        If System.Math.Abs(lngFix) > FixMax + 2 Then 'allow leaway for calls near the limit
            Err.Raise(vbObjectError + 1, "cHBody.RiseSet", "Magnitude of lngFix too large: " & lngFix)
        End If
        If Not ValidstrHBody(strHBody) Then
            Err.Raise(vbObjectError + 1, "cHBody.RiseSet", "Object name not found: " & strHBody)
        End If
        'Find the middle of the day on which the riseset must fall
        Call Meridian("Sun", lngFix, dbldayphase, dblMidDay, blnValid, dbldayphase)
        If Not blnValid Then Exit Sub
        'Calculate the current RA of the object
        Call TrueHBody(frmMain.TranslateHBody(strHBody, False), dblMidDay, udtHBody, blnValid)
        If Not blnValid Then Exit Sub
        'Calculate the start and end of the day on which risest must fall
        Call Meridian("Sun", lngFix, -180 + dbldayphase, dblStartday, blnValid, -180 + dbldayphase)
        If Not blnValid Then Exit Sub
        Call Meridian("Sun", lngFix, 180 + dbldayphase, dblEndday, blnValid, 180 + dbldayphase)
        If Not blnValid Then Exit Sub
        If dblEndday < dblMidDay + 0.3 Or dblEndday > dblMidDay + 0.7 Then
            Err.Raise(vbObjectError + 1, "cHBody.RiseSet", "dblEndDay out of range (" & dblEndday & ") dblMidEay (" & dblMidDay & ")")
        End If
        If dblStartday > dblMidDay - 0.3 Or dblStartday < dblMidDay - 0.7 Then
            Err.Raise(vbObjectError + 1, "cHBody.RiseSet", "dblStartDay out of range (" & dblStartday & ") dblMidEay (" & dblMidDay & ")")
        End If
        dblRiseSetTime = dblMidDay
        'Calculate the rise/set time using the position of the body at the middle of the day
        dblRiseSetTime = RiseSet2(strHBody, 0, dblRiseSetTime, blnSet, blnApparent, blnNeverRises, blnNeverSets, blnSeaLevelHorizon, dblAltitude, blnValid)
        If Not blnValid Then Exit Sub
        'If the time is not within half a rotation of midday, adjust the day
        intDayShift = 0
        If dblRiseSetTime > dblEndday And dblRiseSetTime - dblEndday > dblStartday - dblRiseSetTime + 1 Then
            dblRiseSetTime = dblRiseSetTime - 1
            intDayShift = -1
        ElseIf dblRiseSetTime < dblStartday Then
            dblRiseSetTime = dblRiseSetTime + 1
            intDayShift = 1
        End If
        'Use the new time to calculate the position of the body for rise/set
        intI = 0
        While intI < 10 And (intI < 2 Or Square(dblRiseSetTime - dblORS) >= 1 / 1728000 * System.Math.Abs(dblORS - dblOORS))
            'Allow at least two iterations
            'Exit once it is clear that the next iteration will improve things by less that 1/20 s
            'Quit if over 10 iterations are required
            intI = intI + 1
            dblOORS = dblORS
            dblORS = dblRiseSetTime
            dblRiseSetTime = RiseSet2(strHBody, intDayShift, dblRiseSetTime, blnSet, blnApparent, blnNeverRises, blnNeverSets, blnSeaLevelHorizon, dblAltitude, blnValid)
            If Not blnValid Then Exit Sub
        End While
        If (Square(dblRiseSetTime - dblORS) >= 1 / 1728000 * System.Math.Abs(dblORS - dblOORS)) Then
            dblRiseSetTime = (dblRiseSetTime + dblORS) / 2
        End If
        'If there is a chance that this is not the closest value then calculate the alternative
        If dblRiseSetTime > dblEndday - 0.005 Or dblRiseSetTime < dblStartday + 0.005 Then 'the 0.005 is to allow for retrograde motion of planets
            If dblRiseSetTime > dblEndday Then
                dblRiseSetTime2 = dblRiseSetTime - 1
                intDayShift = intDayShift + 1
            ElseIf dblRiseSetTime < dblStartday Then
                dblRiseSetTime2 = dblRiseSetTime + 1
                intDayShift = intDayShift - 1
            End If
            intI = 0
            While intI < 10 And (intI < 2 Or Square(dblRiseSetTime2 - dblORS) >= 1 / 1728000 * System.Math.Abs(dblORS - dblOORS))
                'Allow at least two iterations
                'Exit once it is clear that the next iteration will improve things by less that 1/20 s
                'Quit if over 10 iterations are required
                intI = intI + 1
                dblOORS = dblORS
                dblORS = dblRiseSetTime2
                dblRiseSetTime2 = RiseSet2(strHBody, intDayShift, dblRiseSetTime2, blnSet, blnApparent, blnNeverRises, blnNeverSets, blnSeaLevelHorizon, dblAltitude, blnValid)
                If Not blnValid Then Exit Sub
            End While
            If (Square(dblRiseSetTime2 - dblORS) >= 1 / 1728000 * System.Math.Abs(dblORS - dblOORS)) Then
                dblRiseSetTime2 = (dblRiseSetTime2 + dblORS) / 2
            End If
            If System.Math.Abs(dblRiseSetTime2 - dblMidDay) < System.Math.Abs(dblRiseSetTime - dblMidDay) Then
                dblRiseSetTime = dblRiseSetTime2
            End If
        End If

        If dblRiseSetTime > dblEndday + 0.1 Or dblRiseSetTime < dblStartday - 0.1 Then
            Err.Raise(vbObjectError + 1, "cHBody.RiseSet", "dblRiseSetTime (" & dblRiseSetTime & ") out of range (" & dblStartday & " - " & dblEndday & ")")
        End If
        Exit Sub
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            blnValid = False
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Sub
    Friend Function RiseSet2(ByVal strHBody As String, ByVal intDayShift As Short, ByVal dblFix As Double, ByVal blnSet As Boolean, ByVal blnApparent As Boolean, ByRef blnNeverRises As Boolean, ByRef blnNeverSets As Boolean, ByVal blnSeaLevelHorizon As Boolean, ByVal dblAltitude As Double, ByRef blnValid As Boolean) As Double
        'Calculate the rise/set time with no iteration or further adjustment fo the day (Use RiseSet to find the right day)
        Dim dblTheta0 As Double 'Right ascension of meridian
        Dim udtHBody As HBody
        Dim dblH0 As Double 'Hour angle
        Dim dblDip As Double 'Angle of dip of the horizon
        Dim cLST As New clsLST
        Dim cHBody As New clsHBody
        Dim cSky As New clsSky
        Dim udtWeatherNow As WeatherNow 'Current weather for refraction calculation

        On Error GoTo EH
        blnValid = True
        If System.Math.Abs(dblFix) > FixMax + 2 Then 'allow leaway for calls near the limit
            Err.Raise(vbObjectError + 1, "cHBody.RiseSet", "Magnitude of dblFix too large: " & dblFix)
        End If
        If Not ValidstrHBody(strHBody) Then
            Err.Raise(vbObjectError + 1, "cHBody.RiseSet", "Object name not found: " & strHBody)
        End If
        dblTheta0 = cLST.FixToLST(dblFix - intDayShift, False, blnValid)
        Call cHBody.TrueHBody(frmMain.TranslateHBody(strHBody, False), dblFix - intDayShift, udtHBody, blnValid)
        If Not blnValid Then Exit Function
        Call frmWeather.GetWeatherNow(dblFix - intDayShift, udtWeatherNow, blnValid)
        If Not blnValid Then Exit Function
        If blnApparent Then
            If blnSeaLevelHorizon Then
                dblDip = -udtHBody.Radius + cSky.SeaLevelHorizon(udtWeatherNow, blnValid) 'Schaefer's method does not use this - cHBody.Refract(0, False, udtWeatherNow, udtHbody.RefrValid)
                If Not blnValid Then Exit Function
            Else
                dblDip = -udtHBody.Radius - cHBody.Refract(0, False, udtWeatherNow, udtHBody.RefrValid, blnValid) + dblAltitude
                If Not blnValid Then Exit Function
            End If
        Else
            dblDip = dblAltitude
        End If
        'Hour angle
        dblH0 = (sinD(dblDip) - sinD(udtLocation.dblLatitude) * sinD(udtHBody.DeclTopo)) / cosD(udtLocation.dblLatitude) / cosD(udtHBody.DeclTopo)
        If System.Math.Abs(dblH0) > 1000000.0# Then 'at pole deal with rounding errors
            blnNeverRises = udtHBody.AltRefr < dblDip Or Not udtHBody.RefrValid
            blnNeverSets = Not blnNeverRises
        Else
            blnNeverRises = dblH0 > 1
            blnNeverSets = dblH0 < -1
        End If
        If dblH0 < -1 Then
            dblH0 = -1
        ElseIf dblH0 > 1 Then
            dblH0 = 1
        End If
        If blnSet Then
            RiseSet2 = FracCirc2(udtHBody.RATopo - dblTheta0 + acosD(dblH0)) / 360 + dblFix
        Else
            RiseSet2 = FracCirc2(udtHBody.RATopo - dblTheta0 - acosD(dblH0)) / 360 + dblFix
        End If
        Exit Function
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            blnValid = False
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Function
    Friend Sub Meridian(ByVal strHBody As String, ByVal lngFix As Integer, ByVal dblPhase As Double, ByRef dblMeridianTime As Double, ByRef blnValid As Boolean, Optional ByVal dbldayphase As Double = 0)
        'Find when body crosses meridian + dblPhase for a particular day (lngFix as fixed radix) nearest the local mean midday + dbldayphase/360
        'dblPhase for Sun is 0 for noon and 180 for midnight at end of day
        Dim cLST As New clsLST
        Dim dblTheta0 As Double 'right ascension of meridian
        Dim udtHBody(3) As HBody
        Dim dblH As Double
        Dim dblY(3) As Double
        Dim dblAlpha As Double
        Dim cDeltaT As New clsDeltaT
        Dim cHBody As New clsHBody
        Dim intDayShift As Short
        Dim dblMidDay As Double 'Initial estimate of UTC time
        Dim dblMidDayDate As Double 'Radix date of initial estimate
        Dim dblNoon As Double
        Dim dblMeridianTime2 As Double

        On Error GoTo EH
        blnValid = True
        If Not ValidstrHBody(strHBody) Then
            Err.Raise(vbObjectError + 1, "cHBody.Meridian", "Object name not found: " & strHBody)
        End If
        If System.Math.Abs(lngFix) > FixMax + 2 Then
            'if converting to UTC then give a little more leaway and check at the end
            Err.Raise(vbObjectError + 1, "cHBody.Meridian", "Magnitude of lngFix too large: " & lngFix)
        End If
        If udtLocation.dblLongitude <= -180 Or udtLocation.dblLongitude > 180 Then
            'if converting to UTC then give a little more leaway and check at the end
            Err.Raise(vbObjectError + 1, "cHBody.Meridian", "Invalid longitude: " & udtLocation.dblLongitude)
        End If
        'Define the mean solar midday in UTC
        dblNoon = 0.5 - udtLocation.dblLongitude / 360
        'Define the time (UTC) to which the result must be closest
        dblMidDay = dblNoon + dbldayphase / 360
        dblMidDayDate = lngFix + dblMidDay
        intDayShift = 0
        'Find celestial longitude at meridian at mean solar midday + dbldayphase
        dblTheta0 = cLST.FixToLST(dblMidDayDate, False, blnValid)
        If Not blnValid Then
            Exit Sub
        End If
        'Determine the dayshift to a first approximation
        'Find the position of the body at mean solar midday + dbldayphase
        Call cHBody.TrueHBody(strHBody, dblMidDayDate, udtHBody(1), blnValid)
        If Not blnValid Then Exit Sub
        'First approximation (UTC) is RA - theta0 + phase from midday
        dblMeridianTime = (udtHBody(1).RATopo - dblTheta0 + dblPhase) / 360 + dblMidDay
        'Check to a first approximation how many days to shift
        intDayShift = -Int(dblMeridianTime + 0.5 - dblMidDay)
        Select Case intDayShift
            Case -1
                Call CopyHBody(udtHBody(1), udtHBody(2))
                Call cHBody.TrueHBody(strHBody, dblMidDayDate - 2, udtHBody(0), blnValid)
                If Not blnValid Then Exit Sub
                Call cHBody.TrueHBody(strHBody, dblMidDayDate - 1, udtHBody(1), blnValid)
                If Not blnValid Then Exit Sub
            Case 0
                Call cHBody.TrueHBody(strHBody, dblMidDayDate - 1, udtHBody(0), blnValid)
                If Not blnValid Then Exit Sub
                Call cHBody.TrueHBody(strHBody, dblMidDayDate + 1, udtHBody(2), blnValid)
                If Not blnValid Then Exit Sub
            Case 1
                Call CopyHBody(udtHBody(1), udtHBody(0))
                Call cHBody.TrueHBody(strHBody, dblMidDayDate + 1, udtHBody(1), blnValid)
                If Not blnValid Then Exit Sub
                Call cHBody.TrueHBody(strHBody, dblMidDayDate + 2, udtHBody(2), blnValid)
                If Not blnValid Then Exit Sub
            Case Else
                'Find the position of the body at mean solar midday + dbldayphase and for the days before, on and after
                Call cHBody.TrueHBody(strHBody, dblMidDayDate - 1 + intDayShift, udtHBody(0), blnValid)
                If Not blnValid Then Exit Sub
                Call cHBody.TrueHBody(strHBody, dblMidDayDate + intDayShift, udtHBody(1), blnValid)
                If Not blnValid Then Exit Sub
                Call cHBody.TrueHBody(strHBody, dblMidDayDate + 1 + intDayShift, udtHBody(2), blnValid)
                If Not blnValid Then Exit Sub
        End Select
        'Interpolate to increase accuracy
        dblY(0) = udtHBody(0).RATopo
        dblY(1) = udtHBody(1).RATopo
        dblY(2) = udtHBody(2).RATopo
        'Deal with discontinuity at 360
        If dblY(0) - dblY(1) > 180 Then
            dblY(0) = dblY(0) - 360
        ElseIf dblY(1) - dblY(0) > 180 Then
            dblY(0) = dblY(0) + 360 'Can happen in retrograde motion of planets
        End If
        If dblY(1) - dblY(2) > 180 Then
            dblY(2) = dblY(2) + 360
        ElseIf dblY(2) - dblY(1) > 180 Then
            dblY(2) = dblY(2) - 360
        End If
        dblAlpha = Interp(dblY, dblMeridianTime - dblMidDay + intDayShift + 1, 3, True)
        'Find celestial longitude at meridian at first approximation
        dblH = cLST.FixToLST(lngFix + dblMeridianTime + intDayShift, False, blnValid)
        dblH = FracCirc(dblH - dblPhase)
        If dblH - dblAlpha > 180 Then 'if the iteration causes a discontinuity
            dblH = dblH - 360
        ElseIf dblAlpha - dblH > 180 Then
            dblH = dblH + 360
        End If
        dblMeridianTime2 = dblMeridianTime - (dblH - dblAlpha) / 360 + intDayShift
        If dblMeridianTime2 - dblMidDay > 0.49 Then
            '0.49 rather than 0.5 allows for retrograde motion for planets
            'Allow forcing of Sun to end of day for EndOfDay calculations
            'calculate for the previous day
            Call cHBody.TrueHBody(strHBody, dblMidDayDate + intDayShift - 2, udtHBody(0), blnValid)
            If Not blnValid Then Exit Sub
            dblY(2) = dblY(1)
            dblY(1) = dblY(0)
            dblY(0) = udtHBody(0).RATopo
            'Deal with discontinuity at 360
            If dblY(0) - dblY(1) > 180 Then
                dblY(0) = dblY(0) - 360
            ElseIf dblY(1) - dblY(0) > 180 Then
                dblY(0) = dblY(0) + 360
            End If
            If dblY(1) - dblY(2) > 180 Then
                dblY(2) = dblY(2) + 360
            ElseIf dblY(2) - dblY(1) > 180 Then
                dblY(2) = dblY(2) - 360
            End If
            dblAlpha = Interp(dblY, dblMeridianTime - dblMidDay + 1 + intDayShift, 3, True)
            dblH = cLST.FixToLST(lngFix + dblMeridianTime + intDayShift - 1, False, blnValid)
            dblH = FracCirc(dblH - dblPhase)
            If dblH - dblAlpha > 180 Then 'if the iteration causes a discontinuity
                dblH = dblH - 360
            ElseIf dblAlpha - dblH > 180 Then
                dblH = dblH + 360
            End If
            dblMeridianTime = dblMeridianTime - (dblH - dblAlpha) / 360 - 1
            If dblMeridianTime > dblMidDay Then
                Err.Raise(vbObjectError + 1, "cHBody.Meridian", "dblMeridianTime out of range: " & dblMeridianTime & " lngFix " & lngFix)
            End If
            If dblMeridianTime2 - dblMidDay < dblMidDay - dblMeridianTime Then
                dblMeridianTime = dblMeridianTime2
            End If
        ElseIf dblMeridianTime2 - dblMidDay < -0.49 Then
            'calculate for the next day
            Call cHBody.TrueHBody(strHBody, dblMidDayDate + intDayShift + 2, udtHBody(2), blnValid)
            If Not blnValid Then Exit Sub
            dblY(0) = dblY(1)
            dblY(1) = dblY(2)
            dblY(2) = udtHBody(2).RATopo
            'Deal with discontinuity at 360
            If dblY(0) - dblY(1) > 180 Then
                dblY(0) = dblY(0) - 360
            ElseIf dblY(1) - dblY(0) > 180 Then
                dblY(0) = dblY(0) + 360
            End If
            If dblY(1) - dblY(2) > 180 Then
                dblY(2) = dblY(2) + 360
            ElseIf dblY(2) - dblY(1) > 180 Then
                dblY(2) = dblY(2) - 360
            End If
            dblAlpha = Interp(dblY, dblMeridianTime - dblMidDay + intDayShift + 1, 3, True)
            dblH = cLST.FixToLST(lngFix + dblMeridianTime + intDayShift + 1, False, blnValid)
            dblH = FracCirc(dblH - dblPhase)
            If dblH - dblAlpha > 180 Then 'if the iteration causes a discontinuity
                dblH = dblH - 360
            ElseIf dblAlpha - dblH > 180 Then
                dblH = dblH + 360
            End If
            dblMeridianTime = dblMeridianTime - (dblH - dblAlpha) / 360
            If dblMeridianTime - dblMidDay > dblMidDay - dblMeridianTime2 Then
                dblMeridianTime = dblMeridianTime2
            End If
        Else
            dblMeridianTime = dblMeridianTime2
        End If
        If dblMeridianTime > dblNoon + 0.7 + dbldayphase / 360 Or dblMeridianTime < dblNoon - 0.7 + dbldayphase / 360 Then
            Err.Raise(vbObjectError + 1, "cHBody.Meridian", "dblMeridianTime out of range: " & dblMeridianTime & " lngFix " & lngFix)
        End If
        dblMeridianTime = dblMeridianTime + lngFix
        Exit Sub
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            blnValid = False
        Else
            Err.Raise(Err.Number)
        End If
    End Sub
    Friend Function MagText(ByVal strHBody As String, ByRef blnValid As Boolean) As String
        'Report the Magnitude, sky brightness and the probability of visibility
        Dim udtHBody As HBody 'Parameters for heavenly body
        Dim dblMagn As Double 'Magnitude above the atmosphere
        Dim dblAppMag As Double 'Magnitude below the atmosphere
        Dim dblBSky As Double 'Brightness of the sky
        Dim dblKA As Double 'Extinction coefficient due to aerosols
        Dim dblKOz As Double 'Extinction coefficient due to ozone
        Dim dblKR As Double 'Extinction coefficient due to Raleigh scattering
        Dim dblKW As Double 'Extinction coefficient due to water
        Dim dblXA As Double 'Atmospheric path length for aerosols and water
        Dim dblXOz As Double 'Atmospheric path length for ozone
        Dim dblXG As Double 'Atmospheric path length for Raleigh scattering
        Dim dblP As Double 'Probability of visiblity
        Dim intPrec As Short 'Number of decimal places to report
        Dim dblAngle As Double 'Orientation of the Lunar crescent
        Dim dblSubtend As Double 'Angle subtended by the lunar crescent
        Dim cSky As New clsSky
        Dim cMoon As New clsMoon

        On Error GoTo EH
        blnValid = True
        Call TrueHBody(frmMain.TranslateHBody(strHBody, False), dblDate + dblTime, udtHBody, blnValid)
        MagText = ""
        If Not blnValid Then Exit Function
        If frmMain.TranslateHBody(strHBody, False) = "Moon" Then 'Calculate the sky's brightness using the position of the bright limb
            Call cMoon.BrightLimb(dblDate + dblTime, dblAngle, dblSubtend, udtHBody.AltTopo, udtHBody.AzTopo, blnValid)
            If Not blnValid Then Exit Function
        End If
        dblMagn = Magnitude(frmMain.TranslateHBody(strHBody, False), udtHBody, dblDate + dblTime, blnValid)
        If Not blnValid Then Exit Function
        If intLanguage = 0 Then
            MagText = frmMain.TranslateHBody(strHBody, True, True, True) & strTexts(intclsHBodyBase + 13 * intNLanguages + intLanguage) & " " & dblMagn.ToString(strFormat(lngPrecision + 1)) 'VB6.Format(dblMagn, strFormat(lngPrecision + 1))
            'magnitude above the atmosphere
        Else
            MagText = strTexts(intclsHBodyBase + 13 * intNLanguages + intLanguage) & " "
            If Left(dblMagn.ToString(strFormat(lngPrecision + 1)), 1) = "-" Then
                MagText = MagText & frmMain.TranslateHBody(strHBody, True, True, True) & " " & (-dblMagn).ToString(strFormat(lngPrecision + 1)) & "-" 'VB6.Format(dblMagn, strFormat(lngPrecision + 1))
            Else
                MagText = MagText & frmMain.TranslateHBody(strHBody, True, True, True) & " " & dblMagn.ToString(strFormat(lngPrecision + 1)) 'VB6.Format(dblMagn, strFormat(lngPrecision + 1))
            End If
        End If
        'MagText = strHBody & "'s magnitude above the atmosphere " & VB6.Format(dblMagn, strFormat(lngPrecision + 1))
        If udtHBody.RefrValid Then 'if it is not too far below the horizon
            dblAppMag = dblMagn + cSky.DeltaM(dblDate + dblTime, udtHBody.AltTopo, udtHBody.AzTopo, 2, blnValid)
            If Not blnValid Then Exit Function
            If intLanguage = 0 Or Not Left(dblAppMag.ToString(strFormat(lngPrecision + 1)), 1) = "-" Then
                MagText = MagText & vbCrLf & strTexts(intclsHBodyBase + 14 * intNLanguages + intLanguage) & " " & dblAppMag.ToString(strFormat(lngPrecision + 1))
            Else
                MagText = MagText & vbCrLf & strTexts(intclsHBodyBase + 14 * intNLanguages + intLanguage) & " " & (-dblAppMag).ToString(strFormat(lngPrecision + 1)) & "-"
            End If
            'MagText = MagText & vbCrLf & "From the ground " & VB6.Format(dblAppMag, strFormat(lngPrecision + 1))
            'Sky brightness
            dblBSky = cSky.BSky(dblDate + dblTime, udtHBody.AltRefr, udtHBody.AzTopo, 2, blnValid)
            If Not blnValid Then Exit Function
            intPrec = -Int(Log10(dblBSky)) + lngPrecision + 1
            If intPrec < 0 Then intPrec = 0
            If intLanguage = 0 Then
                MagText = MagText & vbCrLf & strTexts(intclsHBodyBase + 15 * intNLanguages + intLanguage) & " " & VB6.Format(dblBSky, strFormat(intPrec)) & " cd/m^2"
                'MagText = MagText & vbCrLf & "Sky brightness " & VB6.Format(dblBSky, strFormat(intPrec)) & " cd/m^2"
            Else
                MagText = MagText & vbCrLf & strTexts(intclsHBodyBase + 15 * intNLanguages + intLanguage) & VB6.Format(dblBSky, strFormat(intPrec)) & "cd/m^2"
            End If
            MagText = MagText & vbCrLf & "Lg(B) " & VB6.Format(Log10(dblBSky), strFormat(lngPrecision + 1))
            dblP = HBProbVis(strHBody, dblDate + dblTime, blnValid)
            If dblP <= 1.0E-20 Then
                intPrec = 0
            Else
                intPrec = -Int(Log10(dblP)) + lngPrecision - 1
            End If
            If dblP > 0.99 And dblP < 0.99999999 Then intPrec = -Int(Log10(1 - dblP)) + lngPrecision - 1
            If intPrec > 8 Then intPrec = 8
            If lngPrecision = 0 Then intPrec = 0
            MagText = MagText & vbCrLf & strTexts(intclsHBodyBase + 16 * intNLanguages + intLanguage) & " " & VB6.Format(dblP * 100, strFormat(intPrec)) & "%"
        Else
            MagText = MagText & vbCrLf & frmMain.TranslateHBody(strHBody, True, True, True) & " " & strTexts(intclsHBodyBase + 17 * intNLanguages + intLanguage)
        End If
            Exit Function
EH:
            If Err.Number = vbObjectError + 1 Then
                MsgBox("Error in " & Err.Source & ", " & Err.Description)
                blnValid = False
            Else
                Err.Raise(Err.Number)
            End If
    End Function
    Friend Function HBProbVis(ByVal strHBody As String, ByVal dblFix As Double, ByRef blnValid As Boolean) As Double
        'Calculate the probability of naked eye visibility
        Dim udtHBody As HBody
        Dim udtSun As HBody
        Dim dblMagn As Double 'Stellar magnitude
        Dim dblAppMag As Double 'Magnitude as seen through the atmosphere
        Dim dblBSky As Double 'Brightness of the sky in cd/m^2
        Dim dblKA As Double 'Extinction coefficient due to aerosols
        Dim dblKOz As Double 'Extinction coefficient due to ozone
        Dim dblKR As Double 'Extinction coefficient due to Raleigh scattering
        Dim dblKW As Double 'Extinction coefficient due to water
        Dim dblXA As Double 'Atmospheric path length for aerosols and water
        Dim dblXOz As Double 'Atmospheric path length for ozone
        Dim dblXG As Double 'Atmospheric path length for Raleigh scattering
        Dim dblP As Double 'Probability of visibility
        Dim dblSubtend As Double 'Angle subtended by the lunar crescent
        Dim dblSubtendOuter As Double 'Angle subtended by the outer perimeter of the lunar crescent
        Dim dblUsefulWidth As Double 'Width used by the eye to define an edge of an object
        Dim dblLogB As Double 'Log(10) sky brightness
        Dim dblAlpha As Double
        Dim dblSubtendInner As Double 'Angle subtended by the lunar terminator
        Dim dblPerimeter As Double 'Perimeter of object (Sun or Moon)
        Dim dblAngle As Double
        Dim dblAltitude As Double 'Altitude of object
        Dim dblAzimuth As Double 'Azimuth
        Dim dblAltRefr As Double 'Altitude corrected for refraction
        Dim cSky As New clsSky
        Dim cMoon As New clsMoon
        Dim dblFovMag As Double 'Foveal illuminance (within 6.5' of center)
        Dim dblPerMag As Double 'For Sun and Moon some of the light is effectively peripheral
        Const SFactor As Double = 1.0# 'was 2.4

        On Error GoTo EH
        blnValid = True
        'Calculate position of body
        Call TrueHBody(frmMain.TranslateHBody(strHBody, False), dblFix, udtHBody, blnValid)
        If Not blnValid Then Exit Function
        'Calculate position of Sun
        Call TrueHBody("Sun", dblFix, udtSun, blnValid)
        If Not blnValid Then Exit Function
        'Calculate magnitude
        dblMagn = Magnitude(frmMain.TranslateHBody(strHBody, False), udtHBody, dblFix, blnValid, dblFovMag, dblPerMag)
        If udtHBody.RefrValid Then
            If strHBody = "Moon" Then 'Find the altitude (refracted and unrefracted) and azimuth of the illuminated center
                Call cMoon.BrightLimb(dblFix, dblAngle, dblSubtend, dblAltitude, dblAzimuth, blnValid, False)
                If Not blnValid Then Exit Function
                Call cMoon.BrightLimb(dblFix, dblAngle, dblSubtend, dblAltRefr, dblAzimuth, blnValid, True)
                If Not blnValid Then Exit Function
            Else 'Use the center of the body
                dblAltitude = udtHBody.AltTopo
                dblAltRefr = udtHBody.AltRefr
                dblAzimuth = udtHBody.AzTopo
            End If
            'Calculate the magnitude through the atmosphere
            dblAppMag = dblMagn + cSky.DeltaM(dblFix, dblAltitude, dblAzimuth, 2, blnValid)
            If Not blnValid Then Exit Function
            'Calculate the brightness of the sky
            dblBSky = cSky.BSky(dblFix, dblAltitude, dblAzimuth, 2, blnValid)
            If Not blnValid Then Exit Function
            'Extinction coefficients
            Call cSky.GetK(dblFix, 2, udtSun.RATopo, udtSun.HourAngTopo, dblKA, dblKOz, dblKR, dblKW, dblAltRefr, blnValid)
            If Not blnValid Then Exit Function
            'Atmospheric path lengths
            Call cSky.GetX(dblFix, 2, 90 - dblAltitude, 90 - dblAltRefr, dblXA, dblXOz, dblXG, blnValid)
            If Not blnValid Then Exit Function
            Select Case strHBody
                Case "Sun"
                    HBProbVis = cSky.ProbVis(dblFix, udtHBody.AltTopo, udtHBody.AzTopo, dblFovMag + dblAppMag - dblMagn, dblPerMag + dblAppMag - dblMagn, dblKA, dblXA, blnValid)
                    If Not blnValid Then Exit Function
                Case "Moon"
                    'Reduce the crescent by more than Danjon suggests because the ends are fainter
                    'Outer circumference of the bright limb
                    If dblSubtend >= 180 Then
                        dblSubtendOuter = 180
                    Else 'Was reduced by a factor because of feint crescent ends but now the factor is 1
                        dblSubtendOuter = 180 - (180 - dblSubtend) * SFactor
                        If dblSubtendOuter < 0 Then dblSubtendOuter = 0
                    End If
                    dblUsefulWidth = cSky.UsefulWidth(dblBSky) 'Width used by the eye for defining an object
                    dblLogB = Log10(dblBSky)
                    dblAlpha = acosD(2 * udtHBody.Phase - 1) 'Phase in degrees
                    'Lenth of terminator that does not overlap the useful width of the bright limb
                    dblSubtendInner = (1 - Square((1 - udtHBody.Phase) * udtHBody.Radius / (udtHBody.Radius - dblUsefulWidth))) / (1 - Square(1 - udtHBody.Phase))
                    If dblSubtendInner <= 0 Then 'but not less than zero
                        dblSubtendInner = 0
                    Else
                        dblSubtendInner = asinD(System.Math.Sqrt(dblSubtendInner)) * 2
                    End If
                    If dblAlpha <= 90 Then 'do elliptic integral to find the inner distance on the terminator
                        dblPerimeter = System.Math.Abs(El2(tanD(180 - dblSubtendInner / 2), cosD(dblAlpha), 1, Square(cosD(dblAlpha))))
                    Else
                        dblPerimeter = System.Math.Abs(El2(tanD(dblSubtendInner / 2), cosD(dblAlpha), 1, Square(cosD(dblAlpha))))
                    End If
                    If dblPerimeter > PI * dblSubtendOuter / 360 Then
                        Err.Raise(vbObjectError + 1, "cHBody.HBProbVis", "Inner perimeter of Moon (" & dblPerimeter * 2 * udtHBody.Radius & ") is larger than the outer perimeter (" & udtHBody.Radius * PI * dblSubtendOuter / 180)
                    End If
                    dblPerimeter = udtHBody.Radius * (PI * dblSubtendOuter / 180 + 2 * dblPerimeter) 'Add the outer perimeter
                    HBProbVis = cSky.ProbVis(dblFix, udtHBody.AltTopo, udtHBody.AzTopo, dblFovMag + dblAppMag - dblMagn, dblPerMag + dblAppMag - dblMagn, dblKA, dblXA, blnValid)
                    If Not blnValid Then Exit Function
                Case Else
                    HBProbVis = cSky.ProbVis(dblFix, udtHBody.AltTopo, udtHBody.AzTopo, dblAppMag, 100000.0#, dblKA, dblXA, blnValid)
                    If Not blnValid Then Exit Function
            End Select
        Else
            HBProbVis = 0 'Below the horizon so not visible
        End If
        Exit Function
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            blnValid = False
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Function
    Friend Function Magnitude(ByVal strHBody As String, ByVal udtHBody As HBody, ByVal dblFix As Double, ByRef blnValid As Boolean, Optional ByRef dblFovMag As Double = 0, Optional ByRef dblPerMag As Double = 0) As Double
        'Calculate the magnitude as seen from above the atmosphere
        Dim dblRD As Double 'Distance from the Sun times distance from Earth
        Dim dblI As Double 'Phase and Saturn's axial inclination
        Dim intI As Short
        Dim intJ As Short
        Dim dblY(2) As Double 'Used for interpolation
        Dim intX0 As Short
        Dim dblDMS As Double 'Distance from the Moon to the Sun
        Dim udtSun As HBody
        'Parameters for Saturn's rings
        Dim dblT As Double 'Julian centuries from J2000 used for clculating the orientation of Saturn's rings
        Dim dblB As Double 'Saturncentric latitude of the Earth
        Dim dblA As Double 'Major axis of outer B ring
        Dim dblBB As Double 'Minor axis of outer B ring and Saturncentric latitude of the Sun
        Dim dblL As Double 'Heliocentric longitude of Saturn
        Dim dblOmega As Double 'Longitude of Saturn's ascending node
        Dim dblU1 As Double 'Saturncentric longitude of the Sun
        Dim dblU2 As Double 'Saturncentric longitude of the Earth
        Dim dblDU As Double 'Satruncentric elongation of the Earth
        Dim udtscnd As HBody 'Parameters for body
        Dim dblPenumbral As Double 'Amount of Sun or Moon in penumbral eclipse
        Dim dblUmbral As Double 'Amount of Sun or Moon in umbral eclipse
        Dim dblFracVisible As Double 'Fraction of Sun or Moon visible during an eclipse
        Dim dblA1 As Double 'Parameters for calculating the fraction visible during an eclipse
        Dim dblA2 As Double
        Dim strLines() As String 'For reading Moon magnitude data
        Dim intLines As Integer
        Dim intLineNumber As Integer
        Dim dblRUmbra As Double
        Dim dblRPenumbra As Double
        Dim cReadResource As New clsReadResource
        Dim cSun As New clsSun

        On Error GoTo EH
        blnValid = True
        Select Case strHBody
            Case "Sun"
                Magnitude = -26.73 + 5 * Log10(udtHBody.DistanceTopo / AU)
                'Test for eclipse
                Call TrueHBody("Moon", dblFix, udtscnd, blnValid)
                If Not blnValid Then Exit Function
                dblUmbral = 0
                dblPenumbral = 0
                If udtscnd.ElongationTopo < udtscnd.Radius + udtHBody.Radius Then
                    dblPenumbral = (udtscnd.Radius + udtHBody.Radius - udtscnd.ElongationTopo) / 2 / udtHBody.Radius
                    If udtscnd.ElongationTopo < System.Math.Abs(udtscnd.Radius - udtHBody.Radius) Then
                        'Positive is total, negative is annular
                        dblUmbral = (udtscnd.Radius - udtHBody.Radius - udtscnd.ElongationTopo) / 2 / udtHBody.Radius
                    End If
                End If
                If dblUmbral > 0 Then 'Total eclipse
                    dblFracVisible = 0.00000001 'Very approximate value for the corona
                ElseIf dblUmbral < 0 Then  'Annular
                    dblFracVisible = Square((udtHBody.Radius - udtscnd.Radius) / udtHBody.Radius)
                    If dblFracVisible < 0.00000001 Then dblFracVisible = 0.00000001
                ElseIf dblPenumbral > 0 Then 'Calculate the portion covered
                    dblA1 = 2 * acosD((Square(udtHBody.Radius) + Square(udtscnd.ElongationTopo) - Square(udtscnd.Radius)) / 2 / udtHBody.Radius) / RADCON
                    dblA2 = 2 * acosD((Square(udtscnd.Radius) + Square(udtscnd.ElongationTopo) - Square(udtHBody.Radius)) / 2 / udtscnd.Radius) / RADCON
                    dblFracVisible = 1 - (Square(udtHBody.Radius) * (dblA1 - System.Math.Sin(dblA1)) + Square(udtscnd.Radius) * (dblA2 - System.Math.Sin(dblA2))) / Square(udtHBody.Radius) / 2 / PI
                    If dblFracVisible < 0.00000001 Then dblFracVisible = 0.00000001
                Else
                    dblFracVisible = 1
                End If
                If dblFracVisible > 1 Or dblFracVisible < 0.00000001 Then
                    Err.Raise(vbObjectError + 1, "cHBody.Magnitude", "dblFracVisible out of range: " & dblFracVisible)
                End If
                Magnitude = Magnitude - System.Math.Log(dblFracVisible) / NATTOMAG
                dblFovMag = Magnitude + 0.29 'Region within 6.5' of focus
                dblPerMag = Magnitude + 0.04 'Region outside 6.5'
            Case "Moon"
                'Calculate the magnitude of the Moon as seen from above the atmosphere
                'Moon's phase in degrees
                dblI = acosD(2 * udtHBody.Phase - 1)
                If Not blnMoonMagRead Then 'Read magnitude data precalculated using the Hapke formula
                    ReDim strLines(0)
                    Call cReadResource.ReadResource(My.Resources.MoonMag, strLines, intLines, "_", "'", True, ",")
                    intLineNumber = -1
                    For intI = 0 To 180
                        intLineNumber = intLineNumber + 1
                        If intLineNumber >= intLines Then
                            Err.Raise(vbObjectError + 1, "clsHBody.Magnitude", "Error in MoonMag file: File truncated at entry: " & intLineNumber - 1)
                        End If
                        If Not Main.GetValue(strLines(intLineNumber), "Double", 0, 180, True, False) Then
                            Err.Raise(vbObjectError + 1, "clsDeltaT.DeltaT", "Invalid phase angle in file MoonMag, entry " & intI & ": " & strLines(intLineNumber))
                        End If
                        For intJ = 0 To 2
                            intLineNumber = intLineNumber + 1
                            If intLineNumber >= intLines Then
                                Err.Raise(vbObjectError + 1, "clsHBody.Magnitude", "Error in MoonMag file: File truncated at file record: " & intLineNumber - 1)
                            End If
                            If Not Main.GetValue(strLines(intLineNumber), "Double", -20, 25, False, False) Then
                                Err.Raise(vbObjectError + 1, "clsDeltaT.DeltaT", "Invalid magnitude in file MoonMag at file record " & intI & ": " & strLines(intLineNumber))
                            End If
                            dblMoonMag(intJ, intI) = strLines(intLineNumber)
                        Next
                    Next
                    Erase strLines 'Free up memory
                End If
                'Interpolate magnitude from the table
                intX0 = Int(dblI) - 0.5
                If intX0 < 0 Then
                    dblY(0) = dblMoonMag(0, 1)
                    dblY(1) = dblMoonMag(0, 0)
                    dblY(2) = dblMoonMag(0, 1)
                Else
                    If intX0 > 178 Then intX0 = 178
                    dblY(0) = dblMoonMag(0, intX0)
                    dblY(1) = dblMoonMag(0, intX0 + 1)
                    dblY(2) = dblMoonMag(0, intX0 + 2)
                End If
                Call TrueHBody("Sun", dblDate + dblTime, udtSun, blnValid)
                If Not blnValid Then Exit Function
                'Adjust for the distance between the Sun and the Moon
                dblDMS = System.Math.Sqrt(Square(udtHBody.DistanceTopo) + Square(udtSun.DistanceTopo) - 2 * udtHBody.DistanceTopo * udtSun.DistanceTopo * cosD(udtHBody.ElongationTopo)) / 149597870
                If dblDMS < 0.9 Or dblDMS > 1.1 Then
                    Err.Raise(vbObjectError + 1, "cHBody.Magnitude", "Invalid Moon-Sun distnce " & dblDMS)
                End If
                Magnitude = Interp(dblY, dblI - intX0, 3) + 5 * Log10(udtHBody.DistanceTopo / 384400 * dblDMS)
                'Darken during lunar eclipse
                dblUmbral = 0
                dblPenumbral = 0
                dblRUmbra = udtHBody.RadiusGeo * 3.6711 * (udtSun.DistanceGeo * udtHBody.DistanceGeo * _
                    udtHBody.RadiusGeo * 3.6711 - udtHBody.DistanceGeo * udtSun.RadiusGeo * _
                    udtSun.DistanceGeo) / udtSun.DistanceGeo / udtHBody.RadiusGeo / 3.6711 / _
                    udtHBody.DistanceGeo
                dblRPenumbra = udtHBody.RadiusGeo * 3.6711 * (udtSun.DistanceGeo * udtHBody.DistanceGeo * _
                    udtHBody.RadiusGeo * 3.6711 + udtHBody.DistanceGeo * udtSun.RadiusGeo * _
                    udtSun.DistanceGeo) / udtSun.DistanceGeo / udtHBody.RadiusGeo / 3.6711 / _
                    udtHBody.DistanceGeo
                If Math.Abs(udtHBody.ElongationGeo - 180) < dblRPenumbra + udtHBody.Radius Then
                    dblPenumbral = (dblRPenumbra + udtHBody.Radius - Math.Abs(udtHBody.ElongationGeo - 180)) / 2 / udtHBody.Radius
                    If Math.Abs(udtHBody.ElongationGeo - 180) < dblRUmbra + udtHBody.Radius Then
                        dblUmbral = (dblRUmbra + udtHBody.Radius - Math.Abs(udtHBody.ElongationGeo - 180)) / 2 / udtHBody.Radius
                    End If
                    If dblPenumbral < 0.1 Then 'smooth the transition between eclipsed and uneclipsed
                        Magnitude += 9.4 * Math.Exp(-4.3 * (2 - dblPenumbral)) * dblPenumbral * 10
                    ElseIf dblUmbral < 1 Then
                        Magnitude += 9.4 * Math.Exp(-4.3 * (2 - dblPenumbral))
                        'See N. Hernitschek, et al., Appl. Optics, 47, H62 (2008).
                    Else
                        Magnitude += 9.4 * Math.Exp(-4.3 * (1 - dblPenumbral + dblUmbral)) + 14 * ((dblUmbral - 1) - (dblUmbral - 1) * (dblUmbral - 1))
                    End If
                End If
                    If intX0 < 0 Then
                        dblY(0) = dblMoonMag(1, 1)
                        dblY(1) = dblMoonMag(1, 0)
                        dblY(2) = dblMoonMag(1, 1)
                    Else
                        If intX0 > 178 Then intX0 = 178
                        dblY(0) = dblMoonMag(1, intX0)
                        dblY(1) = dblMoonMag(1, intX0 + 1)
                        dblY(2) = dblMoonMag(1, intX0 + 2)
                    End If
                    'Magnitude arising within 6.5' of focus
                    dblFovMag = Interp(dblY, dblI - intX0, 3) + 5 * Log10(udtHBody.DistanceTopo / 384400 * dblDMS)
                    If intX0 < 0 Then
                        dblY(0) = dblMoonMag(2, 1)
                        dblY(1) = dblMoonMag(2, 0)
                        dblY(2) = dblMoonMag(2, 1)
                    Else
                        If intX0 > 178 Then intX0 = 178
                        dblY(0) = dblMoonMag(2, intX0)
                        dblY(1) = dblMoonMag(2, intX0 + 1)
                        dblY(2) = dblMoonMag(2, intX0 + 2)
                    End If
                    'Region outside 6.5' of focus
                    dblPerMag = Interp(dblY, dblI - intX0, 3) + 5 * Log10(udtHBody.DistanceTopo / 384400 * dblDMS)
            Case "Mercury", "Venus", "Mars", "Jupiter", "Saturn"
                    'Planet's phase in degrees
                    dblI = acosD(2 * udtHBody.Phase - 1)
                    'Planet's distance from the Sun times distance to planet in AU^2
                    dblRD = System.Math.Abs(sinD(udtHBody.ElongationTopo) * udtHBody.DistanceTopo / sinD(180 - udtHBody.ElongationTopo - dblI) * udtHBody.DistanceTopo / AU / AU)
                    Select Case strHBody
                        Case "Mercury"
                            Magnitude = 1.16 + 5 * Log10(dblRD) + (dblI - 50) * (0.02838 + (dblI - 50) * 0.0001023)
                        Case "Venus"
                            Magnitude = -4.0# + 5 * Log10(dblRD) + dblI * (0.01322 + dblI * dblI * 0.0000004247)
                        Case "Mars"
                            Magnitude = -1.3 + 5 * Log10(dblRD) + dblI * 0.01486
                        Case "Jupiter"
                            Magnitude = -8.93 + 5 * Log10(dblRD)
                        Case "Saturn"
                            'Adjust for the rings
                            dblT = ToJ2000(dblDate + dblTime, blnValid)
                            If Not blnValid Then Exit Function
                            dblI = 28.075216 - 0.012998 * (dblT - 0.000004 * dblT)
                            dblOmega = 169.50847 + 1.394681 * (dblT + 0.000412 * dblT)
                            dblB = asinD(sinD(dblI) * cosD(udtHBody.EclDecl) * sinD(udtHBody.EclLong - dblOmega) - cosD(dblI) * sinD(udtHBody.EclDecl))
                            dblA = 375.35 / 3600 / udtHBody.DistanceGeo * AU
                            dblBB = dblA * sinD(System.Math.Abs(dblB))
                            dblL = udtSaturnSave.L - 0.01759 / udtSaturnSave.R
                            dblBB = dblBB - 0.000764 * cosD(udtSaturnSave.L - 113.6655 - 0.8771 * dblT) / udtSaturnSave.R
                            dblU1 = atn2D(sinD(dblI) * sinD(dblBB) + cosD(dblI) * cosD(dblBB) * sinD(dblL - dblOmega), cosD(dblBB) * cosD(dblL - dblOmega))
                            dblU2 = atn2D(sinD(dblI) * sinD(udtHBody.EclDecl) + cosD(dblI) * cosD(udtHBody.EclDecl) * sinD(udtHBody.EclLong - dblOmega), cosD(udtHBody.EclDecl) * cosD(udtHBody.EclLong - dblOmega))
                            If dblU1 - dblU2 < -180 Then 'If dblU1 and dblU2 are either side of 0 then adjust them
                                dblU1 = dblU1 + 360
                            ElseIf dblU1 - dblU2 > 180 Then
                                dblU2 = dblU2 + 360
                            End If
                            dblDU = System.Math.Abs(dblU1 - dblU2)
                            Magnitude = -8.68 + 5 * Log10(dblRD) + 0.044 * System.Math.Abs(dblDU) - 2.6 * sinD(System.Math.Abs(dblB)) + 1.25 * Square(sinD(dblB))
                        Case Else
                            Magnitude = 0
                    End Select
                    dblFovMag = Magnitude 'All foveal
                    dblPerMag = 30 'None peripheral
            Case Else
                    intI = 0
                    While intI < intNStars - 1 And strHBody <> udtStar(intI).strName(0)
                        intI = intI + 1
                    End While
                    If strHBody <> udtStar(intI).strName(0) Then
                        Err.Raise(vbObjectError + 1, "cHBody.Magnitude", "Invalid strHBody " & strHBody)
                        End
                    End If
                    Magnitude = udtStar(intI).dblMag + 5 * Log10(udtHBody.DistanceGeo / udtStar(intI).dblDist / 30856800000000.0#)
                    dblFovMag = Magnitude 'All foveal
                    dblPerMag = 30 'None peripheral
        End Select
        Exit Function
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            blnValid = False
        Else
            Err.Raise(Err.Number)
        End If
    End Function
    Function El2(ByVal dblX As Double, ByVal dblQQC As Double, ByVal dblAA As Double, ByVal dblBB As Double) As Double
        'Elliptic integral used to calculation the length of the lunar terminator
        Const CA As Double = 0.0003
        Const CB As Double = 1000000000.0#
        Dim dblA As Double
        Dim dblB As Double
        Dim dblC As Double
        Dim dblD As Double
        Dim dblE As Double
        Dim dblF As Double
        Dim dblG As Double
        Dim dblEM As Double
        Dim dblEye As Double
        Dim dblP As Double
        Dim dblQC As Double
        Dim dblY As Double
        Dim dblZ As Double
        Dim dblL As Short
        Dim blnDone As Boolean

        If dblX = 0 Then
            El2 = 0
        ElseIf dblQQC <> 0 Then
            dblQC = dblQQC
            dblA = dblAA
            dblB = dblBB
            dblC = dblX * dblX
            dblD = 1 + dblC
            dblP = System.Math.Sqrt((1 + dblC * dblQC * dblQC) / dblD)
            dblD = dblX / dblD
            dblC = dblD / (dblP + dblP)
            dblEye = dblA
            dblZ = dblEye - dblB
            dblA = 0.5 * (dblB + dblA)
            dblY = System.Math.Abs(1 / dblX)
            dblF = 0
            dblL = 0
            dblEM = 1
            dblQC = System.Math.Abs(dblQC)
            blnDone = False
            While Not blnDone
                dblB = dblB + dblEye * dblQC
                dblE = dblEM * dblQC
                dblG = dblE / dblP
                dblD = dblD + dblF * dblG
                dblF = dblC
                dblEye = dblA
                dblP = dblP + dblG
                dblC = 0.5 * (dblD / dblP + dblC)
                dblG = dblEM
                dblEM = dblEM + dblQC
                dblA = 0.5 * (dblB / dblEM + dblA)
                dblY = dblY - dblE / dblY
                If dblY = 0 Then dblY = System.Math.Sqrt(dblE) * CB
                If System.Math.Abs(dblG - dblQC) <= CA * dblG Then
                    blnDone = True
                Else
                    dblQC = System.Math.Sqrt(dblE) * 2
                    dblL = dblL * 2
                    If dblY < 0 Then dblL = dblL + 1
                End If
            End While
            If dblY < 0 Then dblL = dblL + 1
            dblE = (System.Math.Atan(dblEM / dblY) + PI * dblL) * dblA / dblEM
            If dblX < 0 Then dblE = -dblE
            El2 = dblE + dblC * dblZ
        Else
            MsgBox("Bad dblQQC in El2.")
        End If
    End Function
    Friend Function EclipticCoordinates(ByVal strHBody As String, ByRef blnValid As Boolean) As String
        'Return the ecliptic coordinates including ecliptic elongation (orech rishon) illumination
        'and phase angle as string. For the Moon, the simplified geocentric illumination is also
        'reported.
        Dim udtHBody As HBody

        On Error GoTo EH
        blnValid = True
        EclipticCoordinates = ""
        'Calculate the parameters of the body
        Call TrueHBody(frmMain.TranslateHBody(strHBody, False), dblDate + dblTime, udtHBody, blnValid)
        If Not blnValid Then Exit Function
        If intLanguage = 0 Then
            EclipticCoordinates = frmMain.TranslateHBody(strHBody, True, True, True) & strTexts(intclsHBodyBase + 18 * intNLanguages + intLanguage)
        Else
            EclipticCoordinates = strTexts(intclsHBodyBase + 18 * intNLanguages + intLanguage) & frmMain.TranslateHBody(strHBody, True, True, True)
        End If
        EclipticCoordinates = EclipticCoordinates & " " & strAngle(udtHBody.EclLong, blnValid, CShort(lngPrecision)) & vbCrLf
        'EclipticCoordinates = strHBody & "'s geocentric ecliptic coordinates" & vbCrLf & "Longitude " & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & VB6.Format(udtDms.dblSeconds, strFormat(lngPrecision)) & """" & vbCrLf
        EclipticCoordinates = EclipticCoordinates & strTexts(intclsHBodyBase + 20 * intNLanguages + intLanguage) & " "
        'EclipticCoordinates = EclipticCoordinates & "Declination "
        EclipticCoordinates = EclipticCoordinates & strAngle(udtHBody.EclDecl, blnValid, CShort(lngPrecision))
        If strHBody <> "Sun" Then 'Don't give elongation for the Sun as it is zero by definition
            EclipticCoordinates = EclipticCoordinates & vbCrLf & strTexts(intclsHBodyBase + 21 * intNLanguages + intLanguage) & " " & strAngle(udtHBody.EclElong, blnValid, CShort(lngPrecision))
            'EclipticCoordinates = EclipticCoordinates & vbCrLf & "Geocentric ecliptic elongation " & strAngle(udtHBody.EclElong, blnValid, CShort(lngPrecision))
        End If
        If udtHBody.DistanceGeo < 10000000000.0# Then 'If not a fixed star show the topocentric coordinates
            If intLanguage = 0 Then
                EclipticCoordinates = EclipticCoordinates & vbCrLf & frmMain.TranslateHBody(strHBody, True, True, True) & strTexts(intclsHBodyBase + 22 * intNLanguages + intLanguage)
            Else
                EclipticCoordinates = EclipticCoordinates & vbCrLf & strTexts(intclsHBodyBase + 22 * intNLanguages + intLanguage) & frmMain.TranslateHBody(strHBody, True, True, True)
            End If
            EclipticCoordinates = EclipticCoordinates & vbCrLf & strTexts(intclsHBodyBase + 19 * intNLanguages + intLanguage) & " " & strAngle(udtHBody.EclLongTopo, blnValid, CShort(lngPrecision)) & vbCrLf
            'EclipticCoordinates = EclipticCoordinates & vbCrLf & strHBody & "'s topocentric ecliptic coordinates" & vbCrLf & "Longitude " & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & VB6.Format(udtDms.dblSeconds, strFormat(lngPrecision)) & """" & vbCrLf
            If Not blnValid Then Exit Function
            EclipticCoordinates = EclipticCoordinates & strTexts(intclsHBodyBase + 20 * intNLanguages + intLanguage) & " "
            'EclipticCoordinates = EclipticCoordinates & "Declination "
            EclipticCoordinates = EclipticCoordinates & strAngle(udtHBody.EclDeclTopo, blnValid, CShort(lngPrecision))
            If strHBody <> "Sun" Then 'Don't give elongation for the Sun as it is zero by definition
                EclipticCoordinates = EclipticCoordinates & vbCrLf & strTexts(intclsHBodyBase + 23 * intNLanguages + intLanguage) & " " & strAngle(udtHBody.EclElongTopo, blnValid, CShort(lngPrecision))
                'EclipticCoordinates = EclipticCoordinates & vbCrLf & "Topocentric ecliptic elongation " & strAngle(udtHBody.EclElongTopo, blnValid, CShort(lngPrecision))
                If Not blnValid Then Exit Function
            End If
        End If
        If strHBody = "Moon" Then EclipticCoordinates = EclipticCoordinates & vbCrLf & strTexts(intclsHBodyBase + 24 * intNLanguages + intLanguage) & " " & VB6.Format((1 - cosD(udtHBody.ElongationGeo)) * 50, strFormat(lngPrecision + 2)) & "% (" & strAngle(udtHBody.ElongationGeo, blnValid, CShort(lngPrecision)) & ")"
        'If strHBody = "Moon" Then EclipticCoordinates = EclipticCoordinates & vbCrLf & "Simple geocentric illumination " & VB6.Format((1 - cosD(udtHBody.ElongationGeo)) * 50, strFormat(lngPrecision + 2)) & "% (" & strAngle(udtHBody.ElongationGeo, blnValid, CShort(lngPrecision)) & ")"
        If Not blnValid Then Exit Function
        EclipticCoordinates = EclipticCoordinates & vbCrLf & strTexts(intclsHBodyBase + 25 * intNLanguages + intLanguage) & " " & VB6.Format(udtHBody.Phase * 100, strFormat(lngPrecision + 2)) & "% (" & strAngle(acosD(1 - 2 * udtHBody.Phase), blnValid, CShort(lngPrecision)) & ")"
        'EclipticCoordinates = EclipticCoordinates & vbCrLf & "Topocentric illumination " & VB6.Format(udtHBody.Phase * 100, strFormat(lngPrecision + 2)) & "% (" & strAngle(acosD(1 - 2 * udtHBody.Phase), blnValid, CShort(lngPrecision)) & ")"
        If Not blnValid Then Exit Function
        Exit Function
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            blnValid = False
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Function
    Friend Function EquatorialCoordinates(ByVal strHBody As String, ByRef blnValid As Boolean) As String
        'Return equatorial coordinates as string
        Dim udtHBody As HBody
        Dim udtDms As DMS
        Dim cDMS As New clsDMS

        On Error GoTo EH
        blnValid = True
        EquatorialCoordinates = ""
        Call TrueHBody(frmMain.TranslateHBody(strHBody, False), dblDate + dblTime, udtHBody, blnValid)
        If Not blnValid Then Exit Function
        Call cDMS.ToDMS(udtHBody.RAGeo / 15, udtDms)
        If intLanguage = 0 Then
            EquatorialCoordinates = frmMain.TranslateHBody(strHBody, True, True, True) & strTexts(intclsHBodyBase + 26 * intNLanguages + intLanguage)
        Else
            EquatorialCoordinates = strTexts(intclsHBodyBase + 26 * intNLanguages + intLanguage) & frmMain.TranslateHBody(strHBody, True, True, True)
        End If
        EquatorialCoordinates = EquatorialCoordinates & vbCrLf & strTexts(intclsHBodyBase + 27 * intNLanguages + intLanguage) & " " & udtDms.intDegreesHours & strTexts(intListclsMoonWriteDMSTimeBase + intLanguage) & udtDms.intMinutes & strTexts(intListclsMoonWriteDMSTimeBase + intNLanguages + intLanguage) & VB6.Format(udtDms.dblSeconds, strFormat(lngPrecision + 1)) & strTexts(intListclsMoonWriteDMSTimeBase + 2 * intNLanguages + intLanguage) & vbCrLf
        'EquatorialCoordinates = strHBody & "'s geocentric equatorial coordinates" & vbCrLf & "Right ascension " & udtDms.intDegreesHours & "h" & udtDms.intMinutes & "m" & VB6.Format(udtDms.dblSeconds, strFormat(lngPrecision + 1)) & "s" & vbCrLf
        EquatorialCoordinates = EquatorialCoordinates & "              = " & strAngle(udtHBody.RAGeo, blnValid, CShort(lngPrecision)) & vbCrLf
        Call cDMS.ToDMS(udtHBody.DeclGeo, udtDms)
        EquatorialCoordinates = EquatorialCoordinates & strTexts(intclsHBodyBase + 20 * intNLanguages + intLanguage) & " "
        'EquatorialCoordinates = EquatorialCoordinates & "Declination "
        EquatorialCoordinates = EquatorialCoordinates & strAngle(udtHBody.DeclGeo, blnValid, CShort(lngPrecision)) & vbCrLf
        If udtHBody.DistanceGeo < 10000000000.0# Then
            Call cDMS.ToDMS(udtHBody.RATopo / 15, udtDms)
            If intLanguage = 0 Then
                EquatorialCoordinates = EquatorialCoordinates & frmMain.TranslateHBody(strHBody, True, True, True) & strTexts(intclsHBodyBase + 28 * intNLanguages + intLanguage)
            Else
                EquatorialCoordinates = EquatorialCoordinates & strTexts(intclsHBodyBase + 28 * intNLanguages + intLanguage) & frmMain.TranslateHBody(strHBody, True, True, True)
            End If
            EquatorialCoordinates = EquatorialCoordinates & vbCrLf & strTexts(intclsHBodyBase + 27 * intNLanguages + intLanguage) & " " & udtDms.intDegreesHours & strTexts(intListclsMoonWriteDMSTimeBase + intLanguage) & udtDms.intMinutes & strTexts(intListclsMoonWriteDMSTimeBase + intNLanguages + intLanguage) & VB6.Format(udtDms.dblSeconds, strFormat(lngPrecision + 1)) & strTexts(intListclsMoonWriteDMSTimeBase + 2 * intNLanguages + intLanguage) & vbCrLf
            'EquatorialCoordinates = EquatorialCoordinates & strHBody & "'s topocentric equatorial coordinates" & vbCrLf & "Right ascension " & udtDms.intDegreesHours & "h" & udtDms.intMinutes & "m" & VB6.Format(udtDms.dblSeconds, strFormat(lngPrecision + 1)) & "s" & vbCrLf
            EquatorialCoordinates = EquatorialCoordinates & "              = " & strAngle(udtHBody.RATopo, blnValid, CShort(lngPrecision)) & vbCrLf
            EquatorialCoordinates = EquatorialCoordinates & strTexts(intclsHBodyBase + 20 * intNLanguages + intLanguage) & " "
            'EquatorialCoordinates = EquatorialCoordinates & "Declination "
            EquatorialCoordinates = EquatorialCoordinates & strAngle(udtHBody.DeclTopo, blnValid, CShort(lngPrecision)) & vbCrLf
        End If
        Exit Function
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            blnValid = False
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Function
    Friend Function HorizonCoordinates(ByVal strHBody As String, ByRef blnValid As Boolean) As String
        'Return horizon coordinates as string
        Dim udtHBody As HBody
        Dim udtDms As DMS
        Dim cDMS As New clsDMS
        Dim cMoon As New clsMoon
        'Parameters for the Moon
        Dim dblAngle As Double 'Orientation of the crescent
        Dim dblSubtend As Double 'Angle subtended by the crescent
        Dim dblAltitude As Double 'Apparent altitude of the center of the lit portion
        Dim dblAzimuth As Double 'Topocentric azimuth of the center of the lit portion
        Dim dblLowH As Double 'First 'hour' on the clockface where the crescent starts
        Dim dblHighH As Double 'Last 'hour' on the clockface where the crescent ends

        On Error GoTo EH
        blnValid = True
        HorizonCoordinates = ""
        Call TrueHBody(frmMain.TranslateHBody(strHBody, False), dblDate + dblTime, udtHBody, blnValid)
        If Not blnValid Then Exit Function
        If intLanguage = 0 Then
            HorizonCoordinates = frmMain.TranslateHBody(strHBody, True, True, True) & strTexts(intclsHBodyBase + 29 * intNLanguages + intLanguage)
        Else
            HorizonCoordinates = strTexts(intclsHBodyBase + 29 * intNLanguages + intLanguage) & frmMain.TranslateHBody(strHBody, True, True, True)
        End If
        HorizonCoordinates = HorizonCoordinates & vbCrLf & strTexts(intclsHBodyBase + 30 * intNLanguages + intLanguage) & " " & strAngle(udtHBody.AzGeo, blnValid, CShort(lngPrecision)) & vbCrLf
        'Call cDMS.ToDMS(udtHBody.AzGeo, udtDms)
        'HorizonCoordinates = frmMain.TranslateHBody(strHBody, True, True, True) & strTexts(intclsHBodyBase + 29 * intNLanguages + intLanguage) & vbCrLf & strTexts(intclsHBodyBase + 30 * intNLanguages + intLanguage) & " " & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & VB6.Format(udtDms.dblSeconds, strFormat(lngPrecision)) & """"
        'HorizonCoordinates = strHBody & "'s geocentric horizon coordinates" & vbCrLf & "Azimuth " & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & VB6.Format(udtDms.dblSeconds, strFormat(lngPrecision)) & """"
        HorizonCoordinates = HorizonCoordinates & strTexts(intclsHBodyBase + 31 * intNLanguages + intLanguage) & " "
        'HorizonCoordinates = HorizonCoordinates & " Altitude "
        HorizonCoordinates = HorizonCoordinates & strAngle(udtHBody.AltGeo, blnValid, CShort(lngPrecision)) & vbCrLf
        If udtHBody.DistanceGeo < 10000000000.0# Then
            If intLanguage = 0 Then
                HorizonCoordinates = HorizonCoordinates & frmMain.TranslateHBody(strHBody, True, True, True) & strTexts(intclsHBodyBase + 62 * intNLanguages + intLanguage)
            Else
                HorizonCoordinates = HorizonCoordinates & strTexts(intclsHBodyBase + 62 * intNLanguages + intLanguage) & frmMain.TranslateHBody(strHBody, True, True, True)
            End If
            HorizonCoordinates = HorizonCoordinates & vbCrLf & strTexts(intclsHBodyBase + 30 * intNLanguages + intLanguage) & " " & strAngle(udtHBody.AzTopo, blnValid, CShort(lngPrecision)) & vbCrLf
            'HorizonCoordinates = HorizonCoordinates & strHBody & "'s topocentric horizon coordinates" & vbCrLf & "Azimuth " & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & VB6.Format(udtDms.dblSeconds, strFormat(lngPrecision)) & """"
            Call cDMS.ToDMS(udtHBody.AltTopo, udtDms)
            HorizonCoordinates = HorizonCoordinates & strTexts(intclsHBodyBase + 31 * intNLanguages + intLanguage) & " "
            'HorizonCoordinates = HorizonCoordinates & " Altitude "
            HorizonCoordinates = HorizonCoordinates & strAngle(udtHBody.AltTopo, blnValid, CShort(lngPrecision)) & vbCrLf
        End If
        If udtHBody.RefrValid Then
            HorizonCoordinates = HorizonCoordinates & strTexts(intclsHBodyBase + 33 * intNLanguages + intLanguage) & vbCrLf
            HorizonCoordinates = HorizonCoordinates & strTexts(intclsHBodyBase + 32 * intNLanguages + intLanguage) & " "
            If udtHBody.AltRefr >= 1 Then
                HorizonCoordinates = HorizonCoordinates & strAngle(udtHBody.AltRefr, blnValid, CShort(lngPrecision))
            Else 'The accuracy is less near the horizon
                HorizonCoordinates = HorizonCoordinates & strAngle(udtHBody.AltRefr, blnValid, CShort(lngPrecision - 1))
            End If
            If strHBody = "Moon" Then 'Give the oritenation and coordinates of the center of the lit portion
                Call cMoon.BrightLimb(dblDate + dblTime, dblAngle, dblSubtend, dblAltitude, dblAzimuth, blnValid, True)
                If Not blnValid Then Exit Function
                'Call cDMS.ToDMS(dblAzimuth, udtDms)
                HorizonCoordinates = HorizonCoordinates & vbCrLf & strTexts(intclsHBodyBase + 34 * intNLanguages + intLanguage) & vbCrLf & strTexts(intclsHBodyBase + 30 * intNLanguages + intLanguage) & " " & strAngle(dblAzimuth, blnValid, CShort(lngPrecision)) & vbCrLf & strTexts(intclsHBodyBase + 31 * intNLanguages + intLanguage) & " "
                'HorizonCoordinates = HorizonCoordinates & vbCrLf & "The center of the lit portion is at" & vbCrLf & "Azimuth " & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & VB6.Format(udtDms.dblSeconds, strFormat(lngPrecision)) & """" & vbCrLf & "Altitude "
                'Call cDMS.ToDMS(dblAltitude, udtDms)
                'If Not udtDms.blnSign Then HorizonCoordinates = HorizonCoordinates & "-"
                'HorizonCoordinates = HorizonCoordinates & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'"
                If dblAltitude >= 1 Then
                    HorizonCoordinates = HorizonCoordinates & strAngle(dblAltitude, blnValid, CShort(lngPrecision)) & vbCrLf
                Else 'The accuracy is less near the horizon
                    HorizonCoordinates = HorizonCoordinates & strAngle(dblAltitude, blnValid, CShort(lngPrecision) - 1) & vbCrLf
                End If
                dblLowH = dblMod(6 - (dblAngle + dblSubtend / 2) / 30, 12)
                dblHighH = dblMod(6 - (dblAngle - dblSubtend / 2) / 30, 12)
                HorizonCoordinates = HorizonCoordinates & strTexts(intclsHBodyBase + 35 * intNLanguages + intLanguage) & Int(dblLowH) & ":" & VB6.Format(Int(dblLowH * 60 + 0.5) Mod 60, "00") & " " & strTexts(intclsHBodyBase + 63 * intNLanguages + intLanguage) & Int(dblHighH) & ":" & VB6.Format(Int(dblHighH * 60 + 0.5) Mod 60, "00") & strTexts(intclsHBodyBase + 36 * intNLanguages + intLanguage) & " "
                'HorizonCoordinates = HorizonCoordinates & vbCrLf & "The Moon would cover " & Int(dblLowH) & ":" & VB6.Format(Int(dblLowH * 60 + 0.5) Mod 60, "00") & " to " & Int(dblHighH) & ":" & VB6.Format(Int(dblHighH * 60 + 0.5) Mod 60, "00") & " on the clockface."
            End If
        Else
            HorizonCoordinates = HorizonCoordinates & strTexts(intclsHBodyBase + intLanguage) & " " & frmMain.TranslateHBody(strHBody, True, True, True) & strTexts(intclsHBodyBase + 37 * intNLanguages + intLanguage) & " "
            'HorizonCoordinates = HorizonCoordinates & "The " & strHBody & " is well below the horizon so refraction cannot be calculated."
        End If
        Exit Function
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            blnValid = False
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Function
    Friend Function Rise(ByVal strHBody As String, ByRef blnValid As Boolean) As String
        'Return object rise for that day
        Dim dblRiseSetTime As Double 'Rise time
        Dim blnNeverSets As Boolean 'True if the object is always above the horizon
        Dim blnNeverRises As Boolean 'True if the object is always below the horizon
        Dim lngFix As Integer 'Day number
        Dim udtDateOut As MyDate
        Dim udtTimeOut As Mytime
        Dim strOldDate As String 'Last date used in this routine. If it changes between, for example, apparent to geometric rise then the date is writtern again otherwise it is omitted.
        Dim dbldayphase As Double 'Closest rise to what time

        On Error GoTo EH
        blnValid = True
        If strHBody = "Sun" Then
            dbldayphase = -90 'Force prior to midday, center on 06:00 mean solar time
        Else
            dbldayphase = 0 'Center on 12:00 mean solar time 
        End If
        Rise = ""
        strOldDate = ""
        lngFix = frmDate.ToLngDate(dblDate + dblTime, blnValid, False) 'Find day number
        If Not blnValid Then Exit Function
        'Find the geomretric rise time
        Call RiseSet(strHBody, lngFix, False, dblRiseSetTime, False, blnNeverRises, blnNeverSets, blnValid, 0, False, dbldayphase)
        If Not blnValid Then Exit Function
        If blnNeverSets Then
            Rise = strTexts(intclsHBodyBase + 38 * intNLanguages + intLanguage) & frmMain.TranslateHBody(strHBody, True, intLanguage > 0) & strTexts(intclsHBodyBase + 39 * intNLanguages + intLanguage) & vbCrLf & strTexts(intclsHBodyBase + 40 * intNLanguages + intLanguage)
            'Rise = "No geometric " & strHBody & "set" & vbCrLf & "Minimum altitude at "
        ElseIf blnNeverRises Then
            Rise = strTexts(intclsHBodyBase + 41 * intNLanguages + intLanguage) & frmMain.TranslateHBody(strHBody, True, intLanguage > 0) & strTexts(intclsHBodyBase + 42 * intNLanguages + intLanguage) & vbCrLf & strTexts(intclsHBodyBase + 43 * intNLanguages + intLanguage)
            'Rise = "No geometric " & strHBody & "rise" & vbCrLf & "Maximum altitude at "
        Else 'Write the geometric rise time
            Rise = strTexts(intclsHBodyBase + 44 * intNLanguages + intLanguage) & frmMain.TranslateHBody(strHBody, True, intLanguage > 0) & strTexts(intclsHBodyBase + 45 * intNLanguages + intLanguage)
            'Rise = "Geometric " & strHBody & "rise "
        End If
        'Find the apparent rise time over a level horizon
        Call frmMain.ToDateTime(CorrectTime(dblRiseSetTime, lngPrecision), udtDateOut, udtDate.enmDateType, udtTimeOut, udtTime.enmTimeType, blnValid, False)
        If Not blnValid Then Exit Function
        Rise = Rise & frmDate.WriteDateTime(udtDateOut, udtTimeOut, strOldDate, CShort(lngPrecision), False, False, False, True)
        If Not blnNeverSets Then
            Call RiseSet(strHBody, lngFix, False, dblRiseSetTime, True, blnNeverRises, blnNeverSets, blnValid, 0, False, dbldayphase)
            If Not blnValid Then Exit Function
            If blnNeverSets Then
                Rise = Rise & vbCrLf & strTexts(intclsHBodyBase + 46 * intNLanguages + intLanguage) & frmMain.TranslateHBody(strHBody, True, intLanguage > 0) & strTexts(intclsHBodyBase + 47 * intNLanguages + intLanguage) & vbCrLf & strTexts(intclsHBodyBase + 40 * intNLanguages + intLanguage)
                'Rise = Rise & vbCrLf & "No apparent " & strHBody & "set over flat horizon" & vbCrLf & "Minimum altitude at "
            ElseIf blnNeverRises Then
                Rise = Rise & vbCrLf & strTexts(intclsHBodyBase + 48 * intNLanguages + intLanguage) & frmMain.TranslateHBody(strHBody, True, intLanguage > 0) & strTexts(intclsHBodyBase + 49 * intNLanguages + intLanguage) & vbCrLf & strTexts(intclsHBodyBase + 43 * intNLanguages + intLanguage)
                'Rise = Rise & vbCrLf & "No apparent " & strHBody & "rise over flat horizon" & vbCrLf & "Maximum altitude at "
            Else 'Write the apparent rise time
                Rise = Rise & vbCrLf & strTexts(intclsHBodyBase + 50 * intNLanguages + intLanguage) & frmMain.TranslateHBody(strHBody, True, intLanguage > 0) & strTexts(intclsHBodyBase + 49 * intNLanguages + intLanguage)
                'Rise = Rise & vbCrLf & "Apparent " & strHBody & "rise over flat horizon "
            End If
            Call frmMain.ToDateTime(CorrectTime(dblRiseSetTime, lngPrecision - 1), udtDateOut, udtDate.enmDateType, udtTimeOut, udtTime.enmTimeType, blnValid, False)
            If Not blnValid Then Exit Function
            Rise = Rise & frmDate.WriteDateTime(udtDateOut, udtTimeOut, strOldDate, lngPrecision - 1, False, False, False, True)
            If Not blnNeverSets Then
                'Find the apparent rise time over the sea-level horizon
                Call RiseSet(strHBody, lngFix, False, dblRiseSetTime, True, blnNeverRises, blnNeverSets, blnValid, 0, True, dbldayphase)
                If Not blnValid Then Exit Function
                If blnNeverSets Then
                    Rise = Rise & vbCrLf & strTexts(intclsHBodyBase + 52 * intNLanguages + intLanguage) & frmMain.TranslateHBody(strHBody, True, intLanguage > 0) & strTexts(intclsHBodyBase + 53 * intNLanguages + intLanguage) & vbCrLf & strTexts(intclsHBodyBase + 40 * intNLanguages + intLanguage)
                    'Rise = Rise & vbCrLf & "No apparent " & strHBody & "set over sea level horizon" & vbCrLf & "Minimum altitude at "
                ElseIf blnNeverRises Then
                    Rise = Rise & vbCrLf & strTexts(intclsHBodyBase + 54 * intNLanguages + intLanguage) & frmMain.TranslateHBody(strHBody, True, intLanguage > 0) & strTexts(intclsHBodyBase + 55 * intNLanguages + intLanguage) & vbCrLf & strTexts(intclsHBodyBase + 43 * intNLanguages + intLanguage)
                    'Rise = Rise & vbCrLf & "No apparent " & strHBody & "rise over sea level horizon" & vbCrLf & "Maximum altitude at "
                Else 'Write the apparent rise time over the sea-level horizon
                    Rise = Rise & vbCrLf & strTexts(intclsHBodyBase + 56 * intNLanguages + intLanguage) & frmMain.TranslateHBody(strHBody, True, intLanguage > 0) & strTexts(intclsHBodyBase + 55 * intNLanguages + intLanguage)
                    'Rise = Rise & vbCrLf & "Apparent " & strHBody & "rise over sea level horizon "
                End If
                Call frmMain.ToDateTime(CorrectTime(dblRiseSetTime, lngPrecision - 1), udtDateOut, udtDate.enmDateType, udtTimeOut, udtTime.enmTimeType, blnValid, False)
                If Not blnValid Then Exit Function
                Rise = Rise & frmDate.WriteDateTime(udtDateOut, udtTimeOut, strOldDate, lngPrecision - 1, False, False, False, True)
            End If
        End If
        Exit Function
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            blnValid = False
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Function
    Friend Function HBSet(ByVal strHBody As String, ByRef blnValid As Boolean) As String
        'Return object set for that day
        Dim dblRiseSetTime As Double 'Rise time
        Dim blnNeverSets As Boolean 'True if the object is always above the horizon
        Dim blnNeverRises As Boolean 'True if the object is always below the horizon
        Dim lngFix As Integer 'Day number
        Dim udtDateOut As MyDate
        Dim udtTimeOut As Mytime
        Dim strOldDate As String 'Last date used in this routine. If it changes between, for example, apparent to geometric rise then the date is writtern again otherwise it is omitted.
        Dim dbldayphase As Double 'Closest rise to what time

        On Error GoTo EH
        blnValid = True
        If strHBody = "Sun" Then
            dbldayphase = 90 'Force after midday, center on 18:00 mean solar time
        Else
            dbldayphase = 0 'Center on 12:00 mean solar time
        End If
        strOldDate = ""
        blnValid = True
        lngFix = frmDate.ToLngDate(dblDate + dblTime, blnValid, False)
        HBSet = ""
        If Not blnValid Then Exit Function
        'Find the geomretric set time
        Call RiseSet(strHBody, lngFix, True, dblRiseSetTime, False, blnNeverRises, blnNeverSets, blnValid, 0, False, dbldayphase)
        If Not blnValid Then Exit Function
        If blnNeverSets Then
            HBSet = strTexts(intclsHBodyBase + 38 * intNLanguages + intLanguage) & frmMain.TranslateHBody(strHBody, True, intLanguage > 0) & strTexts(intclsHBodyBase + 39 * intNLanguages + intLanguage) & vbCrLf & strTexts(intclsHBodyBase + 40 * intNLanguages + intLanguage)
            'HBSet = "No geometric " & strHBody & "set" & vbCrLf & "Minimum altitude at "
        ElseIf blnNeverRises Then
            HBSet = strTexts(intclsHBodyBase + 41 * intNLanguages + intLanguage) & frmMain.TranslateHBody(strHBody, True, intLanguage > 0) & strTexts(intclsHBodyBase + 42 * intNLanguages + intLanguage) & vbCrLf & strTexts(intclsHBodyBase + 43 * intNLanguages + intLanguage)
            'HBSet = "No geometric " & strHBody & "rise" & vbCrLf & "Maximum altitude at "
        Else
            HBSet = strTexts(intclsHBodyBase + 58 * intNLanguages + intLanguage) & frmMain.TranslateHBody(strHBody, True, intLanguage > 0) & strTexts(intclsHBodyBase + 59 * intNLanguages + intLanguage)
            'HBSet = "Geometric " & strHBody & "set "
        End If
        Call frmMain.ToDateTime(CorrectTime(dblRiseSetTime, lngPrecision), udtDateOut, udtDate.enmDateType, udtTimeOut, udtTime.enmTimeType, blnValid, False)
        If Not blnValid Then Exit Function
        HBSet = HBSet & frmDate.WriteDateTime(udtDateOut, udtTimeOut, strOldDate, CShort(lngPrecision), False, False, False, True)
        If Not blnValid Then Exit Function
        If Not blnNeverSets Then
            'Find the apparent set time over a level horizon
            Call RiseSet(strHBody, lngFix, True, dblRiseSetTime, True, blnNeverRises, blnNeverSets, blnValid, 0, False, dbldayphase)
            If blnNeverSets Then
                HBSet = HBSet & vbCrLf & strTexts(intclsHBodyBase + 46 * intNLanguages + intLanguage) & frmMain.TranslateHBody(strHBody, True, intLanguage > 0) & strTexts(intclsHBodyBase + 47 * intNLanguages + intLanguage) & vbCrLf & strTexts(intclsHBodyBase + 40 * intNLanguages + intLanguage)
                'HBSet = HBSet & vbCrLf & "No apparent " & strHBody & "set over flat horizon" & vbCrLf & "Minimum altitude at "
            ElseIf blnNeverRises Then
                HBSet = HBSet & vbCrLf & strTexts(intclsHBodyBase + 48 * intNLanguages + intLanguage) & frmMain.TranslateHBody(strHBody, True, intLanguage > 0) & strTexts(intclsHBodyBase + 49 * intNLanguages + intLanguage) & vbCrLf & strTexts(intclsHBodyBase + 43 * intNLanguages + intLanguage)
                'HBSet = HBSet & vbCrLf & "No apparent " & strHBody & "rise over flat horizon" & vbCrLf & "Maximum altitude at "
            Else
                HBSet = HBSet & vbCrLf & strTexts(intclsHBodyBase + 60 * intNLanguages + intLanguage) & frmMain.TranslateHBody(strHBody, True, intLanguage > 0) & strTexts(intclsHBodyBase + 51 * intNLanguages + intLanguage)
                'HBSet = HBSet & vbCrLf & "Apparent " & strHBody & "set over flat horizon"
            End If
            Call frmMain.ToDateTime(CorrectTime(dblRiseSetTime, lngPrecision - 1), udtDateOut, udtDate.enmDateType, udtTimeOut, udtTime.enmTimeType, blnValid, False)
            If Not blnValid Then Exit Function
            HBSet = HBSet & frmDate.WriteDateTime(udtDateOut, udtTimeOut, strOldDate, lngPrecision - 1, False, False, False, True)
            If Not blnNeverSets And udtLocation.dblHeight >= 0 Then
                'Find the apparent set time over a sea-level horizon
                Call RiseSet(strHBody, lngFix, True, dblRiseSetTime, True, blnNeverRises, blnNeverSets, blnValid, 0, True, dbldayphase)
                If Not blnValid Then Exit Function
                If blnNeverSets Then
                    HBSet = HBSet & vbCrLf & strTexts(intclsHBodyBase + 52 * intNLanguages + intLanguage) & frmMain.TranslateHBody(strHBody, True, intLanguage > 0) & strTexts(intclsHBodyBase + 53 * intNLanguages + intLanguage) & vbCrLf & strTexts(intclsHBodyBase + 40 * intNLanguages + intLanguage)
                    'HBSet = HBSet & vbCrLf & "No apparent " & strHBody & "set over sea level horizon" & vbCrLf & "Minimum altitude at "
                ElseIf blnNeverRises Then
                    HBSet = HBSet & vbCrLf & strTexts(intclsHBodyBase + 54 * intNLanguages + intLanguage) & frmMain.TranslateHBody(strHBody, True, intLanguage > 0) & strTexts(intclsHBodyBase + 55 * intNLanguages + intLanguage) & vbCrLf & strTexts(intclsHBodyBase + 43 * intNLanguages + intLanguage)
                    'HBSet = HBSet & vbCrLf & "No apparent " & strHBody & "rise over sea level horizon" & vbCrLf & "Maximum altitude at "
                Else
                    HBSet = HBSet & vbCrLf & strTexts(intclsHBodyBase + 60 * intNLanguages + intLanguage) & frmMain.TranslateHBody(strHBody, True, intLanguage > 0) & strTexts(intclsHBodyBase + 57 * intNLanguages + intLanguage)
                    'HBSet = HBSet & vbCrLf & "Apparent " & strHBody & "set over sea level horizon"
                End If
                Call frmMain.ToDateTime(CorrectTime(dblRiseSetTime, lngPrecision - 1), udtDateOut, udtDate.enmDateType, udtTimeOut, udtTime.enmTimeType, blnValid, False)
                If Not blnValid Then Exit Function
                HBSet = HBSet & frmDate.WriteDateTime(udtDateOut, udtTimeOut, strOldDate, lngPrecision - 1, False, False, False, True)
            End If
        End If
        Exit Function
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            blnValid = False
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Function
    Friend Sub Visibility(ByVal strHBody As String, ByVal lngFix As Integer, _
        ByRef blnEvening As Boolean, ByRef dblQ As Double, ByRef dblT() As Double, _
        ByRef blnEasy As Boolean, ByRef blnNotVisible As Boolean, _
        ByRef dblProbVis As Double, ByRef blnValid As Boolean, _
        Optional ByRef blnPhotometric As Boolean = False, _
        Optional ByRef blnNeverRises As Boolean = False, _
        Optional ByRef blnNeverSets As Boolean = False)
        'Calculates when a heavenly body is first and last visible
        'StrHBody - Name of the heavently body in English
        'lngFix - Day number in fixed radix
        'blnEvening - True for evening apparition (ecliptic elongation less than 0 - 180 to the right looking North)
        'dblQ - Ease of visibility used for empirical calculations of lunar visibility
        'The result is returned in array dblT
        'dblT(0) = time of first possible visibility
        'dblt(1) = time of first definate visibility
        'dblT(2) = time of last definate visibility
        'dblt(3) = time of last possible visibility
        'dblT(4) = time of rising
        'dblT(5) = time of setting
        'For our purposes: Possible = 2.5% probability; Definate = 97.5% probability
        'blnEasy - True if the Moon is easier to see that empirical calculations can reliably predict
        'blnNotVisible - Not visible to the naked eye
        'dblProbVis - Maximum probability of visiblity
        'blnValid - False if there is a problem with the calculation
        'blnTopo
        'blnPhotometric - Use photometric rather than empirical parameters for lunar visiblity
        'blnNeverRises - Always below the horizon
        'blnByCriterion - Use the lunar visiblity criterion
        'blnNeverSets - Always above the horizon (circumpolar)

        Dim cSun As New clsSun
        Dim intI As Short 'Counter
        Dim dblP(4) As Double 'Probabilities
        Dim dblRise As Double 'Rise time
        Dim dblSet As Double 'Set time
        Dim intadd As Short 'Days to add to get the rise/set time into range
        Dim intHBody As Short 'Hbody number
        Dim dblLim As Double 'Convergence limit for probability
        Dim cMoon As New clsMoon
        Dim dblMeridianTime As Double 'Time at meridian
        Dim dblSunMeridian As Double 'True solar midday
        Dim dblDarkness As Double 'Darkness parameter for empirical lunar calculation
        Dim intMoonUp As Short 'Determines if the Moon is in the sky (required for the criterion routine but not used here)
        Dim intSunUp As Short 'Determines if the Sun is in the sky (required for the criterion routine but not used here)
        Dim dblBrightness As Double 'Brightness parameter for empirical lunar calculation
        Dim dblV As Double 'Combined visibility parameter
        Dim dblHS As Double 'Nominal height of Sun at a visibility event
        Dim udtMyCriterion As CriterionOptions 'Lunar visiblity criterion parameters
        Dim dblH As Double 'Height of Sun at a visibility event
        Dim dblBestTime As Double 'Time at which the lunar visibility criterion is applied

        On Error GoTo EH
        blnValid = True
        blnCancel = False
        Select Case intNIntegrals
            Case 16
                dblLim = 0.02
            Case 32
                dblLim = 0.01
            Case 64
                dblLim = 0.005
            Case 128
                dblLim = 0.001
            Case Else
                Err.Raise(vbObjectError + 1, "cHBody.Visibility", "intNIntegrals not valid: " & intNIntegrals)
        End Select
        If Not ValidstrHBody(strHBody) Then
            Err.Raise(vbObjectError + 1, "cHBody.Visibility", "strHBody not valid: " & strHBody)
        End If
        Select Case strHBody
            Case "Moon"
                intHBody = 1
            Case "Sun"
                intHBody = 0
            Case "Mercury"
                intHBody = 2
            Case "Venus"
                intHBody = 3
            Case "Mars"
                intHBody = 4
            Case "Jupiter"
                intHBody = 5
            Case "Saturn"
                intHBody = 6
            Case Else
                intHBody = 7
                While intHBody < 66 And strHBody <> udtStar(intHBody - 7).strName(0)
                    intHBody = intHBody + 1
                End While
        End Select
        If udtVisibilitySave(intHBody).blnUpdated And (intHBody <> 1 Or blnPhotometric = udtVisibilitySave(intHBody).blnPhotometric) And udtObserver.blnOverall = udtVisibilitySave(intHBody).blnOverall And udtObserver.dblLevel = udtVisibilitySave(intHBody).dblLevel Then
            For intI = 0 To 5
                dblT(intI) = udtVisibilitySave(intHBody).dblT(intI)
            Next
            dblQ = udtVisibilitySave(intHBody).dblQ
            blnEasy = udtVisibilitySave(intHBody).blnEasy
            blnNotVisible = udtVisibilitySave(intHBody).blnNotVisible
            dblProbVis = udtVisibilitySave(intHBody).dblProbVis
            blnEvening = udtVisibilitySave(intHBody).blnNew
            blnPhotometric = udtVisibilitySave(intHBody).blnPhotometric
            blnNeverRises = udtVisibilitySave(intHBody).blnNeverRises
            blnNeverSets = udtVisibilitySave(intHBody).blnNeverSets
        Else
            udtVisibilitySave(intHBody).blnUpdated = True
            blnChangedInput = False
            Call Meridian(strHBody, lngFix, 0, dblMeridianTime, blnValid)
            If Not blnValid Then Exit Sub
            intadd = Int(lngFix - udtLocation.dblLongitude / 360 - dblMeridianTime) + 1
            Call RiseSet(strHBody, lngFix + intadd, False, dblRise, True, blnNeverRises, blnNeverSets, blnValid, 0, True)
            If Not blnValid Then Exit Sub
            Call RiseSet(strHBody, lngFix + intadd, True, dblSet, True, blnNeverRises, blnNeverSets, blnValid, 0, True)
            If Not blnValid Then Exit Sub
            If dblSet <= dblRise And (dblRise + dblSet) / 2 > dblMeridianTime Then
                intadd = intadd - 1
                Call RiseSet(strHBody, lngFix + intadd, False, dblRise, True, blnNeverRises, blnNeverSets, blnValid, 0, True)
                If Not blnValid Then Exit Sub
                If dblSet - dblRise > 1.8 Then 'Unusual case where a day is skipped when the object does not set
                    Call RiseSet(strHBody, lngFix + intadd, True, dblRise, True, blnNeverRises, blnNeverSets, blnValid, 0, True)
                    If Not blnValid Then Exit Sub
                End If
            ElseIf dblSet <= dblRise And (dblRise + dblSet) / 2 <= dblMeridianTime Then
                intadd = intadd + 1
                Call RiseSet(strHBody, lngFix + intadd, True, dblSet, True, blnNeverRises, blnNeverSets, blnValid, 0, True)
                If Not blnValid Then Exit Sub
                If dblSet - dblRise > 1.8 Then 'Unusual case where a day is skipped when the object does not set
                    Call RiseSet(strHBody, lngFix + intadd, False, dblRise, True, blnNeverRises, blnNeverSets, blnValid, 0, True)
                    If Not blnValid Then Exit Sub
                End If
            End If
            If blnNeverSets Then 'circumpolar
                If strHBody = "Sun" Then
                    Call Meridian(strHBody, lngFix, -180, dblRise, blnValid)
                    Call Meridian(strHBody, lngFix, 180, dblSet, blnValid)
                Else
                    Call Meridian("Sun", lngFix, 0, dblSunMeridian, blnValid)
                    blnEvening = (dblSet + dblRise) / 2 > dblSunMeridian
                    If blnEvening Then
                        dblRise = dblSunMeridian
                        Call Meridian("Sun", lngFix + 1, 0, dblSunMeridian, blnValid)
                        dblSet = dblSunMeridian
                    Else
                        dblSet = dblSunMeridian
                        Call Meridian("Sun", lngFix - 1, 0, dblSunMeridian, blnValid)
                        dblRise = dblSunMeridian
                    End If
                End If
            End If
            If blnNeverRises Then 'Not visible if it does not rise
                blnNotVisible = True
                blnEasy = False
                dblProbVis = 0
            End If
            If Not blnNeverRises And Not blnPhotometric And strHBody = "Moon" Then
                'Empirical calculation for the Moon using a criterion
                'Set the criterion according to the options chosen in frmCriterion
                Call cMoon.SetCriterion(udtMyCriterion, blnValid)
                If Not blnValid Then Exit Sub
                'Is it a New (prior to full) or old (after full) Moon
                blnEvening = EveningSight("Moon", lngFix, blnValid)
                If Not blnValid Then Exit Sub
                'Caclulate the lunar visiblity using the criterion
                Call cMoon.Criterion(lngFix, dblDarkness, intMoonUp, intSunUp, dblBrightness, udtMyCriterion, dblV, dblQ, dblHS, dblBestTime, blnValid)
                If Not blnValid Then Exit Sub
                blnNotVisible = dblQ < 0 'Invisible
                blnEasy = dblQ > 5 'Too easy for the empirical calculation to be accurate for predicting the time of visiblity
                'Find the time of sunrise (old Moon) or sunset (New Moon)
                Call RiseSet("Sun", lngFix, blnEvening, dblT(0), True, blnNeverRises, blnNeverSets, blnValid, 0, False)
                If Not blnValid Then Exit Sub
                'Find the time of moonrise (old Moon) or sunset (New Moon)
                Call RiseSet("Moon", lngFix, blnEvening, dblT(1), True, blnNeverRises, blnNeverSets, blnValid, 0, False)
                If Not blnValid Then Exit Sub
                dblT(4) = dblT(0) * 0.4 + dblT(1) * 0.6 'Time of best visibility.
                'This is used for all criteria since it is the most accurate even though
                'other criteria assume different times of best visibility.
                'At this stage dblT(0) - sunrise/set
                '              dblT(1) - moonrise/set
                '              dblT(4) - time of best visiblity
                If blnNotVisible Then
                    'If not visible set all the times to that of the 'best visiblity'
                    'and the probability to 0
                    'The times of rising and setting have not been set yet
                    dblT(3) = dblT(4)
                    dblT(2) = dblT(3)
                    dblT(1) = dblT(2)
                    dblT(0) = dblT(1)
                    dblProbVis = 0
                Else
                    If udtObserver.blnOverall Then
                        dblH = dblHS + dblSDHS * 2 'Height of Sun when the Moon is first
                        'visible for New and last visible for old, i.e., higher limit of
                        'visibility
                    Else
                        'Setting the performance of the observer slightly improves the
                        'accuracy of the prediction (factor of 0.86) and displaces the
                        'prediction according to the observer's performance
                        dblH = dblHS + dblSDHS * (2 + udtObserver.dblLevel) * 0.86
                    End If
                    'Determine the time of the higher limit of visiblity
                    Call RiseSet("Sun", lngFix, blnEvening, dblT(0), False, blnNeverRises, blnNeverSets, blnValid, dblH, False)
                    If Not blnValid Then Exit Sub
                    If udtObserver.blnOverall Then
                        dblH = 3.04 - 0.75 * dblQ - 2 * 0.92 'Height of Moon at last visiblity for New and last visiblity of old, i.e., lower limit of visibility
                    Else
                        dblH = 3.04 - 0.75 * dblQ - 0.92 * (2 + udtObserver.dblLevel) * 0.86
                    End If
                    'Determine the time of the lower limit of visiblity
                    Call RiseSet("Moon", lngFix, blnEvening, dblT(3), False, blnNeverRises, blnNeverSets, blnValid, dblH, False)
                    If Not blnValid Then Exit Sub
                    If dblQ > 1 - MinProb Then 'Definitely visible - well, at least 97.5% likely
                        'Find the higher limit of visibility where the Moon is definitely (97.5% likely to be) visible
                        If udtObserver.blnOverall Then
                            dblH = dblHS - dblSDHS * 2 'Height of the Sun at higher limit
                            'of definite visiblity
                        Else
                            dblH = dblHS + dblSDHS * (-2 + udtObserver.dblLevel) * 0.86
                        End If
                        'Determine the time
                        Call RiseSet("Sun", lngFix, blnEvening, dblT(1), False, blnNeverRises, blnNeverSets, blnValid, dblH, False)
                        If Not blnValid Then Exit Sub
                        'Find the lower limit of definite visiblity
                        If udtObserver.blnOverall Then
                            dblH = 3.04 - 0.75 * dblQ + 2 * 0.92 'Moon's height at lower limit of definite visibility
                        Else
                            dblH = 3.04 - 0.75 * dblQ - 0.92 * (-2 + udtObserver.dblLevel) * 0.86
                        End If
                        'Determine the time
                        Call RiseSet("Moon", lngFix, blnEvening, dblT(2), False, blnNeverRises, blnNeverSets, blnValid, 3.04 - 0.75 * dblQ + 2 * 0.92, False)
                        If Not blnValid Then Exit Sub
                        dblProbVis = dblQ 'Visibility is certain
                        If dblProbVis > 1 Then dblProbVis = 1
                    Else
                        If System.Math.Abs(dblT(3) - dblT(4)) > System.Math.Abs(dblT(4) - dblT(0)) Then
                            'if the high apparition is closer to the best time than the last then this is wrong so make it the same time away from the best time
                            dblT(3) = 2 * dblT(4) - dblT(0)
                        End If
                        'If the high visiblity is after the low visibility then exchange
                        'This may happen when dblQ < 0.025
                        If dblT(3) < dblT(0) And blnEvening Or dblT(1) > dblT(0) And Not blnEvening Then
                            dblT(4) = dblT(3)
                            dblT(3) = dblT(0)
                            dblT(0) = dblT(4)
                        End If
                        'There is no certain visibility but set the certainty times so
                        'that they do not overlap
                        dblT(1) = dblT(3)
                        dblT(2) = dblT(0)
                        dblProbVis = dblQ
                    End If
                End If
                'If the Moon sets before (rises after for old Moon) 'lower visibility' fix that
                If blnEvening And dblT(3) > dblSet Then
                    dblT(3) = dblSet
                ElseIf Not blnEvening And dblT(3) < dblRise Then
                    dblT(3) = dblRise
                End If
                'If the Moon sets before (rises after for old Moon) 'lower definite visibility' fix that
                If blnEvening And dblT(2) > dblSet Then
                    dblT(2) = dblSet
                ElseIf Not blnEvening And dblT(2) < dblRise Then
                    dblT(2) = dblRise
                End If
                If Not blnEvening Then 'reverse first and last visibility for old Moon
                    dblT(4) = dblT(0) 'Use dblT(4) as workspace
                    dblT(0) = dblT(3)
                    dblT(3) = dblT(4)
                    dblT(4) = dblT(1)
                    dblT(1) = dblT(2)
                    dblT(2) = dblT(4)
                End If
                dblT(4) = dblRise
                dblT(5) = dblSet
            Else 'Photometric
                blnEasy = False
                If strHBody = "Sun" Then
                    blnEvening = True
                Else
                    blnEvening = EveningSight(strHBody, lngFix, blnValid)
                    If Not blnValid Then Exit Sub
                End If
                blnEasy = False 'Photometric methods can be used at any phase so the Moon is never 'too big'
                If Not blnNeverRises Then
                    frmProgress.Show()
                    frmProgress.lblMessage.Text = "Calculating " & strHBody & " 0%"
                    frmProgress.Refresh()
                    frmProgress.Activate()
                    dblP(2) = FindP(strHBody, dblRise, dblSet, 1.1, blnValid, dblLim, dblT(2)) 'Highest probability                    frmProgress.lblMessage = "Calculating " & strHBody & " 20%"
                    If Not blnValid Then Exit Sub
                    frmProgress.lblMessage.Text = "Calculating " & strHBody & " 20%"
                    frmProgress.Refresh()
                    frmProgress.Activate()
                    dblProbVis = dblP(2)
                    If dblP(2) < MinProb Then ''Impossible to see' so set everything to the 'best visiblity'
                        dblP(0) = dblP(2)
                        dblT(0) = dblT(2)
                        dblP(1) = dblP(2)
                        dblT(1) = dblT(2)
                        dblP(3) = dblP(2)
                        dblT(3) = dblT(2)
                        dblP(4) = dblP(2)
                        dblT(4) = dblT(2)
                        blnNotVisible = True
                    Else 'Visible to the eye
                        dblP(0) = HBProbVis(strHBody, dblRise, blnValid)
                        If Not blnValid Then Exit Sub
                        If dblP(0) < MinProb Then
                            dblP(0) = FindP(strHBody, dblRise, dblT(2), MinProb, blnValid, dblLim, dblT(0)) 'First chance of seeing
                            If Not blnValid Then Exit Sub
                        Else
                            dblT(0) = dblRise
                        End If
                        frmProgress.lblMessage.Text = "Calculating " & strHBody & " 40%"
                        frmProgress.Refresh()
                        frmProgress.Activate()
                        dblP(4) = HBProbVis(strHBody, dblSet, blnValid) 'For the time being use dblT(4) as last visiblity
                        If Not blnValid Then Exit Sub
                        If dblP(4) < MinProb Then
                            dblP(4) = FindP(strHBody, dblT(2), dblSet, MinProb, blnValid, dblLim, dblT(4)) 'Last chance of seeing
                            If Not blnValid Then Exit Sub
                        Else
                            dblT(4) = dblSet
                        End If
                        frmProgress.lblMessage.Text = "Calculating " & strHBody & " 60%"
                        frmProgress.Refresh()
                        frmProgress.Activate()
                        If dblP(2) < 1 - MinProb Then 'Set certain visiblity to not overlap
                            dblP(1) = dblP(4)
                            dblT(1) = dblT(4)
                            dblP(3) = dblP(0) 'For the time being use dblT(3) as last certain visiblity
                            dblT(3) = dblT(0)
                        Else
                            dblP(1) = HBProbVis(strHBody, dblRise, blnValid)
                            If Not blnValid Then Exit Sub
                            If dblP(1) > 1 - MinProb Then
                                dblT(1) = dblRise
                            Else
                                dblP(1) = FindP(strHBody, dblT(0), dblT(2), 1 - MinProb, blnValid, dblLim, dblT(1)) 'First certainty of seeing
                                If Not blnValid Then Exit Sub
                            End If
                            frmProgress.lblMessage.Text = "Calculating " & strHBody & " 80%"
                            frmProgress.Refresh()
                            frmProgress.Activate()
                            dblP(3) = HBProbVis(strHBody, dblSet, blnValid)
                            If Not blnValid Then Exit Sub
                            If dblP(3) > 1 - MinProb Then
                                dblT(3) = dblSet
                            Else
                                dblP(3) = FindP(strHBody, dblT(2), dblT(4), 1 - MinProb, blnValid, dblLim, dblT(3)) 'Last certainty of seeing
                                If Not blnValid Then Exit Sub
                            End If
                            frmProgress.lblMessage.Text = "Calculating " & strHBody & " 100%"
                            frmProgress.Refresh()
                            frmProgress.Activate()
                        End If
                        'dblT(2) is no longer needed as maximum visibility so move last certain to dblT(2) and last visible to dblT(3)
                        dblT(2) = dblT(3)
                        dblT(3) = dblT(4)
                    End If
                    'Store the rise and set times
                    dblT(4) = dblRise
                    dblT(5) = dblSet
                    frmProgress.Hide()
                End If
            End If
            udtVisibilitySave(intHBody).lngFix = lngFix
            ReDim udtVisibilitySave(intHBody).dblT(5)
            For intI = 0 To 5
                udtVisibilitySave(intHBody).dblT(intI) = dblT(intI)
            Next
            udtVisibilitySave(intHBody).dblQ = dblQ
            udtVisibilitySave(intHBody).blnEasy = blnEasy
            udtVisibilitySave(intHBody).blnNotVisible = blnNotVisible
            udtVisibilitySave(intHBody).blnOverall = udtObserver.blnOverall
            udtVisibilitySave(intHBody).dblLevel = udtObserver.dblLevel
            udtVisibilitySave(intHBody).dblProbVis = dblProbVis
            udtVisibilitySave(intHBody).blnNew = blnEvening
            udtVisibilitySave(intHBody).blnPhotometric = blnPhotometric
            udtVisibilitySave(intHBody).blnNeverRises = blnNeverRises
            udtVisibilitySave(intHBody).blnNeverSets = blnNeverSets
        End If
        Exit Sub
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            blnValid = False
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Sub
    Function FindP(ByVal strHBody As String, ByVal dblTMin As Double, ByVal dblTMax As Double, ByVal dblPTarget As Double, ByRef blnValid As Boolean, Optional ByVal dblLim As Double = 0.001, Optional ByRef dblFindT As Double = 0) As Double
        'Find the time when a heavenly body reaches a certain probability of visiblity
        Dim dblP(4) As Double 'Probabilities
        Dim dblT(4) As Double 'Times 0 rise, 2 best visbility, 4 set
        Dim intI As Short 'Counter
        Dim blnEvening As Boolean 'Evening sighting?
        Dim dblSunRiseSet As Double 'Time of sunrise/set
        Dim intadd As Short 'Days to add to get the correct sunrise/set
        Dim lngFix As Integer 'Radix date
        Dim udtHBody As HBody
        Dim blnNeverRises As Boolean 'Always below the horizon
        Dim blnNeverSets As Boolean ' Circumpolar

        On Error GoTo EH
        blnValid = True
        lngFix = frmDate.ToLngDate((dblTMin + dblTMax) / 2, blnValid, False) 'Radix day number
        If Not blnValid Then Exit Function
        If dblPTarget > 1 Then 'find maximum
            dblT(0) = dblTMin 'Rise
            dblT(4) = dblTMax 'Set
            If strHBody = "Sun" Then 'Set the mid point to midday because the probability is so close to 1 the time of maximum cannot be calculated any better
                dblT(2) = (dblTMax + dblTMin) / 2
            Else
                blnEvening = EveningSight(strHBody, lngFix, blnValid) 'Determinine if in evening
                If Not blnValid Then Exit Function
                'Find the closest sunset if in evening or sunrise if in morning
                Call RiseSet("Sun", lngFix, blnEvening, dblSunRiseSet, False, blnNeverRises, blnNeverSets, blnValid)
                If Not blnValid Then Exit Function
                'calculate Sunrise or Sunset
                'If it is the wrong day, select the correct day
                intadd = 0
                While dblSunRiseSet > (dblTMin + dblTMax) / 2 + 1
                    intadd = intadd - 1
                    Call RiseSet("Sun", lngFix + intadd, blnEvening, dblSunRiseSet, False, blnNeverRises, blnNeverSets, blnValid)
                    If Not blnValid Then Exit Function
                End While
                While dblSunRiseSet < (dblTMin + dblTMax) / 2 - 1
                    intadd = intadd + 1
                    Call RiseSet("Sun", lngFix + intadd, blnEvening, dblSunRiseSet, False, blnNeverRises, blnNeverSets, blnValid)
                    If Not blnValid Then Exit Function
                End While
                'Find the first approximation to best visibility/ideal time
                If blnEvening Then 'Set 0.6 from Sunset to object set
                    dblT(2) = (2 * dblSunRiseSet + 3 * dblTMax) / 5
                Else 'Set 0.4 from object rise to Sunrise
                    dblT(2) = (2 * dblSunRiseSet + 3 * dblTMin) / 5
                End If
                Call TrueHBody(strHBody, dblT(2), udtHBody, blnValid) 'Find the position at trial optimum time
                If Not blnValid Then Exit Function
                'If udtHBody.AltTopo < 3 Then 'If it is too low on the horizon
                'Call RiseSet(strHBody, lngFix + intadd, blnEvening, dblT(2), False, blnNeverRises, blnNeverSets, blnValid, 3)
                'If Not blnValid Then Exit Function
                'Find out when it is high enough
                'If not on the correct day, find the correct day
                'While dblT(2) > dblTMax
                'intadd = intadd - 1
                'Call RiseSet(strHBody, lngFix + intadd, blnEvening, dblT(2), False, blnNeverRises, blnNeverSets, blnValid, 3)
                'If Not blnValid Then Exit Function
                'End While
                'While dblT(2) < dblTMin
                'intadd = intadd + 1
                'Call RiseSet(strHBody, lngFix + intadd, blnEvening, dblT(2), False, blnNeverRises, blnNeverSets, blnValid, 3)
                'If Not blnValid Then Exit Function
                'End While
                'If the trial optimum is outside the time period then put it in the middle of the period
                'If dblT(2) > dblTMax Then
                'dblT(2) = (dblTMin + dblTMax) / 2
                'End If
                'End If
            End If
            'Calculate the probabilities
            dblP(0) = HBProbVis(strHBody, dblT(0), blnValid)
            If Not blnValid Then Exit Function
            dblP(2) = HBProbVis(strHBody, dblT(2), blnValid)
            If Not blnValid Then Exit Function
            dblP(4) = HBProbVis(strHBody, dblT(4), blnValid)
            If Not blnValid Then Exit Function
            'Binary search iteration
            While dblP(2) - dblP(0) > dblLim Or dblP(2) - dblP(4) > dblLim 'Till no significant change
                'Calculate the mid times between 0 and 2, 2 and 4
                dblT(1) = (dblT(0) + dblT(2)) / 2
                dblP(1) = HBProbVis(strHBody, dblT(1), blnValid)
                If Not blnValid Then Exit Function
                dblT(3) = (dblT(2) + dblT(4)) / 2
                dblP(3) = HBProbVis(strHBody, dblT(3), blnValid)
                If Not blnValid Then Exit Function
                If dblP(2) >= dblP(0) And dblP(2) >= dblP(1) And dblP(2) >= dblP(3) And dblP(2) >= dblP(4) Then
                    'dblp(2) largest
                    dblT(0) = dblT(1)
                    dblP(0) = dblP(1)
                    dblT(4) = dblT(3)
                    dblP(4) = dblP(3)
                ElseIf dblP(1) >= dblP(0) And dblP(1) >= dblP(2) And dblP(1) >= dblP(3) And dblP(1) >= dblP(4) Then
                    'dblp(1) largest
                    dblT(4) = dblT(2)
                    dblP(4) = dblP(2)
                    dblT(2) = dblT(1)
                    dblP(2) = dblP(1)
                ElseIf dblP(3) >= dblP(0) And dblP(3) >= dblP(1) And dblP(3) >= dblP(2) And dblP(3) >= dblP(4) Then
                    'dblp(3) largest
                    dblT(0) = dblT(2)
                    dblP(0) = dblP(2)
                    dblT(2) = dblT(3)
                    dblP(2) = dblP(3)
                ElseIf dblP(0) >= dblP(1) And dblP(0) >= dblP(2) And dblP(0) >= dblP(3) And dblP(0) >= dblP(4) Then
                    'dblp(0) largest
                    dblT(4) = dblT(2)
                    dblP(4) = dblP(2)
                    dblT(2) = dblT(1)
                    dblP(2) = dblP(1)
                Else
                    'dblp(4) largest
                    dblT(0) = dblT(2)
                    dblP(0) = dblP(2)
                    dblT(2) = dblT(3)
                    dblP(2) = dblP(3)
                End If
            End While
            FindP = dblP(2)
            dblFindT = dblT(2)
        Else 'Find a crossing point
            'Evaluate extremes
            dblT(0) = dblTMin
            dblT(2) = dblTMax
            dblP(0) = HBProbVis(strHBody, dblT(0), blnValid)
            If Not blnValid Then Exit Function
            dblP(2) = HBProbVis(strHBody, dblT(2), blnValid)
            If Not blnValid Then Exit Function
            'Check if there is a crossing point
            If dblP(0) > dblPTarget And dblP(2) > dblPTarget Then
                'No crossing point, both higher, choose closest
                If dblP(0) > dblP(2) Then
                    FindP = dblP(2)
                    dblFindT = dblT(2)
                Else
                    FindP = dblP(0)
                    dblFindT = dblT(0)
                End If
            ElseIf dblP(0) < dblPTarget And dblP(2) < dblPTarget Then
                'No crossing point, both lower, choose closest
                If dblP(0) > dblP(2) Then
                    FindP = dblP(0)
                    dblFindT = dblT(0)
                Else
                    FindP = dblP(2)
                    dblFindT = dblT(2)
                End If
            Else 'There is a crossing point
                'Find probability at mid time
                dblT(1) = (dblTMin + dblTMax) / 2
                dblP(1) = HBProbVis(strHBody, dblT(1), blnValid)
                While System.Math.Abs(dblP(1) - dblPTarget) > dblLim And dblT(2) - dblT(0) > 0.0000001 'While the difference in probability and time is significant
                    If dblP(1) >= dblPTarget And dblP(0) < dblPTarget Or dblP(1) <= dblPTarget And dblP(0) > dblPTarget Then
                        'The crossover is in the 1st half so move the time down
                        dblT(2) = dblT(1)
                        dblP(2) = dblP(1)
                    Else
                        'he crossover is in the 2nd half move the time up
                        dblT(0) = dblT(1)
                        dblP(0) = dblP(1)
                    End If
                    'Find the probability in the middle of the new period
                    dblT(1) = (dblT(0) + dblT(2)) / 2
                    dblP(1) = HBProbVis(strHBody, dblT(1), blnValid)
                    If Not blnValid Then Exit Function
                End While
                'Finished - return the values
                FindP = dblP(1)
                dblFindT = dblT(1)
            End If
        End If
        Exit Function
EH:
        If Err.Number = vbObjectError + 1 Then
            MsgBox("Error in " & Err.Source & ", " & Err.Description)
            blnValid = False
        Else
            Debug.Print(VB6.TabLayout(Err.Number, Err.Description))
            Err.Raise(Err.Number)
        End If
    End Function
End Class